/* Created by EasyMotif $Revision: 1.1 $  */

/*
 *	Project:	Rot		Path:	/home/keidel/Brainstorm/Mind/test/rotlabel/
 *	Program-name:	Rot
 *	Designer:	J.Keidel		Version:	$Version$
 *	Description:	Demonstation of the WRotLabel
*/
/* 	Includes */

#include <Xm/XmAll.h>
#include <XMind.h>
#include <X11/xpm.h>
#include <math.h>

/*   PRIVATE INCLUDES   */
#include "WRotLabel.h"

/*   PRIVATE DEFINES   */


/*** PRIVATE HEADER DECLARATIONS ***/ 

	GC  	gc=NULL;
	int	inc = 1;
	int	left_deg=30;
	int	center_deg=0;
	int	right_deg=-30;
	int	add_val = 0;
	int	margin=1;
	XtIntervalId plottimer;
	int 	run=0;

/*** PRIVATE PROTOTYPES  ***/ 


/***  END   HEADER   ***/


/*	STATIC GLOBAL WIDGETS */

static Widget left;
static Widget plot_left;
static Widget center;
static Widget plot_center;
static Widget right;
static Widget plot_right;

/*	Prototypes */

static Widget DI1_Create (Widget parent );

/*	CALLBACKS */
static void quit_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void set_display_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void set_border_cb (Widget parent , XtPointer data , XmToggleButtonCallbackStruct *  cbs);
static void rotate_10_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void rotate_1_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void run_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void stop_cb (Widget parent , XtPointer data , XmPushButtonCallbackStruct *  cbs);
static void border_cb (Widget parent , int data , XmPushButtonCallbackStruct *  cbs);

/*	EVENT HANDLERS */
static void expose_ev (Widget parent, XtPointer clientData, XEvent *event, Boolean *continueToDispatch);

/*	FUNCTIONS */

static void plot_cross ( void ) ;
static void plot ( void ) ;


/*  FALLBACK RESOURCES */
 static String fallback_resources[] = { 
/***********************************************************
 *
 * Insert additional fallbacks
 *
 * Syntax:
 * "ResourceName*WidgetName.Resource:   Value",<NEWLINE>
 *
 * Example:
 * "MyProg*myButton.fontList:   6x10",
 *
 ***********************************************************/

"*USER.fontList: -*-courier-bold-r-*-*-24-*-*-*-*-*-*-*",
"*title:RotLabel Demonstration",

"ROt*Form1*help.background: PaleGreen",
  NULL 
};
/*************************************************************************** 
 ***************************************************************************
 *
 *  Functionname:	main
 *
 *  Input:			int argc; char *argv[]
 *
 *  Return:			int		
 *
 *
 ***************************************************************************
 ***************************************************************************/
int main(int argc,char **argv){
  XtAppContext app_context;
  Widget Toplevel, MainDialog;
  /* INITIALIZE THE TOPLEVEL */

	Toplevel = XtAppInitialize(&app_context, "ROt", NULL, 0, &argc, argv, fallback_resources, NULL, 0);

	  /* CREATE THE MAINDIALOG */

	MainDialog = DI1_Create(Toplevel);
  /* MANAGE AND REALIZE THE SHELL WIDGETS */

	XtManageChild(MainDialog);
	XtRealizeWidget(Toplevel);

  /* START THE MESSAGE-QUEUE */
	XtAppMainLoop(app_context);
	return 0;
}

/*************************************************************************** 
 * 
 * Funktionsname:	DI1_Create
 * 
 * 
 * Input:		Widget parent
 * 
 * Return:		Widget 
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

static Widget DI1_Create (Widget parent ){
  Arg args[40]; 
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget DI1;
  Widget Pulldown_Menubar;
Widget DI1_Ca1;
Widget DI1_Ca2;
Widget DI1_Ca2_Toggle1;
Widget DI1_Ca2_Toggle2;
Widget DI1_Ca3;
Widget DI1_Ca3_Ca4;
Widget DI1_Ca3_Ca5;
Widget DI1_Ca3_Ca6;
Widget DI1_Ca3_Ca7;
Widget DI1_Ca8;
Widget DI1_Ca8_Ca9;
Widget DI1_Ca8_Ca10;
Widget DI1_Ca8_Ca11;
Widget DI1_Ca8_Ca12;
Widget DI1_Ca8_Ca13;
Widget DI1_Tf1;
Widget F_left;
Widget F_center;
Widget F_right;

   /* Main Dialog */

	n = 0;
	 XtSetArg(args[n], XmNwidth, 904); n++;
	XtSetArg(args[n], XmNheight, 376); n++;
	XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
	XtSetArg(args[n], XmNnoResize, TRUE); n++;
	XtSetArg(args[n], XmNdefaultPosition, TRUE); n++;
	DI1 = XmCreateForm(parent, "Form1", args, n);

/*  PULLDOWN MENU */
	n = 0;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNy, 0); n++;
	Pulldown_Menubar = XmCreateMenuBar(DI1, "menuBar", args, n);
	XtManageChild(Pulldown_Menubar);

	n=0;
	tmpLabelString =  XmStringCreate("Quit", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca1 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_1", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca1);

	n=0;
	tmpLabelString =  XmStringCreate("display", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca2 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_2", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca2);
	{
	Widget DI1_Ca2_SubId;
	DI1_Ca2_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Cascade_2", NULL, 0);

	n=0;
#ifndef LESSTIFF
#endif
	 XtSetArg(args[n], XmNx, 0); n++;
	XtSetArg(args[n], XmNy, 0); n++;
	tmpLabelString = XmStringCreateLtoR("degree", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	XtSetArg(args[n], XmNwidth, 0); n++;
	XtSetArg(args[n], XmNheight, 0); n++;
	DI1_Ca2_Toggle1 = XmCreateToggleButton(DI1_Ca2_SubId, "To_1", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca2_Toggle1);

	n=0;
#ifndef LESSTIFF
#endif
	 XtSetArg(args[n], XmNx, 0); n++;
	XtSetArg(args[n], XmNy, 0); n++;
	tmpLabelString = XmStringCreateLtoR("border", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	XtSetArg(args[n], XmNwidth, 0); n++;
	XtSetArg(args[n], XmNheight, 0); n++;
	XtSetArg(args[n], XmNset, TRUE ); n++; 
	DI1_Ca2_Toggle2 = XmCreateToggleButton(DI1_Ca2_SubId, "To_2", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca2_Toggle2);
	XtVaSetValues(DI1_Ca2, XmNsubMenuId, DI1_Ca2_SubId, NULL);
	XtManageChild(DI1_Ca2);
	}

	n=0;
	tmpLabelString =  XmStringCreate("rotate", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca3 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_3", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca3);
	{
	Widget DI1_Ca3_SubId;
	DI1_Ca3_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Cascade_3", NULL, 0);

	n=0;
	tmpLabelString =  XmStringCreate("10 degree", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca3_Ca4 = XmCreatePushButton(DI1_Ca3_SubId, "Cascade_4", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca3_Ca4);

	n=0;
	tmpLabelString =  XmStringCreate("1 degree", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca3_Ca5 = XmCreatePushButton(DI1_Ca3_SubId, "Cascade_5", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca3_Ca5);

	n=0;
	tmpLabelString =  XmStringCreate("start", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca3_Ca6 = XmCreatePushButton(DI1_Ca3_SubId, "Cascade_6", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca3_Ca6);

	n=0;
	tmpLabelString =  XmStringCreate("stop", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca3_Ca7 = XmCreatePushButton(DI1_Ca3_SubId, "Cascade_7", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca3_Ca7);
	XtVaSetValues(DI1_Ca3, XmNsubMenuId, DI1_Ca3_SubId, NULL);
	XtManageChild(DI1_Ca3);
	}

	n=0;
	tmpLabelString =  XmStringCreate("border", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8 = XmCreateCascadeButton(Pulldown_Menubar, "Cascade_8", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8);
	{
	Widget DI1_Ca8_SubId;
	DI1_Ca8_SubId = XmCreatePulldownMenu(Pulldown_Menubar, "Cascade_8", NULL, 0);

	n=0;
	tmpLabelString =  XmStringCreate("1", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8_Ca9 = XmCreatePushButton(DI1_Ca8_SubId, "Cascade_9", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8_Ca9);

	n=0;
	tmpLabelString =  XmStringCreate("2", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8_Ca10 = XmCreatePushButton(DI1_Ca8_SubId, "Cascade_10", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8_Ca10);

	n=0;
	tmpLabelString =  XmStringCreate("3", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8_Ca11 = XmCreatePushButton(DI1_Ca8_SubId, "Cascade_11", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8_Ca11);

	n=0;
	tmpLabelString =  XmStringCreate("4", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8_Ca12 = XmCreatePushButton(DI1_Ca8_SubId, "Cascade_12", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8_Ca12);

	n=0;
	tmpLabelString =  XmStringCreate("5", XmFONTLIST_DEFAULT_TAG);
	XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
	DI1_Ca8_Ca13 = XmCreatePushButton(DI1_Ca8_SubId, "Cascade_13", args, n);
	XmStringFree(tmpLabelString);
	XtManageChild(DI1_Ca8_Ca13);
	XtVaSetValues(DI1_Ca8, XmNsubMenuId, DI1_Ca8_SubId, NULL);
	XtManageChild(DI1_Ca8);
	}

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM );n++;
#endif
	 XtSetArg(args[n], XmNx, 0); n++;
	XtSetArg(args[n], XmNy, 343); n++;
	XtSetArg(args[n], XmNwidth, 904); n++;
	XtSetArg(args[n], XmNeditable, FALSE ); n++;
	DI1_Tf1 = XmCreateTextField(DI1, "help", args, n);
	XtManageChild(DI1_Tf1);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 1); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
	F_left= XmCreateFrame(DI1, "frame", args, n);
	XtManageChild(F_left);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 1); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	left = XmCreateForm(F_left, "Form_3", args, n);
	XtManageChild(left);

	n=0;
	XtSetArg(args[n], XmNx, 150); n++;
	XtSetArg(args[n], XmNy, 150); n++;
	XtSetArg(args[n], XmNwidth, 34); n++;
	XtSetArg(args[n], XmNheight, 18); n++;
	plot_left = XtCreateWidget("USER", xwRotLabelWidgetClass, left, args, n);
	XtManageChild(plot_left);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 302); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
	F_center= XmCreateFrame(DI1, "frame", args, n);
	XtManageChild(F_center);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 302); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	center = XmCreateForm(F_center, "Form_4", args, n);
	XtManageChild(center);

	n=0;
	XtSetArg(args[n], XmNx, 150); n++;
	XtSetArg(args[n], XmNy, 150); n++;
	XtSetArg(args[n], XmNwidth, 44); n++;
	XtSetArg(args[n], XmNheight, 22); n++;
	plot_center = XtCreateWidget("USER", xwRotLabelWidgetClass, center, args, n);
	XtManageChild(plot_center);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 604); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	XtSetArg(args[n], XmNshadowType,XmSHADOW_ETCHED_OUT); n++;
	F_right= XmCreateFrame(DI1, "frame", args, n);
	XtManageChild(F_right);

	n=0;
#ifndef LESSTIFF
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF );n++;
	XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF );n++;
#endif
	 XtSetArg(args[n], XmNx, 604); n++;
	XtSetArg(args[n], XmNy, 35); n++;
	XtSetArg(args[n], XmNwidth, 300); n++;
	XtSetArg(args[n], XmNheight, 300); n++;
	right = XmCreateForm(F_right, "Form_5", args, n);
	XtManageChild(right);

	n=0;
	XtSetArg(args[n], XmNx, 150); n++;
	XtSetArg(args[n], XmNy, 150); n++;
	XtSetArg(args[n], XmNwidth, 27); n++;
	XtSetArg(args[n], XmNheight, 25); n++;
	plot_right = XtCreateWidget("USER", xwRotLabelWidgetClass, right, args, n);
	XtManageChild(plot_right);
	XtAddCallback(DI1_Ca1, XmNactivateCallback,(XtCallbackProc)quit_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca8_Ca9, XmNactivateCallback,(XtCallbackProc)border_cb,(XtPointer)1 );
	XtAddCallback(DI1_Ca8_Ca10, XmNactivateCallback,(XtCallbackProc)border_cb,(XtPointer)2 );
	XtAddCallback(DI1_Ca8_Ca11, XmNactivateCallback,(XtCallbackProc)border_cb,(XtPointer)3 );
	XtAddCallback(DI1_Ca8_Ca12, XmNactivateCallback,(XtCallbackProc)border_cb,(XtPointer)4 );
	XtAddCallback(DI1_Ca8_Ca13, XmNactivateCallback,(XtCallbackProc)border_cb,(XtPointer)5 );
	XtAddCallback(DI1_Ca3_Ca4, XmNactivateCallback,(XtCallbackProc)rotate_10_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca3_Ca5, XmNactivateCallback,(XtCallbackProc)rotate_1_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca3_Ca6, XmNactivateCallback,(XtCallbackProc)run_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca3_Ca7, XmNactivateCallback,(XtCallbackProc)stop_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca2_Toggle1, XmNvalueChangedCallback,(XtCallbackProc)set_display_cb,(XtPointer)NULL );
	XtAddCallback(DI1_Ca2_Toggle2, XmNvalueChangedCallback,(XtCallbackProc)set_border_cb,(XtPointer)NULL );
	XtAddEventHandler(right, ExposureMask, False, (XtEventHandler)expose_ev, (XtPointer)NULL);
/* DI1 FINIT-function */
n = 0;
XtSetArg(args[n], XmNstring , "left");n++;
XtSetArg(args[n], XwNmarginWidth ,1); n++;
XtSetArg(args[n], XwNrotation , 30);n++;
XtSetArg(args[n], XwNRotCenter,XmALIGNMENT_BEGINNING );n++;
XwSetRotValues(plot_left, args, n);

n = 0;
XtSetArg(args[n], XmNstring , "center");n++;
XtSetArg(args[n], XwNmarginWidth ,1); n++;
XtSetArg(args[n], XwNRotCenter,XmALIGNMENT_CENTER );n++;

XwSetRotValues(plot_center, args, n);

n = 0;
XtSetArg(args[n], XmNstring , "right");n++;
XtSetArg(args[n], XwNmarginWidth ,1); n++;
XtSetArg(args[n], XwNrotation , -30);n++;
XtSetArg(args[n], XwNRotCenter,XmALIGNMENT_END );n++;
XwSetRotValues(plot_right, args, n);	EAddQuickHelp (DI1_Tf1 , DI1_Ca2 , "change display mode");
	EAddQuickHelp (DI1_Tf1 , DI1_Ca3 , "rotate   the Label");
	EAddQuickHelp (DI1_Tf1 , DI1_Ca3_Ca6 , "Start continously rotation");
	EAddQuickHelp (DI1_Tf1 , DI1_Ca3_Ca7 , "Stop rotation");
	EAddQuickHelp (DI1_Tf1 , DI1_Ca8 , "select thickness of border");
	EAddQuickHelp (DI1_Tf1 , plot_left , "centered to left lower corner, rotated counterclockwise");
	EAddQuickHelp (DI1_Tf1 , plot_center , "centered to center of text, rotated counterclockwise (2 deg. increment)");
	EAddQuickHelp (DI1_Tf1 , plot_right , "centered lower right corner, rotated clockwise");
	XtManageChild(DI1);
	return DI1;
}

/*	CALLBACKS */
static void quit_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	MCloseDialog (parent);
}
static void set_display_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){

	if(cbs->set)
		add_val = 1;
	else
		add_val=0;
	plot (  );
}
static void set_border_cb (Widget parent, XtPointer data , XmToggleButtonCallbackStruct * cbs ){
   int border;
  Arg args[40]; 
  Cardinal n;

	if(cbs->set)
		border=margin;
	else
		border =0;

	n= 0;
	XtSetArg(args[n], XwNmarginWidth ,border); n++;
	XwSetRotValues(plot_left, args, n);
	n= 0;
	XtSetArg(args[n], XwNmarginWidth ,border); n++;
	XwSetRotValues(plot_right, args, n);
	n= 0;
	XtSetArg(args[n], XwNmarginWidth ,border); n++;
	XwSetRotValues(plot_center, args, n);

}
static void rotate_10_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

	inc = 10;
	plot (  );
}
static void rotate_1_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	inc = 1;
	plot (  );
}
static void run_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){

	run = True;
	plot();
}
static void stop_cb (Widget parent, XtPointer data , XmPushButtonCallbackStruct * cbs ){
	run=0;
}
static void border_cb (Widget parent, int data , XmPushButtonCallbackStruct *  cbs ){

	margin = data;

}

/*	EVENT HANDLERS */
static void expose_ev (Widget parent, XtPointer clientData, XEvent *event, Boolean *continueToDispatch) {
   XGCValues values;
  unsigned long mask = GCForeground  | GCLineWidth  ;
 
	if(!gc){
		values.line_width = 2;
 		values.foreground = MGetPixel("RED",left);
  		gc = XCreateGC(XtDisplay(left),XtWindow(left), mask, &values);
	}
	plot_cross();
}

/*	FUNCTIONS */
static void plot_cross ( void ) {

	XDrawLine(XtDisplay(left),XtWindow(left),gc ,0,150,300,150);	
	XDrawLine(XtDisplay(left),XtWindow(left),gc ,150,0,150,300);	
	XDrawLine(XtDisplay(right),XtWindow(right),gc ,0,150,300,150);	
	XDrawLine(XtDisplay(right),XtWindow(right),gc ,150,0,150,300);	
	XDrawLine(XtDisplay(center),XtWindow(center),gc ,0,150,300,150);	
	XDrawLine(XtDisplay(center),XtWindow(center),gc ,150,0,150,300);	

}
static void plot ( void ) {
  char text[40]="";
  Arg args[40]; 
  Cardinal n;

	left_deg += inc;
	center_deg += inc;
	right_deg -= inc;

	n = 0;
	if(add_val){
		sprintf(text,"Left %d",left_deg);
		XtSetArg(args[n], XmNstring , text);n++;
	}else {
		XtSetArg(args[n], XmNstring , "left");n++;
	}
	XtSetArg(args[n], XwNrotation , left_deg);n++;
	XwSetRotValues(plot_left, args, n);

	n = 0;
	if(add_val){
		sprintf(text,"Center %d",left_deg);
		XtSetArg(args[n], XmNstring , text);n++;
	}else {
		XtSetArg(args[n], XmNstring , "center");n++;
	}
	XtSetArg(args[n], XwNrotation , center_deg);n++;
	XwSetRotValues(plot_center, args, n);

	n = 0;
	if(add_val){
		sprintf(text,"Right %d",left_deg);
		XtSetArg(args[n], XmNstring , text);n++;
	}else {
		XtSetArg(args[n], XmNstring , "right");n++;
	}
	XtSetArg(args[n], XwNrotation , right_deg);n++;
	XwSetRotValues(plot_right, args, n);
	plot_cross();
	if(run)
		plottimer = XtAppAddTimeOut(XtWidgetToApplicationContext(right),
	    200 , (XtTimerCallbackProc)plot , NULL);

}
