/* Created by MIND V.3.0 (c), flux Software GmbH, 1993-99   */ 

/*************************************************************************** 
 *************************************************************************** 
 * 
 * Projekt:		Scollingtest
 * 
 * 
 * Dokumentation:	Test for ScrollingWidgetClass
 * 
 * Designer:		J.Keidel
 * 
 * Datum:		Fri Feb 23 09:41:29 2001
 * 
 ***************************************************************************
 ***************************************************************************/

/* INCLUDES */

#include <Xm/XmAll.h>
#include "XMind.h"
#include <X11/xpm.h>



/*** PRIVATE HEADER ***/ 


/*   PRIVATE INCLUDE   */
#include <math.h>
#include	<WScroll.h>

/*#include "/server/softy/include/psplot.h"*/
/*   PRIVATE DEFINES   */

static double base = 0.0;

int ncc=3;
int testnc = 0,testncv= 1;
int plotr = 0;
int rate=100;
int timer = 0;		/* 0 is timer, 1 is workproc */
XtIntervalId plottimer;
XtWorkProcId plotwork;
static  Dimension widt = 612,hig = 133;
/***  END   HEADER   ***/

/* PROTOTYPES */

static Widget WiScroll_Create(Widget parent);
static void formdest(Widget parent, XtPointer data, XmAnyCallbackStruct *cbs);
static void scrolldest(Widget parent, XtPointer data, XmAnyCallbackStruct *cbs);
static void reset_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void quit_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void stop_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void start_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz10(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz20(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz50(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz100(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void full_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void addtext_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void colorchange_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void ann_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void anndir_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void scal1_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void scal2_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void base0_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void base40_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void get_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void enablehistory_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void disablehistory_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void docopy_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void destroyit_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void createit_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void plus_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void minus_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
Boolean plotter(void);
static void expcb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs);
static void resicb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs);
int destrcb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs);
static void input_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs);
static void inputv_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs);
static void inputv2_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs);


/* STATIC GLOBAL WIDGETS */

static Widget WiScroll;
static Widget testscroll;
static Widget testscrollv;
static Widget testscrollv2;
static Widget WiScroll_PD_Menubar_history_copy;

/* FALLBACK RESOURCES */
static String fallback_resources[] = {
"SCollingtest*form1.menuBar*Quit.background:	firebrick3",
  NULL
};




/* FUNKTIONEN */

/*************************************************************************** 
 * 
 * Funktionsname:	main
 * 
 * 
 * Input:		int argc; char *argv[]
 * 
 * Return:		void
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

void main(int argc,char **argv)
{
  XtAppContext app_context;
  Widget Toplevel, MainDialog;

  XtSetLanguageProc(NULL, NULL, NULL);

  /* INITIALISIERE DEN TOPLEVEL */

  Toplevel = XtAppInitialize(&app_context, "SCollingtest", NULL, 0, &argc, argv, fallback_resources, NULL, 0);

  /* ERSTELLE DEN HAUPTDIALOG */

  MainDialog = WiScroll_Create(Toplevel);

  /* MANAGEN UND REALISIEREN DER SHELL WIDGETS */

  XtManageChild(MainDialog);
  XtRealizeWidget(Toplevel);

  /* STARTE DIE NACHRICHTEN-QUEUE */

  XtAppMainLoop(app_context);
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Main Dialog
 *  
 *  Input:		%I
 *
 *  Return:		%R
 *
 *  Documentation:	Test Dialog for scrolling widgets
 *
 *
 *  History:		%T
 *
 *
 ***************************************************************************
 ***************************************************************************/

static Widget WiScroll_Create(Widget parent)
{
  Arg args[40];
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget WiScroll_pushButton113;
  Widget PulldownMenu;
  Widget WiScroll_PD_Menubar_Quit;
  Widget WiScroll_PD_Menubar_STOP;
  Widget WiScroll_PD_Menubar_start;
  Widget WiScroll_PD_Menubar_rate;
  Widget WiScroll_PD_Menubar_rate_SubId;
  Widget WiScroll_PD_Menubar_rate_10hz;
  Widget WiScroll_PD_Menubar_rate_20hz;
  Widget WiScroll_PD_Menubar_rate_50hz;
  Widget WiScroll_PD_Menubar_rate_100hz;
  Widget WiScroll_PD_Menubar_rate_FULL;
  Widget WiScroll_PD_Menubar_text;
  Widget WiScroll_PD_Menubar_change;
  Widget WiScroll_PD_Menubar_change_SubId;
  Widget WiScroll_PD_Menubar_change_colors;
  Widget WiScroll_PD_Menubar_change_annotation;
  Widget WiScroll_PD_Menubar_change_annodir;
  Widget WiScroll_PD_Menubar_change_scal1;
  Widget WiScroll_PD_Menubar_change_scal2;
  Widget WiScroll_PD_Menubar_change_base0;
  Widget WiScroll_PD_Menubar_change_base40000;
  Widget WiScroll_PD_Menubar_getval;
  Widget WiScroll_PD_Menubar_history;
  Widget WiScroll_PD_Menubar_history_SubId;
  Widget WiScroll_PD_Menubar_history_ON;
  Widget WiScroll_PD_Menubar_history_OFF;
  Widget WiScroll_PD_Menubar_widget;
  Widget WiScroll_PD_Menubar_widget_SubId;
  Widget WiScroll_PD_Menubar_widget_destroy;
  Widget WiScroll_PD_Menubar_widget_create;
  Widget WiScroll_PD_Menubar_resize;
  Widget WiScroll_PD_Menubar_resize_SubId;
  Widget WiScroll_PD_Menubar_resize_plus;
  Widget WiScroll_PD_Menubar_resize_minus;
  /* Init-functions */



  n = 0;
  XtSetArg(args[n], XmNwidth, 566); n++;
  XtSetArg(args[n], XmNheight, 503); n++;
  WiScroll = XmCreateForm(parent, "form1", args, n);

  /*  CREATE PULLDOWN MENU */

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  PulldownMenu = XmCreateMenuBar(WiScroll, "menuBar", args, n);
  XtManageChild(PulldownMenu);


  n = 0;
  tmpLabelString =  XmStringCreate("Quit", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_Quit = XmCreateCascadeButton(PulldownMenu, "Quit", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_Quit);


  n = 0;
  tmpLabelString =  XmStringCreate("STOP", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_STOP = XmCreateCascadeButton(PulldownMenu, "cascadeButton4", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_STOP);


  n = 0;
  tmpLabelString =  XmStringCreate("start", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_start = XmCreateCascadeButton(PulldownMenu, "cascadeButton5", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_start);


  n = 0;
  tmpLabelString =  XmStringCreate("rate", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate = XmCreateCascadeButton(PulldownMenu, "cascadeButton6", args, n);
  XmStringFree(tmpLabelString);
  WiScroll_PD_Menubar_rate_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton6", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("10hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate_10hz = XmCreatePushButton(WiScroll_PD_Menubar_rate_SubId, "cascadeButton7", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_rate_10hz);


  n = 0;
  tmpLabelString =  XmStringCreate("20hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate_20hz = XmCreatePushButton(WiScroll_PD_Menubar_rate_SubId, "cascadeButton8", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_rate_20hz);


  n = 0;
  tmpLabelString =  XmStringCreate("50hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate_50hz = XmCreatePushButton(WiScroll_PD_Menubar_rate_SubId, "cascadeButton9", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_rate_50hz);


  n = 0;
  tmpLabelString =  XmStringCreate("100hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate_100hz = XmCreatePushButton(WiScroll_PD_Menubar_rate_SubId, "cascadeButton10", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_rate_100hz);


  n = 0;
  tmpLabelString =  XmStringCreate("FULL", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_rate_FULL = XmCreatePushButton(WiScroll_PD_Menubar_rate_SubId, "cascadeButton22", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_rate_FULL);

  XtVaSetValues(WiScroll_PD_Menubar_rate, XmNsubMenuId, WiScroll_PD_Menubar_rate_SubId, NULL);
  XtManageChild(WiScroll_PD_Menubar_rate);


  n = 0;
  tmpLabelString =  XmStringCreate("text", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_text = XmCreateCascadeButton(PulldownMenu, "cascadeButton11", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_text);


  n = 0;
  tmpLabelString =  XmStringCreate("change", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change = XmCreateCascadeButton(PulldownMenu, "cascadeButton12", args, n);
  XmStringFree(tmpLabelString);
  WiScroll_PD_Menubar_change_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton12", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("colors", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_colors = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton13", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_colors);


  n = 0;
  tmpLabelString =  XmStringCreate("annotation", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_annotation = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton14", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_annotation);


  n = 0;
  tmpLabelString =  XmStringCreate("annodir", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_annodir = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton15", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_annodir);


  n = 0;
  tmpLabelString =  XmStringCreate("scal 1", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_scal1 = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton18", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_scal1);


  n = 0;
  tmpLabelString =  XmStringCreate("scal 2", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_scal2 = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton19", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_scal2);


  n = 0;
  tmpLabelString =  XmStringCreate("base 0", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_base0 = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton20", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_base0);


  n = 0;
  tmpLabelString =  XmStringCreate("base 40000", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_change_base40000 = XmCreatePushButton(WiScroll_PD_Menubar_change_SubId, "cascadeButton21", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_change_base40000);

  XtVaSetValues(WiScroll_PD_Menubar_change, XmNsubMenuId, WiScroll_PD_Menubar_change_SubId, NULL);
  XtManageChild(WiScroll_PD_Menubar_change);


  n = 0;
  tmpLabelString =  XmStringCreate("getval", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_getval = XmCreateCascadeButton(PulldownMenu, "cascadeButton16", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_getval);


  n = 0;
  tmpLabelString =  XmStringCreate("history", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_history = XmCreateCascadeButton(PulldownMenu, "cascadeButton1", args, n);
  XmStringFree(tmpLabelString);
  WiScroll_PD_Menubar_history_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton1", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("ON", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_history_ON = XmCreatePushButton(WiScroll_PD_Menubar_history_SubId, "cascadeButton2", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_history_ON);


  n = 0;
  tmpLabelString =  XmStringCreate("OFF", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_history_OFF = XmCreatePushButton(WiScroll_PD_Menubar_history_SubId, "cascadeButton3", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_history_OFF);


  n = 0;
  tmpLabelString =  XmStringCreate("copy", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_history_copy = XmCreatePushButton(WiScroll_PD_Menubar_history_SubId, "cascadeButton17", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_history_copy);

  XtVaSetValues(WiScroll_PD_Menubar_history, XmNsubMenuId, WiScroll_PD_Menubar_history_SubId, NULL);
  XtManageChild(WiScroll_PD_Menubar_history);


  n = 0;
  tmpLabelString =  XmStringCreate("widget", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_widget = XmCreateCascadeButton(PulldownMenu, "cascadeButton23", args, n);
  XmStringFree(tmpLabelString);
  WiScroll_PD_Menubar_widget_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton23", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("destroy", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_widget_destroy = XmCreatePushButton(WiScroll_PD_Menubar_widget_SubId, "cascadeButton24", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_widget_destroy);


  n = 0;
  tmpLabelString =  XmStringCreate("create", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_widget_create = XmCreatePushButton(WiScroll_PD_Menubar_widget_SubId, "cascadeButton25", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_widget_create);

  XtVaSetValues(WiScroll_PD_Menubar_widget, XmNsubMenuId, WiScroll_PD_Menubar_widget_SubId, NULL);
  XtManageChild(WiScroll_PD_Menubar_widget);


  n = 0;
  tmpLabelString =  XmStringCreate("resize", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_resize = XmCreateCascadeButton(PulldownMenu, "cascadeButton26", args, n);
  XmStringFree(tmpLabelString);
  WiScroll_PD_Menubar_resize_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton26", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("plus", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_resize_plus = XmCreatePushButton(WiScroll_PD_Menubar_resize_SubId, "cascadeButton27", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_resize_plus);


  n = 0;
  tmpLabelString =  XmStringCreate("minus", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_PD_Menubar_resize_minus = XmCreatePushButton(WiScroll_PD_Menubar_resize_SubId, "cascadeButton28", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_PD_Menubar_resize_minus);

  XtVaSetValues(WiScroll_PD_Menubar_resize, XmNsubMenuId, WiScroll_PD_Menubar_resize_SubId, NULL);
  XtManageChild(WiScroll_PD_Menubar_resize);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 15); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 360); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 536); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 132); n++;
  testscroll = XtCreateWidget("WiScrollC", XwScrollWidgetClass, WiScroll, args, n);
  XtManageChild(testscroll);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 15); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 48); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 195); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 288); n++;
  testscrollv = XtCreateWidget("WiScrollA", XwScrollWidgetClass, WiScroll, args, n);
  XtManageChild(testscrollv);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 300); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 48); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 251); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 288); n++;
  testscrollv2 = XtCreateWidget("WiScrollB", XwScrollWidgetClass, WiScroll, args, n);
  XtManageChild(testscrollv2);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 224); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 72); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 56); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 36); n++;
  tmpLabelString = XmStringCreateLtoR("reset", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  WiScroll_pushButton113 = XmCreatePushButton(WiScroll, "pushButton1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(WiScroll_pushButton113);

  XtAddCallback(WiScroll, XmNdestroyCallback, (XtCallbackProc) formdest, (XtPointer)NULL);
  XtAddCallback(testscrollv, XmNdestroyCallback, (XtCallbackProc) scrolldest, (XtPointer)NULL);
  XtAddCallback(WiScroll_pushButton113, XmNactivateCallback, (XtCallbackProc) reset_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_Quit, XmNactivateCallback, (XtCallbackProc) quit_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_STOP, XmNactivateCallback, (XtCallbackProc) stop_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_start, XmNactivateCallback, (XtCallbackProc) start_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_rate_10hz, XmNactivateCallback, (XtCallbackProc) hz10, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_rate_20hz, XmNactivateCallback, (XtCallbackProc) hz20, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_rate_50hz, XmNactivateCallback, (XtCallbackProc) hz50, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_rate_100hz, XmNactivateCallback, (XtCallbackProc) hz100, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_rate_FULL, XmNactivateCallback, (XtCallbackProc) full_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_text, XmNactivateCallback, (XtCallbackProc) addtext_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_colors, XmNactivateCallback, (XtCallbackProc) colorchange_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_annotation, XmNactivateCallback, (XtCallbackProc) ann_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_annodir, XmNactivateCallback, (XtCallbackProc) anndir_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_scal1, XmNactivateCallback, (XtCallbackProc) scal1_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_scal2, XmNactivateCallback, (XtCallbackProc) scal2_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_base0, XmNactivateCallback, (XtCallbackProc) base0_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_change_base40000, XmNactivateCallback, (XtCallbackProc) base40_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_getval, XmNactivateCallback, (XtCallbackProc) get_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_history_ON, XmNactivateCallback, (XtCallbackProc) enablehistory_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_history_OFF, XmNactivateCallback, (XtCallbackProc) disablehistory_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_history_copy, XmNactivateCallback, (XtCallbackProc) docopy_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_widget_destroy, XmNactivateCallback, (XtCallbackProc) destroyit_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_widget_create, XmNactivateCallback, (XtCallbackProc) createit_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_resize_plus, XmNactivateCallback, (XtCallbackProc) plus_cb, (XtPointer)NULL);
  XtAddCallback(WiScroll_PD_Menubar_resize_minus, XmNactivateCallback, (XtCallbackProc) minus_cb, (XtPointer)NULL);
  /* Finit-functions */
{
float scal[4] = {0,170.0,-2.,4};
float grid[4] = {0,10.,-2.,1.0};

   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscrollv,args,n);
XwScrollAddcurve( testscrollv ,MGetPixel("green",parent) );
  XtAddCallback(testscrollv, XmNinputCallback, (XtCallbackProc) inputv_cb, (XtPointer)NULL);


}


{
float scal[4] = {0,100.0,-2.,4};
float grid[4] = {0,10.,-2.,1.0};

   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscrollv2,args,n);
XwScrollAddcurve( testscrollv2 ,MGetPixel("goldenrod",parent) );
  XtAddCallback(testscrollv2, XmNinputCallback, (XtCallbackProc) inputv2_cb, (XtPointer)NULL);


}


{
float scal[4] = {0,170.0,-2.,4};
float grid[4] = {0,10.,-2.,0.5};

   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscroll,args,n);
  XtManageChild(testscroll);
XwScrollAddcurve( testscroll ,MGetPixel("blue",parent) );
XwScrollAddcurve( testscroll ,MGetPixel("firebrick",parent) );
XwScrollAddcurve( testscroll ,MGetPixel("white",parent) );
  XtAddCallback(testscroll, XmNinputCallback, (XtCallbackProc) input_cb, (XtPointer)NULL);

}
  return WiScroll;
}


static void  formdest(Widget parent,  XtPointer data,  XmAnyCallbackStruct *cbs)
{
printf("FORM\n");
}


static void  scrolldest(Widget parent,  XtPointer data,  XmAnyCallbackStruct *cbs)
{
printf("SCROLL\n");
}


static void  reset_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
float scal[4] = {0,100.0,-2.,4};
float grid[4] = {0,10.,-2.,1.0};
   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscroll,args,n);

if(--ncc <1)
ncc=3;

switch (ncc){
case 1:
	XwScrollSettext(testscroll , 0, "ein TEXT");
break;
case 2:
	XwScrollSettext(testscroll , 0, "zwei TEXT");
break;
case 3:
	XwScrollSettext(testscroll , 0, "drei TEXT");
}



}


static void  quit_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	MCloseDialog(parent);
}


static void  stop_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	if(timer && plotr)
		XtRemoveWorkProc (plotwork);
	plotr=0;
}


static void  start_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr=1;
	if(!timer)
		plotter();
	else
		plotwork = XtAppAddWorkProc( XtWidgetToApplicationContext(testscroll)
		, (XtWorkProc)plotter,NULL);
}


static void  hz10(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate = 100;
	timer = 0;
}


static void  hz20(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate=50;
	timer = 0;
}


static void  hz50(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate=20;
	timer = 0;
}


static void  hz100(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate=10;
	timer = 0;
}


static void  full_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	timer = 1;
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	addtext_cb
 *  
 *  Input:		Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs
 *
 *  Return:		void
 *
 *  Documentation:	adding descriptive text on per curve basis to scrolling widgets
 *
 *
 *  History:		Sun Mar 30 07:29:29 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void  addtext_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	XwScrollSettext(testscroll , 0, "NULL TEXT");
	XwScrollSettext(testscroll , 1, "eins");
	XwScrollSettext(testscroll , 2, "zwei");
	XwScrollSettext(testscrollv,0,"OTHER");
	XwScrollSettext(testscrollv2,0,"ParaMeter");
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	colorchange_cb
 *  
 *  Input:		Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs
 *
 *  Return:		void
 *
 *  Documentation:	disables global addvalue, changes number of decimals
 *			changes colours
 *
 *
 *  History:		Sun Mar 30 07:32:17 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void  colorchange_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
   n = 0;
XtSetArg(args[n],XwNscrollAddvalue, 0); n++;
XtSetArg(args[n],XwNscrollAnnotYNdec, 3); n++;
XtSetArg(args[n],XwNscrollAnnotXNdec, 1); n++;
XtSetArg(args[n], XwNscrollCUcolor, MGetPixel("blue",testscroll)); n++;
XtSetArg(args[n], XwNscrollGridColor, MGetPixel("orange",testscroll)); n++;
XtSetArg(args[n], XwNscrollAnnotColor, MGetPixel("red",testscroll)); n++;
XtSetValues(testscroll,args,n);
XwScrollchangecolor	(testscroll, 1 , MGetPixel("red",testscroll));
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	ann_cb
 *  
 *  Input:		Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs
 *
 *  Return:		void
 *
 *  Documentation:	changes number of decimals, switches to addvalue
 *			and rescales. switching different annotation position
 *
 *
 *  History:		Sun Mar 30 07:31:05 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void  ann_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
  float scal[4] = {0,100.0,-4.,8};
  float grid[4] = {0,10.,-4.,1};

  n = 0;
XtSetArg(args[n],XwNscrollAddvalue, FALSE); n++;
XtSetArg(args[n],XwNscrollAnnotYNdec, 1); n++;
XtSetArg(args[n],XwNscrollAnnotXNdec, 3); n++;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetArg(args[n],XwNscrollAnnotation,XwScrollRiAnno+XwScrollUpAnno);n++;
XtSetValues(testscroll,args,n);

}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	anndir_cb
 *  
 *  Input:		Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs
 *
 *  Return:		void
 *
 *  Documentation:	switches the scroll direction to vertical, changes annotation
 *			position
 *
 *
 *  History:		Sun Mar 30 07:30:11 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void  anndir_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

  n = 0;
XtSetArg(args[n],XwNscrollAnnotation, 1); n++;
XtSetArg(args[n],XwNscrolldirection, 1); n++;
XtSetValues(testscroll,args,n);

}


static void  scal1_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
float scal[4] = {500,170.0,-1.,2};
float grid[4] = {0,10.,-1.,0.5};
float scal1[4] = {500,170.0,-3.,6};
float grid1[4] = {0,10.,-3.,0.5};

   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscroll,args,n);
   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal1); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid1); n++;
XtSetValues(testscrollv,args,n);
   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal1); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid1); n++;
XtSetValues(testscrollv2,args,n);

}


static void  scal2_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
 Arg args[40];
  Cardinal n;
float scal[4] = {0,170.0,-4.,8};
float grid[4] = {0,10.,-4.,1.0};


   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscroll,args,n);
   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscrollv,args,n);
   n = 0;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
XtSetValues(testscrollv2,args,n);
memset(scal,0,sizeof(scal));
memset(grid,0,sizeof(grid));

}


static void  base0_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	base=0.0;
}


static void  base40_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	base=40000.0;
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	get_cb
 *  
 *  Input:		Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs
 *
 *  Return:		void
 *
 *  Documentation:	gets some resources and prints them
 *
 *
 *  History:		Sun Mar 30 07:33:28 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void  get_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
  float *scal;
  float *grid;
  int a,b,c;
  n = 0;
XFlush(XtDisplay(parent));
XtSetArg(args[n],XwNscrollAddvalue, &a); n++;
XtSetArg(args[n],XwNscrollAnnotYNdec, &b); n++;
XtSetArg(args[n],XwNscrollAnnotXNdec, &c); n++;
  XtSetArg(args[n],XwNscrollScale, &scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, &grid); n++;
XtGetValues(testscroll,args,n);

printf("%p %p\n",scal,grid);
printf(" %f %f %f %f\n",scal[0],scal[1],scal[2],scal[3]);
printf(" %f %f %f %f\n",grid[0],grid[1],grid[2],grid[3]);

printf("%d  %d  %d  \n",a,b,c);
}


static void  enablehistory_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
   n = 0;
XtSetArg(args[n],XwNscrollHistory ,TRUE); n++;
XtSetValues(testscroll,args,n);
XtSetValues(testscrollv,args,n);
XtSetValues(testscrollv2,args,n);
XtSetSensitive(WiScroll_PD_Menubar_history_copy,TRUE);

}


static void  disablehistory_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
   n = 0;
XtSetArg(args[n],XwNscrollHistory ,FALSE); n++;
XtSetValues(testscroll,args,n);
XtSetValues(testscrollv,args,n);
XtSetValues(testscrollv2,args,n);
XtSetSensitive(WiScroll_PD_Menubar_history_copy,FALSE);
}


static void  docopy_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
   float *x1 , *y1 , *x2,*y2,*x3,*y3;
   int npoints , i;
   char fl[50];
   static int n=0;
/* first test only */

/*	sprintf(fl,"curves%d.ps",n++);
	PS_Open(fl,PORTRAIT);
	XwScrollhistory (testscroll  ,0 ,  &x1 , &y1 , &npoints); 
	XwScrollhistory (testscroll  ,1 ,  &x2 , &y2 , &npoints); 
	XwScrollhistory (testscroll  ,2 ,  &x3 , &y3 , &npoints); 
	PS_define_plotarea(1,10.,10.,170.,80.);
	VPS_Curve(1,x2,y2,npoints,1,1+2+32+64,'A',4,0);
	VPS_Curve(1,x1,y1,npoints,1,1+2,'B',4,0);
	VPS_Curve(1,x3,y3,npoints,1,1+2,'C',4,0);
	VPS_scalgrid(1,128);
	free (x1);
	free(y1);
	free (x2);
	free(y2);
	free (x3);
	free(y3);
	XwScrollhistory (testscrollv  ,0 ,  &x1 , &y1 , &npoints); 
	PS_define_plotarea(2,10.,100.,80.,100.);
	VPS_Curve(2,y1,x1,npoints,1,1+2+32+64,'A',4,0);
	VPS_scalgrid(2,128);
	free (x1);
	free(y1);
	XwScrollhistory (testscrollv2  ,0 ,  &x1 , &y1 , &npoints); 
	PS_define_plotarea(3,100.,100.,80.,100.);
	VPS_Curve(3,y1,x1,npoints,1,1+2+32+64,'A',4,0);
	VPS_scalgrid(3,128);
	free (x1);
	free(y1);
	PS_Close();		*/
}


static void  destroyit_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	XtDestroyWidget(testscroll);
}


static void  createit_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
  XmString tmpLabelString = NULL;
float scal[4] = {0,170.0,-2.,4};
float grid[4] = {0,10.,-2.,0.5};
  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 15); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 360); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 615); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 132); n++;
  XtSetArg(args[n],XwNscrollScale, scal); n++;
  XtSetArg(args[n],XwNscrollGridScale, grid); n++;
  testscroll = XtCreateWidget("WiScrollC", XwScrollWidgetClass, WiScroll, args, n);
   XtManageChild(testscroll);
XwScrollAddcurve( testscroll ,MGetPixel("blue",parent) );
XwScrollAddcurve( testscroll ,MGetPixel("firebrick",parent) );
XwScrollAddcurve( testscroll ,MGetPixel("white",parent) );
  XtAddCallback(testscroll, XmNinputCallback, (XtCallbackProc) input_cb, (XtPointer)NULL);

}


static void  plus_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  widt +=  widt /5;
  hig += hig /5;
XtResizeWidget(testscroll, widt, hig, 1);

}


static void  minus_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
 
 



 
  widt /= 2;
  hig /= 2;
 XtResizeWidget(testscroll, widt, hig, 1);

}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	plotter
 *  
 *  Input:		void
 *
 *  Return:		void
 *
 *  Documentation:	creates sines with different frequencies and pushes
 *			the data into the scrolling widgets
 *			does this continzozsly using timed event
 *
 *
 *  History:		Sun Mar 30 07:27:46 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

Boolean plotter(void) {
float xy[2] ,xy1[2];

	xy1[0]=xy[0] = 3.0 * base;

	xy[1] = sin(base);
	xy1[1] = 2*sin(3*base);
if(ncc>1)
	 XwScrollcurve (testscroll  , 1  ,   xy1 , 0);
	xy1[1] = sin(5*base);
if(ncc>2)
	 XwScrollcurve (testscroll  , 2  ,   xy1 , 0);
	 XwScrollcurve (testscroll  , 0  ,   xy , 1);
	 XwScrollcurve (testscrollv  , 0  ,   xy , 1);
	 XwScrollcurve (testscrollv2  , 0  ,   xy , 1);
	base += 0.07;
	if(plotr == 1 && !timer)
  		plottimer = XtAppAddTimeOut(XtWidgetToApplicationContext(testscroll),
	    rate , (XtTimerCallbackProc)plotter , NULL);
	else if (plotr == 1)
		return False;
	else
		return True;
}

static void expcb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs) 
{
	printf("EXPOSE: %d %d %f \n",cbs->width,cbs->height,cbs->value);
}
static void resicb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs) 
{

}

int destrcb(Widget parent, XtPointer data, XwScrollCallbackStruct *cbs) 
{

}

static void input_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs) {
printf("HOR button %d %d\n",cbs->event->xbutton.x,cbs->event->xbutton.y);
printf(" X-value= %f\n",cbs->value);
}

static void inputv_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs) {
printf("VERT 1 button %d %d\n",cbs->event->xbutton.x,cbs->event->xbutton.y);
printf(" X-value= %f\n",cbs->value);
printf("Y-vale  %f\n",XwScrollGetValue(parent,0,cbs->value));
}

static void inputv2_cb(Widget parent,  XtPointer data,  XwScrollCallbackStruct *cbs) {
printf("VERT 2 button %d %d\n",cbs->event->xbutton.x,cbs->event->xbutton.y);
printf(" X-value= %f\n",cbs->value);
}

