/* Created by MIND V.3.0 (c), flux Software GmbH, 1993-99   */ 

/*************************************************************************** 
 *************************************************************************** 
 * 
 * Projekt:		ezdrawtest
 * 
 * 
 * Dokumentation:	Test Program for Widget Ezdraw
 * 
 * Designer:		J.Keidel
 * 
 * Datum:		Fri Feb 23 09:36:51 2001
 * 
 ***************************************************************************
 ***************************************************************************/

/* INCLUDES */

#include <Xm/XmAll.h>
#include "XMind.h"
#include <X11/xpm.h>
#include <math.h>



/*** PRIVATE HEADER ***/ 


/*   PRIVATE INCLUDE   */

#include <WEzdraw.h>
/*   #include "/server/softy/include/psplot.h"  */

/*   PRIVATE DEFINES   */
static double base = 0 , radius=0.1;


int plotr = 0;
int rate=50;
int timer = 0;          /* 0 is timer, 1 is workproc */
XtIntervalId plottimer;
XtWorkProcId plotwork;

/***  END   HEADER   ***/

/* PROTOTYPES */

static Widget EZ_Create(Widget parent);
static void quit_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void start_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz10_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz20_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz50_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hz100_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void full_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void stop_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void clear_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void annleft_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void annleftup_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void annrigdo_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void anrighup_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void danceon_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void danceoff_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void texton_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void textoff_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void ctexton_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void ctextoff_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void scale10_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void scale20_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void hardcopy_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void destroy_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void recreate_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
Boolean plotter(void);
static void ezexp_cb(Widget parent, XtPointer data, XwEzdrawCallbackStruct *cbs);
static void input_cb(Widget parent,  XtPointer data,  XwEzdrawCallbackStruct *cbs);
static void ezres_cb(Widget parent, XtPointer data, XwEzdrawCallbackStruct *cbs);


/* STATIC GLOBAL WIDGETS */

static Widget EZ;
static Widget EZ_userWidget10;
static Widget EZ_userWidget23;
static Widget EZ_userWidget34;
static Widget EZ_userWidget45;

/* FALLBACK RESOURCES */
static String fallback_resources[] = {
"Ezdrawtest*form1.userWidget1.foreground: 	red",
"Ezdrawtest*form1.userWidget1.background: 	yellow",
"Ezdrawtest*form1.userWidget1.borderColor: 	black",
"Ezdrawtest*form1.userWidget1.borderWidth: 	2",
"Ezdrawtest*form1.userWidget2.foreground: 	DarkOrange3",
"Ezdrawtest*form1.userWidget2.background: 	aquamarine1",
  NULL
};




/* FUNKTIONEN */

/*************************************************************************** 
 * 
 * Funktionsname:	main
 * 
 * 
 * Input:		int argc; char *argv[]
 * 
 * Return:		void
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

void main(int argc,char **argv)
{
  XtAppContext app_context;
  Widget Toplevel, MainDialog;

  XtSetLanguageProc(NULL, NULL, NULL);

  /* INITIALISIERE DEN TOPLEVEL */

  Toplevel = XtAppInitialize(&app_context, "Ezdrawtest", NULL, 0, &argc, argv, fallback_resources, NULL, 0);

  /* ERSTELLE DEN HAUPTDIALOG */

  MainDialog = EZ_Create(Toplevel);

  /* MANAGEN UND REALISIEREN DER SHELL WIDGETS */

  XtManageChild(MainDialog);
  XtRealizeWidget(Toplevel);

  /* STARTE DIE NACHRICHTEN-QUEUE */

  XtAppMainLoop(app_context);
}


/*************************************************************************** 
 * 
 * Funktionsname:	EZ_Create
 * 
 * 
 * Input:		Widget parent
 * 
 * Return:		Widget main
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

static Widget EZ_Create(Widget parent)
{
  Arg args[40];
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget EZ_textField11;
  Widget PulldownMenu;
  Widget EZ_PD_Menubar_Quit;
  Widget EZ_PD_Menubar_start;
  Widget EZ_PD_Menubar_rate;
  Widget EZ_PD_Menubar_rate_SubId;
  Widget EZ_PD_Menubar_rate_10Hz;
  Widget EZ_PD_Menubar_rate_20Hz;
  Widget EZ_PD_Menubar_rate_50Hz;
  Widget EZ_PD_Menubar_rate_100Hz;
  Widget EZ_PD_Menubar_rate_FULL;
  Widget EZ_PD_Menubar_stop;
  Widget EZ_PD_Menubar_clear;
  Widget EZ_PD_Menubar_Annotation;
  Widget EZ_PD_Menubar_Annotation_SubId;
  Widget EZ_PD_Menubar_Annotation_Left;
  Widget EZ_PD_Menubar_Annotation_Right;
  Widget EZ_PD_Menubar_Annotation_Up;
  Widget EZ_PD_Menubar_Annotation_Down;
  Widget EZ_PD_Menubar_Dance;
  Widget EZ_PD_Menubar_Dance_SubId;
  Widget EZ_PD_Menubar_Dance_ON;
  Widget EZ_PD_Menubar_Dance_Off;
  Widget EZ_PD_Menubar_Dance_Texton;
  Widget EZ_PD_Menubar_Dance_Textoff;
  Widget EZ_PD_Menubar_Dance_Ctexton;
  Widget EZ_PD_Menubar_Dance_Ctextoff;
  Widget EZ_PD_Menubar_Scale;
  Widget EZ_PD_Menubar_Scale_SubId;
  Widget EZ_PD_Menubar_Scale_1010;
  Widget EZ_PD_Menubar_Scale_2020;
  Widget EZ_PD_Menubar_hardcopy;
  Widget EZ_PD_Menubar_widget;
  Widget EZ_PD_Menubar_widget_SubId;
  Widget EZ_PD_Menubar_widget_destroy;
  Widget EZ_PD_Menubar_widget_create;

  n = 0;
  XtSetArg(args[n], XmNwidth, 752); n++;
  XtSetArg(args[n], XmNheight, 673); n++;
  EZ = XmCreateForm(parent, "form1", args, n);

  /*  CREATE PULLDOWN MENU */

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  PulldownMenu = XmCreateMenuBar(EZ, "menuBar", args, n);
  XtManageChild(PulldownMenu);


  n = 0;
  tmpLabelString =  XmStringCreate("Quit", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Quit = XmCreateCascadeButton(PulldownMenu, "cascadeButton1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Quit);


  n = 0;
  tmpLabelString =  XmStringCreate("start", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_start = XmCreateCascadeButton(PulldownMenu, "cascadeButton2", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_start);


  n = 0;
  tmpLabelString =  XmStringCreate("rate", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate = XmCreateCascadeButton(PulldownMenu, "cascadeButton3", args, n);
  XmStringFree(tmpLabelString);
  EZ_PD_Menubar_rate_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton3", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("10Hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate_10Hz = XmCreatePushButton(EZ_PD_Menubar_rate_SubId, "cascadeButton4", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_rate_10Hz);


  n = 0;
  tmpLabelString =  XmStringCreate("20Hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate_20Hz = XmCreatePushButton(EZ_PD_Menubar_rate_SubId, "cascadeButton5", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_rate_20Hz);


  n = 0;
  tmpLabelString =  XmStringCreate("50Hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate_50Hz = XmCreatePushButton(EZ_PD_Menubar_rate_SubId, "cascadeButton6", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_rate_50Hz);


  n = 0;
  tmpLabelString =  XmStringCreate("100Hz", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate_100Hz = XmCreatePushButton(EZ_PD_Menubar_rate_SubId, "cascadeButton7", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_rate_100Hz);


  n = 0;
  tmpLabelString =  XmStringCreate("FULL", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_rate_FULL = XmCreatePushButton(EZ_PD_Menubar_rate_SubId, "cascadeButton8", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_rate_FULL);

  XtVaSetValues(EZ_PD_Menubar_rate, XmNsubMenuId, EZ_PD_Menubar_rate_SubId, NULL);
  XtManageChild(EZ_PD_Menubar_rate);


  n = 0;
  tmpLabelString =  XmStringCreate("stop", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_stop = XmCreateCascadeButton(PulldownMenu, "cascadeButton9", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_stop);


  n = 0;
  tmpLabelString =  XmStringCreate("clear", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_clear = XmCreateCascadeButton(PulldownMenu, "cascadeButton10", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_clear);


  n = 0;
  tmpLabelString =  XmStringCreate("Annotation", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Annotation = XmCreateCascadeButton(PulldownMenu, "cascadeButton11", args, n);
  XmStringFree(tmpLabelString);
  EZ_PD_Menubar_Annotation_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton11", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("Left-down", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Annotation_Left = XmCreatePushButton(EZ_PD_Menubar_Annotation_SubId, "cascadeButton12", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Annotation_Left);


  n = 0;
  tmpLabelString =  XmStringCreate("Left-Up", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Annotation_Right = XmCreatePushButton(EZ_PD_Menubar_Annotation_SubId, "cascadeButton13", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Annotation_Right);


  n = 0;
  tmpLabelString =  XmStringCreate("Right-Down", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Annotation_Up = XmCreatePushButton(EZ_PD_Menubar_Annotation_SubId, "cascadeButton14", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Annotation_Up);


  n = 0;
  tmpLabelString =  XmStringCreate("Right-Up", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Annotation_Down = XmCreatePushButton(EZ_PD_Menubar_Annotation_SubId, "cascadeButton15", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Annotation_Down);

  XtVaSetValues(EZ_PD_Menubar_Annotation, XmNsubMenuId, EZ_PD_Menubar_Annotation_SubId, NULL);
  XtManageChild(EZ_PD_Menubar_Annotation);


  n = 0;
  tmpLabelString =  XmStringCreate("Dance", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance = XmCreateCascadeButton(PulldownMenu, "cascadeButton16", args, n);
  XmStringFree(tmpLabelString);
  EZ_PD_Menubar_Dance_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton16", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("ON", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_ON = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton17", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_ON);


  n = 0;
  tmpLabelString =  XmStringCreate("Off", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_Off = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton18", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_Off);


  n = 0;
  tmpLabelString =  XmStringCreate("Text on", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_Texton = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton19", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_Texton);


  n = 0;
  tmpLabelString =  XmStringCreate("Text off", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_Textoff = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton20", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_Textoff);


  n = 0;
  tmpLabelString =  XmStringCreate("Ctext on", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_Ctexton = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton21", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_Ctexton);


  n = 0;
  tmpLabelString =  XmStringCreate("Ctext off", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Dance_Ctextoff = XmCreatePushButton(EZ_PD_Menubar_Dance_SubId, "cascadeButton22", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Dance_Ctextoff);

  XtVaSetValues(EZ_PD_Menubar_Dance, XmNsubMenuId, EZ_PD_Menubar_Dance_SubId, NULL);
  XtManageChild(EZ_PD_Menubar_Dance);


  n = 0;
  tmpLabelString =  XmStringCreate("Scale", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Scale = XmCreateCascadeButton(PulldownMenu, "cascadeButton23", args, n);
  XmStringFree(tmpLabelString);
  EZ_PD_Menubar_Scale_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton23", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("-10 10", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Scale_1010 = XmCreatePushButton(EZ_PD_Menubar_Scale_SubId, "cascadeButton24", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Scale_1010);


  n = 0;
  tmpLabelString =  XmStringCreate("-20 20", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_Scale_2020 = XmCreatePushButton(EZ_PD_Menubar_Scale_SubId, "cascadeButton25", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_Scale_2020);

  XtVaSetValues(EZ_PD_Menubar_Scale, XmNsubMenuId, EZ_PD_Menubar_Scale_SubId, NULL);
  XtManageChild(EZ_PD_Menubar_Scale);


  n = 0;
  tmpLabelString =  XmStringCreate("hardcopy", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_hardcopy = XmCreateCascadeButton(PulldownMenu, "cascadeButton26", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_hardcopy);


  n = 0;
  tmpLabelString =  XmStringCreate("widget", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_widget = XmCreateCascadeButton(PulldownMenu, "cascadeButton27", args, n);
  XmStringFree(tmpLabelString);
  EZ_PD_Menubar_widget_SubId = XmCreatePulldownMenu(PulldownMenu, "cascadeButton27", NULL, 0);

  n = 0;
  tmpLabelString =  XmStringCreate("destroy", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_widget_destroy = XmCreatePushButton(EZ_PD_Menubar_widget_SubId, "cascadeButton28", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_widget_destroy);


  n = 0;
  tmpLabelString =  XmStringCreate("create", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  EZ_PD_Menubar_widget_create = XmCreatePushButton(EZ_PD_Menubar_widget_SubId, "cascadeButton29", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(EZ_PD_Menubar_widget_create);

  XtVaSetValues(EZ_PD_Menubar_widget, XmNsubMenuId, EZ_PD_Menubar_widget_SubId, NULL);
  XtManageChild(EZ_PD_Menubar_widget);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 12); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 36); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 456); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 348); n++;
  EZ_userWidget10 = XtCreateWidget("userWidget1", XwEzdrawWidgetClass, EZ, args, n);
  XtManageChild(EZ_userWidget10);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 642); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNwidth, 752); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNeditable, FALSE ); n++;
  XtSetArg(args[n], XmNmaxLength, 256); n++;
  EZ_textField11 = XmCreateTextField(EZ, "help", args, n);
  XtManageChild(EZ_textField11);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 18); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 392); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 306); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 240); n++;
  EZ_userWidget23 = XtCreateWidget("userWidget2", XwEzdrawWidgetClass, EZ, args, n);
  XtManageChild(EZ_userWidget23);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 360); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 400); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 360); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 232); n++;
  EZ_userWidget34 = XtCreateWidget("userWidget3", XwEzdrawWidgetClass, EZ, args, n);
  XtManageChild(EZ_userWidget34);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 486); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 40); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 252); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 352); n++;
  EZ_userWidget45 = XtCreateWidget("userWidget4", XwEzdrawWidgetClass, EZ, args, n);
  XtManageChild(EZ_userWidget45);

  XtAddCallback(EZ_PD_Menubar_Quit, XmNactivateCallback, (XtCallbackProc) quit_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_start, XmNactivateCallback, (XtCallbackProc) start_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_rate_10Hz, XmNactivateCallback, (XtCallbackProc) hz10_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_rate_20Hz, XmNactivateCallback, (XtCallbackProc) hz20_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_rate_50Hz, XmNactivateCallback, (XtCallbackProc) hz50_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_rate_100Hz, XmNactivateCallback, (XtCallbackProc) hz100_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_rate_FULL, XmNactivateCallback, (XtCallbackProc) full_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_stop, XmNactivateCallback, (XtCallbackProc) stop_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_clear, XmNactivateCallback, (XtCallbackProc) clear_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Annotation_Left, XmNactivateCallback, (XtCallbackProc) annleft_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Annotation_Right, XmNactivateCallback, (XtCallbackProc) annleftup_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Annotation_Up, XmNactivateCallback, (XtCallbackProc) annrigdo_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Annotation_Down, XmNactivateCallback, (XtCallbackProc) anrighup_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_ON, XmNactivateCallback, (XtCallbackProc) danceon_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_Off, XmNactivateCallback, (XtCallbackProc) danceoff_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_Texton, XmNactivateCallback, (XtCallbackProc) texton_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_Textoff, XmNactivateCallback, (XtCallbackProc) textoff_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_Ctexton, XmNactivateCallback, (XtCallbackProc) ctexton_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Dance_Ctextoff, XmNactivateCallback, (XtCallbackProc) ctextoff_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Scale_1010, XmNactivateCallback, (XtCallbackProc) scale10_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_Scale_2020, XmNactivateCallback, (XtCallbackProc) scale20_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_hardcopy, XmNactivateCallback, (XtCallbackProc) hardcopy_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_widget_destroy, XmNactivateCallback, (XtCallbackProc) destroy_cb, (XtPointer)NULL);
  XtAddCallback(EZ_PD_Menubar_widget_create, XmNactivateCallback, (XtCallbackProc) recreate_cb, (XtPointer)NULL);
  /* Finit-functions */
{
float scal[4] = {-15.0,30.0,-15.0,30.0};
float grid[4] = {-15.0,3.0,-15.0,3.0};
 int fac=3;
   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetArg(args[n],XwNezdrawPixFactor,fac);n++;
  XtSetValues(EZ_userWidget45,args,n);
  XwEzdrawAddcurve(EZ_userWidget45,	MGetPixel("white",EZ_userWidget45 ));


   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetValues(EZ_userWidget10,args,n);
  XwEzdrawAddcurve(EZ_userWidget10,	MGetPixel("red",EZ_userWidget10 ));

  XwEzdrawAddcurve(EZ_userWidget10,	MGetPixel("blue",EZ_userWidget10 ));
  XtAddCallback(EZ_userWidget10, XmNresizeCallback, (XtCallbackProc) ezres_cb, (XtPointer)NULL);
  XtAddCallback(EZ_userWidget10, XmNinputCallback, (XtCallbackProc) input_cb, (XtPointer)NULL);
  XtAddCallback(EZ_userWidget10, XmNexposeCallback, (XtCallbackProc) ezexp_cb, (XtPointer)NULL);


XwEzdrawSettext(EZ_userWidget10, 0 , "first text ");
XwEzdrawSettext(EZ_userWidget10, 1 , "some other ");


   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetValues(EZ_userWidget23,args,n);
  XwEzdrawAddcurve(EZ_userWidget23,	MGetPixel("black",EZ_userWidget23 ));

   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetValues(EZ_userWidget34,args,n);
  XwEzdrawAddcurve(EZ_userWidget34,	MGetPixel("red",EZ_userWidget34 ));

}
  return EZ;
}


static void  quit_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	MCloseDialog(parent);
}


static void  start_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr = 1;
	if(!timer)
  		plottimer = XtAppAddTimeOut(XtWidgetToApplicationContext(EZ_userWidget10),
		    rate , (XtTimerCallbackProc)plotter , NULL);
	else
		plotwork = XtAppAddWorkProc( XtWidgetToApplicationContext(EZ_userWidget10)
		, (XtWorkProc)plotter,NULL);

}


static void  hz10_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate = 100;
	timer = 0;

}


static void  hz20_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate = 50;
	timer = 0;

}


static void  hz50_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate = 20;
	timer = 0;

}


static void  hz100_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	rate = 10;
	timer = 0;

}


static void  full_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	timer=1;
}


static void  stop_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr=0;
	
}


static void  clear_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr=0;
	XwEzdrawClear(EZ_userWidget10 , 0);
}


static void  annleft_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAnnotation, XwEzdrawLeAnno | XwEzdrawDoAnno); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  annleftup_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAnnotation, XwEzdrawLeAnno | XwEzdrawUpAnno); n++;
  XtSetValues(EZ_userWidget10,args,n);


}


static void  annrigdo_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAnnotation, XwEzdrawRiAnno | XwEzdrawDoAnno); n++;
  XtSetValues(EZ_userWidget10,args,n);


}


static void  anrighup_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAnnotation, XwEzdrawRiAnno | XwEzdrawUpAnno); n++;
  XtSetValues(EZ_userWidget10,args,n);


}


static void  danceon_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAddvalue, TRUE); n++;
  XtSetValues(EZ_userWidget10,args,n);


}


static void  danceoff_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAddvalue, FALSE); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  texton_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAddtext, "Text is On"); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  textoff_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;

   n = 0;
  XtSetArg(args[n],XwNezdrawAddtext, NULL); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  ctexton_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	XwEzdrawSettext(EZ_userWidget10 , 0, "NULL TEXT");
	XwEzdrawSettext(EZ_userWidget10 , 1, "Kurve eins");

}


static void  ctextoff_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	XwEzdrawSettext(EZ_userWidget10 , 0, NULL);
	XwEzdrawSettext(EZ_userWidget10 , 1, NULL);


}


static void  scale10_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
float scal[4] = {-10.0,20.0,-10.0,20.0};
float grid[4] = {-10.0,2.0,-10.0,2.0};

   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  scale20_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  Arg args[40];
  Cardinal n;
float scal[4] = {-20.0,40.0,-20.0,40.0};
float grid[4] = {-20.0,2.5,-20.0,5.0};

   n = 0;
  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
  XtSetValues(EZ_userWidget10,args,n);

}


static void  hardcopy_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
/*   float *x1 , *y1 , *x2,*y2,*x3,*y3;
   short int *flag;
   int npoints , i;
   char fl[50];
   static int  nth=0;
    int n ;
  float *scal;
   Arg args[40];
  	n = 0;
  	XtSetArg(args[n],XwNezdrawScale, &scal); n++;
	XtGetValues(EZ_userWidget10,args,n);*/
/* first test only */
/*	sprintf(fl,"curves%d.ps",nth++);
	PS_Open(fl,PORTRAIT);
	XwEzdrawhistory (EZ_userWidget10  ,0 ,  &x1 , &y1 , &flag , &npoints); 
	free (flag);
	XwEzdrawhistory (EZ_userWidget10  ,1 ,  &x2 , &y2 , &flag ,&npoints); 
	PS_define_plotarea(1,20.,110.,150.,150.);
	PS_scale_plotarea(1,scal[0],scal[2],scal[1],scal[3],0);

	VPS_Curve(1,x2,y2,npoints,1,1+2,'A',4,0);
	VPS_Curve(1,x1,y1,npoints,1,1+2,'B',4,0);
	VPS_scalgrid(1,128);
	free (x1);
	free(y1);
	free (x2);
	free(y2);
	free (flag);
	PS_define_plotarea(2,20.,10.,75.,75.);
	PS_scale_plotarea(2,scal[0],scal[2],scal[1],scal[3],0);
  	n = 0;
  	XtSetArg(args[n],XwNezdrawScale, &scal); n++;
	XtGetValues(EZ_userWidget23,args,n);
	XwEzdrawhistory (EZ_userWidget23  ,0 ,  &x1 , &y1 , &flag , &npoints); 
	VPS_Curve(2,x1,y1,npoints,1,1,'A',4,0);
	VPS_scalgrid(2,128);
	free (x1);
	free(y1);

	free (flag);

 	PS_define_plotarea(3,110.,10.,75.,75.);
	PS_scale_plotarea(3,scal[0],scal[2],scal[1],scal[3],0);
 	n = 0;
  	XtSetArg(args[n],XwNezdrawScale, &scal); n++;
	XtGetValues(EZ_userWidget34,args,n);
	XwEzdrawhistory (EZ_userWidget34  ,0 ,  &x1 , &y1 , &flag , &npoints); 
	VPS_Curve(3,x1,y1,npoints,1,1 +32 + 64,'A',4,0);
	VPS_scalgrid(3,128);
	free (x1);
	free(y1);

	free (flag);

	PS_Close();		*/

}


static void  destroy_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
XtDestroyWidget(EZ_userWidget10);
}


static void  recreate_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
float scal[4] = {-15.0,30.0,-15.0,30.0};
float grid[4] = {-15.0,3.0,-15.0,3.0};
  Arg args[40];
  Cardinal n;
n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 12); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 36); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 456); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 348); n++;
 




  XtSetArg(args[n],XwNezdrawScale, scal); n++;
  XtSetArg(args[n],XwNezdrawGridScale, grid); n++;
 EZ_userWidget10 = XtCreateWidget("userWidget1", XwEzdrawWidgetClass, EZ, args, n);
  XtManageChild(EZ_userWidget10);
  XwEzdrawAddcurve(EZ_userWidget10,	MGetPixel("red",EZ_userWidget10 ));

  XwEzdrawAddcurve(EZ_userWidget10,	MGetPixel("blue",EZ_userWidget10 ));
  XtAddCallback(EZ_userWidget10, XmNresizeCallback, (XtCallbackProc) ezres_cb, (XtPointer)NULL);
  XtAddCallback(EZ_userWidget10, XmNinputCallback, (XtCallbackProc) input_cb, (XtPointer)NULL);
  XtAddCallback(EZ_userWidget10, XmNexposeCallback, (XtCallbackProc) ezexp_cb, (XtPointer)NULL);


XwEzdrawSettext(EZ_userWidget10, 0 , "first text ");
XwEzdrawSettext(EZ_userWidget10, 1 , "some other ");

}

Boolean plotter(void) {
float xy[2] ,xy1[2];
static int cnt=0 , symb=0 ;
int isym=0;
	if(cnt++ > 113){
		if(++symb > 33)
			symb = 1;
		isym = symb;
		cnt =0;
	}
		
	xy1[0] =radius * cos( base);
	xy[0] = (radius+0.001) * sin(base);
	xy[1] = (radius+0.001) * cos(base);
	xy1[1] = radius*sin(base);


	 XwEzdrawcurve (EZ_userWidget10  , 0  ,   xy1 , 2 + XwEzdrawSymbPlot , isym);
	 XwEzdrawcurve (EZ_userWidget10  , 1  ,   xy , 1 , 0);

	if(isym){
		xy1[0] = 10.0 * cos(base);
		xy1[1] = 10.0 * sin(base);
		XwEzdrawcurve (EZ_userWidget45, 0  ,   xy1 ,XwEzdrawSymbPlot+1 , isym);
	}
	xy[1] = (radius+0.001) * cos(base*1.5);
	XwEzdrawcurve (EZ_userWidget23  , 0  ,   xy , 1 , 0);

	xy[1] = (radius+0.001) * cos(base*3.);
	XwEzdrawcurve (EZ_userWidget34  , 0  ,   xy , 1 , 0);
	base += 0.07;
	radius += 0.002;
	if(plotr == 1 && !timer)
  		plottimer = XtAppAddTimeOut(XtWidgetToApplicationContext(EZ_userWidget10),
	    rate , (XtTimerCallbackProc)plotter , NULL);
	if(plotr == 1)
		return FALSE;
	else
		return TRUE;

}
static void ezexp_cb(Widget parent, XtPointer data, XwEzdrawCallbackStruct *cbs) {
printf ("EXPOSE\n");
printf ("\t %f %f %f %f\n ", cbs->x_value,cbs->y_value,cbs->x_max,cbs->y_max);
}

static void input_cb(Widget parent,  XtPointer data,  XwEzdrawCallbackStruct *cbs){

printf("BUTTON: %f %f \n",cbs->x_value    , cbs->y_value   );
}

static void ezres_cb(Widget parent, XtPointer data, XwEzdrawCallbackStruct *cbs) {
printf ("RESIZE\n");
printf ("\t %f %f %f %f\n ", cbs->x_value,cbs->y_value,cbs->x_max,cbs->y_max);
}



