/* Created by MIND V.3.0 (c), flux Software GmbH, 1993-99   */ 

/*************************************************************************** 
 *************************************************************************** 
 * 
 * Projekt:		histbar
 * 
 * 
 * Dokumentation:	Demo and Test Program for  WHistbar
 * 
 * Designer:		J.Keidel
 * 
 * Datum:		Thu Dec  9 11:43:38 1999
 * 
 ***************************************************************************
 ***************************************************************************/

/* INCLUDES */

#include <Xm/XmAll.h>
#include "XMind.h"
#include <X11/xpm.h>



 #include <stdlib.h>
#include <math.h>
#include <Xm/DrawP.h>
/*   PRIVATE INCLUDE   */
#include "WHistbar.h"

/*   PRIVATE DEFINES   */
  static int mvfirst=0;

GC bargc,topgc,shadegc , lgc;
GC pxbargc,pxtopgc,pxshadegc ,mvbargc,mvtopgc,mvshadegc , mvlgc , backgc;
 Pixmap          pix , PXpix; 

int Deep=100 , High=1 , Broad=20;
double angle = 45.0;
Bool Fill=TRUE;
int noline = 1;
static int pxfirst = 0;
static double timbase = 500;

XtIntervalId plottimer;
int plotr =0 ; 
int rate=20;
int doit =1;
static int next = 0;

char  col[][20]={"grey40","green","blue","yellow","red","goldenrod",
"MediumSlateBlue","aquamarine","GreenYellow","gold","IndianRed",
"HotPink","salmon","magenta","cyan1","firebrick1","grey83","MediumOrchid1"
,"maroon1","tomato1","tan1","RosyBrown1","DarkSeaGreen1",};



/***  END   HEADER   ***/

/* PROTOTYPES */

static Widget histbar_Create(Widget parent);
static void starthist_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void histquit_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void histstop_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void cont_do_cb(Widget parent, XtPointer data, XmToggleButtonCallbackStruct *cbs);
static void dump_history_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void add_a_bar(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void reset_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static Widget values_Create(Widget parent);
static void history_cb(Widget parent, XtPointer data, XmTextVerifyCallbackStruct *cbs);
static void quit_values_cb(Widget parent, XtPointer data, XmPushButtonCallbackStruct *cbs);
static void histplotter(void);
static void input_cb(Widget parent,  XtPointer data,  XwHistbarCallbackStruct *cbs);


/* STATIC GLOBAL WIDGETS */

static Widget histb;
static Widget histbar_value;
static Widget values_liste;

/* FALLBACK RESOURCES */
static String fallback_resources[] = {
"Histbar*form2.userWidget1.background: 	PeachPuff1",
"Histbar*form2.pushButton.fontList: 	-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-iso8859-*",
"Histbar*form2.pushButton.fontList: 	-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-iso8859-*",
"Histbar*form2.pushButton.background: 	red",
"Histbar*form2.toggleButton1.fontList: 	-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-iso8859-*",
  NULL
};




/* FUNKTIONEN */

/*************************************************************************** 
 * 
 * Funktionsname:	main
 * 
 * 
 * Input:		int argc; char *argv[]
 * 
 * Return:		void
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

void main(int argc,char **argv)
{
  XtAppContext app_context;
  Widget Toplevel, MainDialog;

  XtSetLanguageProc(NULL, NULL, NULL);

  /* INITIALISIERE DEN TOPLEVEL */

  Toplevel = XtAppInitialize(&app_context, "Histbar", NULL, 0, &argc, argv, fallback_resources, NULL, 0);

  /* ERSTELLE DEN HAUPTDIALOG */

  MainDialog = histbar_Create(Toplevel);

  /* MANAGEN UND REALISIEREN DER SHELL WIDGETS */

  XtManageChild(MainDialog);
  XtRealizeWidget(Toplevel);

  /* STARTE DIE NACHRICHTEN-QUEUE */

  XtAppMainLoop(app_context);
}


/*************************************************************************** 
 * 
 * Funktionsname:	histbar_Create
 * 
 * 
 * Input:		Widget parent
 * 
 * Return:		Widget main
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

static Widget histbar_Create(Widget parent)
{
  Arg args[40];
  Cardinal n;
  XmString tmpLabelString = NULL;
  Widget histbar;
  Widget histbar_textField10;
  Widget histbar_pushButton13;
  Widget histbar_pushButton24;
  Widget histbar_pushButton35;
  Widget histbar_toggleButton16;
  Widget histbar_pushButton47;
  Widget PulldownMenu;
  Widget histbar_PD_Menubar_addbar;
  Widget histbar_PD_Menubar_reset;

  n = 0;
  XtSetArg(args[n], XmNwidth, 566); n++;
  XtSetArg(args[n], XmNheight, 417); n++;
  histbar = XmCreateForm(parent, "form2", args, n);

  /*  CREATE PULLDOWN MENU */

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  PulldownMenu = XmCreateMenuBar(histbar, "menuBar", args, n);
  XtManageChild(PulldownMenu);


  n = 0;
  tmpLabelString =  XmStringCreate("add bar", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  histbar_PD_Menubar_addbar = XmCreateCascadeButton(PulldownMenu, "cascadeButton1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_PD_Menubar_addbar);


  n = 0;
  tmpLabelString =  XmStringCreate("reset", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  histbar_PD_Menubar_reset = XmCreateCascadeButton(PulldownMenu, "cascadeButton2", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_PD_Menubar_reset);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 386); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNwidth, 566); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNeditable, FALSE ); n++;
  XtSetArg(args[n], XmNresizeWidth, TRUE); n++;
  histbar_textField10 = XmCreateTextField(histbar, "textField1", args, n);
  XtManageChild(histbar_textField10);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 12); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 127); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 548); n++;
  XtSetArg(args[n], XmNheight, 255); n++;
  histb = XtCreateWidget("userWidget1", XwHistbarWidgetClass, histbar, args, n);
  XtManageChild(histb);


  n = 0;
  XtSetArg(args[n], XmNx, 47); n++;
  XtSetArg(args[n], XmNy, 33); n++;
  tmpLabelString = XmStringCreateLtoR("start", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  histbar_pushButton13 = XmCreatePushButton(histbar, "pushButton", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_pushButton13);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNleftOffset, 5); n++;
  XtSetArg(args[n], XmNx, 5); n++;
  XtSetArg(args[n], XmNy, 33); n++;
  tmpLabelString = XmStringCreateLtoR("Quit", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  histbar_pushButton24 = XmCreatePushButton(histbar, "pushButton", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_pushButton24);


  n = 0;
  XtSetArg(args[n], XmNx, 93); n++;
  XtSetArg(args[n], XmNy, 33); n++;
  tmpLabelString = XmStringCreateLtoR("stop", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  histbar_pushButton35 = XmCreatePushButton(histbar, "pushButton", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_pushButton35);


  n = 0;
  XtSetArg(args[n], XmNx, 136); n++;
  XtSetArg(args[n], XmNy, 33); n++;
  tmpLabelString =  XmStringCreate("pause", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  histbar_toggleButton16 = XmCreateToggleButton(histbar, "toggleButton1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_toggleButton16);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 291); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 31); n++;
  tmpLabelString = XmStringCreateLtoR("Dump History", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  histbar_pushButton47 = XmCreatePushButton(histbar, "pushButton", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(histbar_pushButton47);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 392); n++;
  XtSetArg(args[n], XmNy, 31); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNwidth, 174); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 89); n++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
  XtSetArg(args[n], XmNeditable, FALSE ); n++;
  XtSetArg(args[n], XmNscrollHorizontal, FALSE); n++;
  histbar_value = XmCreateScrolledText(histbar, "text1", args, n);
  XtManageChild(histbar_value);

  XtAddCallback(histbar_pushButton13, XmNactivateCallback, (XtCallbackProc) starthist_cb, (XtPointer)NULL);
  XtAddCallback(histbar_pushButton24, XmNactivateCallback, (XtCallbackProc) histquit_cb, (XtPointer)NULL);
  XtAddCallback(histbar_pushButton35, XmNactivateCallback, (XtCallbackProc) histstop_cb, (XtPointer)NULL);
  XtAddCallback(histbar_toggleButton16, XmNvalueChangedCallback, (XtCallbackProc) cont_do_cb, (XtPointer)NULL);
  XtAddCallback(histbar_pushButton47, XmNactivateCallback, (XtCallbackProc) dump_history_cb, (XtPointer)NULL);
  XtAddCallback(histbar_PD_Menubar_addbar, XmNactivateCallback, (XtCallbackProc) add_a_bar, (XtPointer)NULL);
  XtAddCallback(histbar_PD_Menubar_reset, XmNactivateCallback, (XtCallbackProc) reset_cb, (XtPointer)NULL);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNbottomWidget, histbar_textField10); n++;
  XtSetValues(histb, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNleftOffset, 5); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, histbar_pushButton24); n++;
  XtSetArg(args[n], XmNtopOffset, 2); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, histbar_PD_Menubar_addbar); n++;
  XtSetValues(histbar_pushButton13, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNtopOffset, 2); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, histbar_PD_Menubar_addbar); n++;
  XtSetValues(histbar_pushButton24, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNleftOffset, 5); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, histbar_pushButton13); n++;
  XtSetArg(args[n], XmNtopOffset, 2); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, histbar_PD_Menubar_addbar); n++;
  XtSetValues(histbar_pushButton35, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNleftOffset, 5); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNleftWidget, histbar_pushButton35); n++;
  XtSetArg(args[n], XmNtopOffset, 2); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, histbar_PD_Menubar_addbar); n++;
  XtSetValues(histbar_toggleButton16, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNrightOffset, 5); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNrightWidget, histbar_value); n++;
  XtSetValues(histbar_pushButton47, args, n);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, histbar_PD_Menubar_addbar); n++;
  XtSetValues(XtParent(histbar_value), args, n);
  /* Finit-functions */
XwHistbarAddbar( histb , MGetPixel("green",histb));
XwHistbarSettext( histb , 0 , "BAR 0");

{
  float scal[4] = {500,50.0,0,800};
  float grid[4] = {500,10,0,100};
 n = 0;
XtSetArg(args[n], XwNhistbarBARcolor, MGetPixel("black",histb)); n++;
XtSetArg(args[n], XwNhistbarAnnotColor, MGetPixel("blue",histb)); n++;
 XtSetArg(args[n],XwNhistbarScale, scal); n++;
 XtSetArg(args[n],XwNhistbarGridScale, grid); n++;
XtSetValues(histb,args,n);
 XtAddCallback(histb, XmNinputCallback, (XtCallbackProc) input_cb, (XtPointer)NULL);
}



  /* QUICKHELP - HANDLER */
  {    USER_DATA *data;

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Start it running");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_pushButton13, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_pushButton13, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Stop running");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_pushButton35, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_pushButton35, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("If set, continues plotting without display");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_toggleButton16, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_toggleButton16, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Start History dump Dialog");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_pushButton47, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_pushButton47, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Displays values from mousklick");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_value, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_value, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Add one more bar");
    data->Qhelp_widget = histbar_textField10;
    XtAddEventHandler(histbar_PD_Menubar_addbar, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(histbar_PD_Menubar_addbar, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

  }

  return histbar;
}


/*************************************************************************** 
 * 
 * Funktionsname:	values_Create
 * 
 * 
 * Input:		Widget parent
 * 
 * Return:		Widget main
 * 
 * Dokumentation:		
 * 
 * 
 ***************************************************************************/

static Widget values_Create(Widget parent)
{
  Arg args[40];
  Cardinal n;
  Widget MainShell;
  XmString tmpLabelString = NULL;
  Widget values;
  Widget values_textField10;
  Widget values_label11;
  Widget values_textField22;
  Widget values_pushButton14;


  n = 0;
  XtSetArg(args[n], XmNwidth, 343); n++;
  XtSetArg(args[n], XmNheight, 410); n++;
  XtSetArg(args[n], XmNtitle, "values"); n++;
  MainShell = (Widget)XmCreateDialogShell(parent,"form1_Dialog",args, n);


  n = 0;
  XtSetArg(args[n], XmNwidth, 343); n++;
  XtSetArg(args[n], XmNheight, 410); n++;
  XtSetArg(args[n], XmNautoUnmanage, FALSE); n++;
  values = XmCreateForm(MainShell, "form1", args, n);

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 248); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopOffset, 5); n++;
  XtSetArg(args[n], XmNy, 5); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset, 5); n++;
  XtSetArg(args[n], XmNwidth, 90); n++;
  XtSetArg(args[n], XmNmaxLength, 256); n++;
  values_textField10 = XmCreateTextField(values, "textField1", args, n);
  XtManageChild(values_textField10);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 192); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 10); n++;
  tmpLabelString =  XmStringCreateLtoR("select ID", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  XtSetArg(args[n], XmNrecomputeSize, TRUE ); n++;
  XtSetArg(args[n], XmNalignment, 1 ); n++;
  values_label11 = XmCreateLabel(values, "label1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(values_label11);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 379); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNwidth, 343); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNeditable, FALSE ); n++;
  XtSetArg(args[n], XmNresizeWidth, TRUE); n++;
  XtSetArg(args[n], XmNmaxLength, 256); n++;
  values_textField22 = XmCreateTextField(values, "textField2", args, n);
  XtManageChild(values_textField22);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNleftOffset, 5); n++;
  XtSetArg(args[n], XmNx, 5); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopOffset, 5); n++;
  XtSetArg(args[n], XmNy, 5); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 54); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 20); n++;
  tmpLabelString = XmStringCreateLtoR("QUIT", XmFONTLIST_DEFAULT_TAG);
  XtSetArg(args[n], XmNlabelString, tmpLabelString); n++;
  values_pushButton14 = XmCreatePushButton(values, "pushButton1", args, n);
  XmStringFree(tmpLabelString);
  XtManageChild(values_pushButton14);


  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 6); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNy, 50); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 330); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 320); n++;
  XtSetArg(args[n], XmNselectionPolicy, 0); n++;
  XtSetArg(args[n], XmNlistSizePolicy, XmCONSTANT); n++;
  values_liste = XmCreateScrolledList(values, "list1", args, n);
  XtManageChild(values_liste);

  XtAddCallback(values_textField10, XmNactivateCallback, (XtCallbackProc) history_cb, (XtPointer)NULL);
  XtAddCallback(values_pushButton14, XmNactivateCallback, (XtCallbackProc) quit_values_cb, (XtPointer)NULL);

  /* GENERATE ADDITIONAL ATTACHMENTS */
  n=0;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNrightWidget, values_textField10); n++;
  XtSetValues(values_label11, args, n);
  XtManageChild(values);


  /* QUICKHELP - HANDLER */
  {    USER_DATA *data;

    data = (USER_DATA *) malloc(sizeof(USER_DATA));
    data->Qhelp_name = strdup("Type in ID, The bar-history will be printed in List");
    data->Qhelp_widget = values_textField22;
    XtAddEventHandler(values_textField10, EnterWindowMask, FALSE, (XtEventHandler) MSetQuickhelp, (XtPointer)data);
    XtAddCallback(values_textField10, XmNdestroyCallback, (XtCallbackProc) MDestroyQuickhelp, (XtPointer)data);

  }

  return values;
}


static void  starthist_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr=1;
	histplotter();
}


static void  histquit_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	MCloseDialog(parent);
}


static void  histstop_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	plotr=0;

}


static void  cont_do_cb(Widget parent,  XtPointer data,  XmToggleButtonCallbackStruct *cbs)
{
	if(cbs->set)
		doit = 0;
	else
		doit = 1;
}


static void  dump_history_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	values_Create(XtParent(parent));
}


static void  add_a_bar(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  int id;
  char annot[30];
	if(next <=15){
	id = XwHistbarAddbar( histb , MGetPixel(col[next],histb));
	next++;
	sprintf(annot,"BAR %d",id);
	XwHistbarSettext( histb , id , annot);
	}
}


static void  reset_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
  float scal[4] = {500,50.0,0,800};
  float grid[4] = {500,10,0,100};
  Arg args[40];
  Cardinal n;
	timbase = 500;
 n = 0;
 XtSetArg(args[n],XwNhistbarScale, scal); n++;
 XtSetArg(args[n],XwNhistbarGridScale, grid); n++;
XtSetValues(histb,args,n);
}


static void  history_cb(Widget parent,  XtPointer data,  XmTextVerifyCallbackStruct *cbs)
{
   float *tim,*val;
   char line[200];
   long int ID;
   int nlines , i;

	ID = MTextGetInt(parent);

	XwHistbarhistory (histb ,ID , &tim , &val ,&nlines);

	MListDeleteAllItems(values_liste);
	for(i=0;i<nlines;i++){
		sprintf(line,"%d  %f  %f\n", i , tim[i] , val[i]);
		MListAddString(values_liste, line);
	}
	free(tim);
	free(val);

}


static void  quit_values_cb(Widget parent,  XtPointer data,  XmPushButtonCallbackStruct *cbs)
{
	MCloseDialog(parent);
}

static void histplotter(void) {
   int i;
  float height,height2     , xy[2] , xya[2] , xyb[2];
/* assume height = 200 */
/* do a sine for height */
	xy[1] =   (sin(timbase) + 1.0) * 400 * (rand()/(RAND_MAX+1.0));
	xya[1] = (sin(timbase/2) + 1.0)*400;
	timbase += 0.5 ;
	xyb[1] =  (sin(timbase/8) + 1.0) * 400;
	xyb[0]=xy[0] = xya[0] = timbase;
	XwHistdobar ( histb , 0,xy,doit);

	for (i=0; i<next;i++){
	switch(i){
	case 0:
	XwHistdobar ( histb , i+1,xya,0);
	break;
	case 1:
	XwHistdobar ( histb , i+1,xyb,0);
	break;
	default:
	xya[1] = (sin((timbase*(1.3*i)/8)) + 1.0)*400;
	xya[1] /= (i-1);
	XwHistdobar ( histb , i+1,xya,0);
	break;
	}
	}
	if(plotr == 1 )
  		plottimer = XtAppAddTimeOut(XtWidgetToApplicationContext(histb),
	    rate , (XtTimerCallbackProc)histplotter , NULL);
	if(plotr == -1)
		MCloseDialog(histb);

}


static void input_cb(Widget parent,  XtPointer data,  XwHistbarCallbackStruct *cbs) {
  char line [100];


	sprintf(line,"ID:%d\nwin_t:%f\nID_t :%f\nval:%f",cbs->id, cbs->time_win,cbs->time_id 
		,XwHistbarGetValue(parent ,cbs->id ,cbs->time_id ));
	XmTextSetString(histbar_value,line);

}

