/*
   Widgetklasse:	XwEzDrawWidgetClass
   $Revision: 2.2 $
   $Log: WEzdraw.c,v $
   Revision 2.2  2001/11/17 12:30:36  keidel
   corrected problem with fontlist at destroy

   Revision 2.1  2001/02/25 14:57:15  keidel
   Set all to stable version 2.0

   Revision 1.1.1.1  2001/02/25 14:48:21  keidel
   initial motif in motion widgets


   Revision 1.10  1999/10/21 14:10:18  keidel
   change ezdrwaclear to switch on flag, clear only pixmap or screen and pixmap

   Revision 1.4  1999/10/21 07:29:12  keidel
   change XwEzdrawClear to have flag clearing only pixmap or screen as well

   Revision 1.3  1999/10/06 07:43:56  keidel
   added character plot to symbolplot

   Revision 1.7  1998/02/09 16:23:34  keidel
   final cleaning (using IRIS -fullwarn on an origin with IRIX 6.4)

   Revision 1.6  1998/02/07 15:56:55  keidel
   due to -fullwarn on IRIX6.4 eliminating unused etc

   Revision 1.5  1998/01/22 16:30:38  keidel
    corrected destoy callback, no cbs special at destroy

   Revision 1.4  1998/01/12 16:15:00  keidel
   corrected gridplotting (better start etc)

   Revision 1.3  1998/01/09 17:59:23  keidel
   changed pixfactor to int

   Revision 1.2  1997/10/11 13:09:52  keidel
   clean up, to make it safer, accessing a destroyed widget.

   Revision 1.1  1997/06/22 07:54:43  keidel
   Initial revision

   
*/

/*
    Copyright 1997,  WizAnt Software  
                Jrgen Keidel  
                Bergstrasse 15
                D 85080 Gaimersheim
                Tel/Fax: D  08406 379
                E-mail: wizant.keidel@01019freenet.de


          This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2, or (at your option)
        any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/******************************************************************
   Widgetclass:	XwEzDrawWidgetClass

   written by: 	WizAnt Software
   		Jrgen Keidel  
   		Bergstrasse 15
   		85080 Gaimersheim
   		
   		1997
  
  
                                                                
******************************************************************/
/* include */

#include <stdio.h>
#include <stdlib.h>
#include<Xm/PrimitiveP.h>
#include<Xm/DrawP.h>


#include <WEzdraw.h>


#ifdef __cpluspuls
extern "C"{
#endif

#define offset(field) XtOffsetOf(XwEzdrawRec, field)
#ifndef strdup
char *strdup(const char *s);
#endif


 #define MACRO  
  
#ifdef MACRO
#define xPix(cw,x)  \
	((long int)(cw->ezdraw.sc.ax + cw->ezdraw.sc.bx * x) )
	
	
#define yPix(cw,y)  \
	( (long int)(cw->ezdraw.sc.ay - cw->ezdraw.sc.by * y) )
	 

 #endif
	
/****** private Funktions Deklaration ******/
#ifdef _NO_PROTO

/* Deklaration der Methoden */
static void Initialize();
static Boolean SetValues ();
static void Redisplay();
static XtGeometryResult QueryGeometry( );
static void Resize();
static void Destroy(  );

/* Deklaration der privaten Funktionen */
static void get_proportion();
static void select_action_button1();
static void select_action_2_down();
static void select_action_2_drag();
static void scale();
static void create_pixmap		();
static void  create_history 		();
static void Getezdraw_gc		();
static void drawgrid		();
static void clear_ezdraw		();
static void copy_pixmaps		();
static void  addhistory  		 ();
static void ez_plot			();
static void redrawhistory		();
static void  dancevals		();
static void  addtext		();
static void Set_clipping 		();

 #else

/* Deklaration der Methoden */
static void Initialize		( Widget , Widget , ArgList , Cardinal *);
static Boolean SetValues 		( Widget curr, Widget requ, Widget new, ArgList args
				, Cardinal *numargs);
static void Redisplay		(Widget w, XEvent *event, Region region);
static XtGeometryResult QueryGeometry( Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer);
static void Resize			( Widget );
static void Destroy			( Widget );

/* Deklaration der privaten Funktionen */
static void get_proportion		( XwEzdrawWidget );
static void select_action_button1	(Widget , XEvent *);
static void select_action_2_down	(Widget , XEvent *);
static void select_action_2_drag	(Widget , XEvent *);
static void scale			(XwEzdrawWidget cw);
static void create_pixmap		(XwEzdrawWidget cw , int flag);
static void  create_history 		(XwEzdrawWidget  cw, int flag);
static void Getezdraw_gc		(XwEzdrawWidget  cw);
static void drawgrid		(XwEzdrawWidget cw);
static void clear_ezdraw		(XwEzdrawWidget cw , int flag);
static void copy_pixmaps		(XwEzdrawWidget cw , int flag);
static void  addhistory   		(Ezdrawhistory *hist, float xy[] , char symb,char flag);
static void ez_plot			(XwEzdrawWidget cw , int ID , int ix , int iy , int flag,char symb);
static void redrawhistory		(XwEzdrawWidget cw);
static void  dancevals		(XwEzdrawWidget  cw );
static void  addtext		(XwEzdrawWidget  cw );
static void Set_clipping 		(XwEzdrawWidget  cw);


#endif /* _NO_PROTO */


/* Definition der Resourcen-Liste */


static XtResource resources[] = {
   {
    	XmNinputCallback,
    	NULL,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(ezdraw.input_callback),
    	XtRCallback,
    	NULL

  },
  {
    	XmNexposeCallback,
    	XmCExposeCallback,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(ezdraw.expose_callback),
    	XtRCallback,
    	NULL

  },
 {
    	XmNresizeCallback,
    	XmCResizeCallback,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(ezdraw.resize_callback),
    	XtRCallback,
    	NULL

  },
   {
  	XwNezdrawBorder,
  	XwCEzdrawBorder,
  	XtRBool,
  	sizeof(int),
  	offset(ezdraw.border),
  	XtRImmediate,
  	(XtPointer) FALSE
  },
 {
   	XwNezdrawGridScale ,
   	XwCEzdrawGridScale,
  	XtRFloat ,  	  	 
  	sizeof(float *),
  	offset(ezdraw.gr),	
  	XtRImmediate,
  	NULL
  },
  {
   	XwNezdrawScale,
   	XwCEzdrawScale,
  	XtRFloat ,  	  	 
  	sizeof(float *),
  	offset(ezdraw.vis),	
  	XtRImmediate,
  	NULL
  },
 {
   	XwNezdrawAnnotColor,
   	XwCEzdrawAnnotColor,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(ezdraw.anncolor ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
  {
   	XwNezdrawGridColor,
   	XwCEzdrawGridColor,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(ezdraw.gridcolor ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
{
   	XwNezdrawCUcolor ,
   	XwCEzdrawCUcolor ,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(ezdraw.background ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
   {
   	XwNezdrawAnnotXNdec,
   	XwCEzdrawAnnotXNdec,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.xndecimals ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
   {
   	XwNezdrawAnnotYNdec,
   	XwCEzdrawAnnotYNdec,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.yndecimals ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
  {
   	XwNezdrawAnnotXNgrid,
   	XwCEzdrawAnnotXNgrid,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.xnthgridanno),	
  	XtRImmediate,
  	(XtPointer) 0
  },
   {
   	XwNezdrawAnnotYNgrid,
   	XwCEzdrawAnnotYNgrid,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.ynthgridanno),	
  	XtRImmediate,
  	(XtPointer) 0
  },
 {
   	XwNezdrawNcurves,
   	XwCEzdrawNcurves,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.ncurves ),	
  	XtRImmediate,
  	(XtPointer) DefaultNcurves
  },
  {
   	XwNezdrawAnnotation,
   	XwCEzdrawAnnotation,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(ezdraw.anflag ),	
  	XtRImmediate,
  	(XtPointer) (XwEzdrawLeAnno + XwEzdrawDoAnno)
  },
 {
   	XwNezdrawAddvalue,
   	XwCEzdrawAddvalue,
  	XtRBool ,  	  	 
  	sizeof(int),
  	offset(ezdraw. addvalues),	
  	XtRImmediate,
  	(XtPointer) FALSE
  },
 {
   	XwNezdrawCurve,
   	XwCEzdrawCurve,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(ezdraw.firstcurve ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
  {
   	XwNezdrawAddtext,
   	XwCEzdrawAddtext,
  	XtRString ,  	  	 
  	sizeof(char *),
  	offset(ezdraw.addtext ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
{
 	XmNfontList,
 	XmCFontList,
 	XmRFontList,
 	sizeof(XmFontList),
 	offset(ezdraw.font_list),
 	XtRImmediate,
 	NULL
  },
   {
  	XwNezdrawHistory,
  	XwCEzdrawHistory,
  	XtRBool,
  	sizeof(int),
  	offset(ezdraw.history),
  	XtRImmediate,
  	(XtPointer) TRUE
  },
 {
   	XwNezdrawHistorysize,
   	XwCEzdrawHistorysize,
  	XtRInt,  	  	 
  	sizeof(int),
  	offset(ezdraw.historysize ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
 {
   	XwNezdrawPixFactor ,
   	XwCEzdrawPixFactor,
  	XtRInt ,  	  	 
  	sizeof(int ),
  	offset(ezdraw.pixfactor),	
  	XtRImmediate,
  	(XtPointer) 1
  },
 {
   	XwNezdrawAutoscroll,
   	XwCEzdrawAutoscroll,
  	XtRInt,  	  	 
  	sizeof(int),
  	offset(ezdraw.autoscroll ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
};
/*Definition der Translation Tabelle */


static char defaultTranslations[] =
  "<Btn1Down>:	select_action_button1()	\n\
     <Btn2Down>:	select_action_2_down()	\n\
     <Btn2Motion>: 	select_action_2_drag()";

   
/* Definition der Aktionen fr die Translation-Tabelle */

static XtActionsRec actions[] = {

   {"select_action_button1", (XtActionProc)select_action_button1},
   {"select_action_2_down", (XtActionProc)select_action_2_down},
   {"select_action_2_drag", (XtActionProc)select_action_2_drag},
};



/* Klasseninitialisierung fr die XwEzdrawClass */

XwEzdrawClassRec xwEzdrawClassRec = {
  {
     /* core_Class Felder */
     /* Superklasse		*/ (WidgetClass) & xmPrimitiveClassRec,
     /* Klassenname		*/ "XwEzdraw",
     /* Widget groesse	*/ sizeof(XwEzdrawRec),
     /* Class_initialize	*/ NULL,
     /* Class_part_initialize	*/ NULL,
     /* class_inited intern	*/ FALSE,
     /* initialize		*/ Initialize,
     /* initialize_hook (dynami)*/ NULL,
     /* realize	(XCreateWindow)	*/ XtInheritRealize,
     /* actions		*/actions,
     /* Anzahl der Action	*/ XtNumber(actions), 
     /* Resourcen 		*/ resources,
     /* Resourcen anzahl	*/ XtNumber(resources),
     /* xrm_class intern	*/ NULLQUARK,
     /* compressmotion 	*/ TRUE,
     /* compress_exposure	*/ XtExposeCompressMultiple,
     /* compress_enterleave	*/ TRUE,
     /* VisibilityNotify	*/ FALSE,
     /* destroy		*/ Destroy,
     /* resize		*/ Resize,	
     /* expose		*/ Redisplay,
     /* set_values		*/ SetValues,
     /* set_values_hook	*/ NULL,
     /* set_values_almost	*/ XtInheritSetValuesAlmost,
     /* get_values_hook	*/ NULL,
     /* accept_focus		*/ NULL,
     /* version		*/ XtVersion,
     /* callback_private	*/ NULL,
     /* tm_table		*/defaultTranslations,
     /* query_geometry	*/QueryGeometry,
     /* display_accelerator	*/ XtInheritDisplayAccelerator,
     /* extension		*/ NULL
  },
  { /* Primitive_Class felder */
    /* border_highlight	*/ NULL,
    /* border_unhighlight*/ NULL,
    /* translations		*/ XtInheritTranslations,
    /* arm_and_activate	*/ NULL,
    /* syn resources		*/ NULL,
    /* num_syn_resources	*/ 0,
    /* extension	 	*/ NULL,
  },
  { /* wiezdraw_Class felder */
    /* extensions 		*/ NULL,
  },
};

WidgetClass XwEzdrawWidgetClass = (WidgetClass) &xwEzdrawClassRec;


static   float defaultscal[4] = {-50.0,100.0,-50.0,100.0};
static    float  defaultgrid[4] ={-50.0,10.0,-50.0,10.0};
/*
static   float defaultscal[4] = {0.0,100.0,0.0,100.0};
static    float  defaultgrid[4] ={0.0,10.0,0.0,10.0};
*/
/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Initialize
 *
 *
 *  Prototype:	static void Initialize (Widget treq, Widget tnew, ArgList args,
 *			 Cardinal *num_args);
 *  
 *  Input:		Widget treq, Widget tnew, ArgList args,
 *			Cardinal *num_args
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	Method, called from X, creating the Widget.
 *			The Instances are checked, dependent parameters
 *			calculated from resources, pixmaps and GC's created
 *			initial clearing of pixmaps, and setting the grid
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
 static void Initialize (Widget treq, Widget tnew, ArgList args, Cardinal *num_args)
{
   XwEzdrawWidget new = (XwEzdrawWidget) tnew; /* Convert pointer type to Instancerecord */
   float *interm;
  



	new->primitive.highlight_thickness = 0;
	if(new->ezdraw.addtext)
		new->ezdraw.addtext = strdup(new->ezdraw.addtext);
	/* copy scaling and grid definition over to internal storage, as application might free the array */
	interm = (float *)XtMalloc(sizeof(float)*4);
	if(new->ezdraw.vis)
		memcpy(interm, new->ezdraw.vis , 4*sizeof(float));
	else
		memcpy(interm,  defaultscal , 4*sizeof(float));
	new->ezdraw.vis = interm;
	interm = (float *)XtMalloc(sizeof(float)*4);
	if(new->ezdraw.gr	)
		memcpy(interm, new->ezdraw.gr , 4*sizeof(float));
	else
		memcpy(interm, defaultgrid  , 4*sizeof(float));
	new->ezdraw.gr = interm;
	if(new->ezdraw.pixfactor < 1.0)	/* ensure legal value for factor */
		new->ezdraw.pixfactor = 1.0	;
	new->ezdraw.exposed = 0;		/* count to get first exposure */
	new->ezdraw.lastanncnt_x = new->ezdraw.lastanncnt_y  = 1;
/*  create default storage for curves */
	new->ezdraw.crv = (EzCurve *)XtMalloc(new->ezdraw.ncurves * sizeof(EzCurve));
	memset(new->ezdraw.crv , 0 , new->ezdraw.ncurves * sizeof(EzCurve));
	new->ezdraw.nactc=0;
  /* Wenn keine Fontliste durch Resourcen gesetzt ist,laden die Default-Fontliste */
  	if (new->ezdraw.font_list == NULL){
    		new->ezdraw.font_list =
    		      _XmGetDefaultFontList((Widget) new, XmLABEL_FONTLIST);
  	}
/* set all colours , is not explicitely set, inherit from parent */
	if (new->ezdraw.background == 0){
	        new->ezdraw.background = new->core.background_pixel;
	 }
	if(!new->ezdraw.gridcolor)
		new->ezdraw.gridcolor  = new->primitive.foreground;

	if(!new->ezdraw.anncolor)
		new->ezdraw.anncolor = new->ezdraw.gridcolor;
	
  /* Die Fonts fr die Fontliste laden */
  	if (new->ezdraw.font_list ){
   		 new->ezdraw.font_list = XmFontListCopy(new->ezdraw.font_list);
    		_XmFontListGetDefaultFont( new->ezdraw.font_list, &new->ezdraw.font_struct);
 	 }
 	 else{
    		new->ezdraw.font_struct = XLoadQueryFont(XtDisplay(new), "fixed");
 	 }
	get_proportion(new);
		
	 if(!new->ezdraw.historysize)       /* use default pixmap size size for history */
	 	new->ezdraw.historysize = (new->ezdraw.Sheight * new->ezdraw.Swidth) / 20;
	if(new->ezdraw.firstcurve){	/* if set init ID 0 here */
		new->ezdraw.crv[new->ezdraw.nactc].color = new->ezdraw.firstcurve;
		new->ezdraw.crv[new->ezdraw.nactc].id = new->ezdraw.nactc;
		new->ezdraw.nactc++;
		if(new->ezdraw.history)
			create_history (new , 1);
	}
	 
	create_pixmap (new ,  0);		/* create all pixmaps */
    	 Getezdraw_gc(new);		/* create the GC's   */
	 scale(new);			/* scale the widget */
	drawgrid(new);



}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		SetValues
 *  
 *  Input:		Widget curr,Widget requ, Widget new, ArgList args, Cardinal *numargs	
 *
 *  Return:			
 *
 *  Documentation:	Die Funktion wird von Xt als Methode aufgerufen wenn die Applikation 
 * 		  XtSetValue() oder XtSetValues() aufruft. In dieser Funktion wird ber-
 *		  prft ob sich eine Wert der Ressourcen Variablen fr die Widgetklasse
 * 		  gendert hat. Ist dies der Fall werden die davon abhnigen privaten 
  *		  Instanzvariablen neu berechnet.  Wenn sich die Skalierung, der Grid oder
  *		Annotation, bzw. Ezdraw-Richtung geaendert hat, wird das Widget komplett
  *		neu gezeichnet.
 *	
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
/* ARGSUSED */

static Boolean SetValues ( Widget curr, Widget requ, Widget new, ArgList args, Cardinal *numargs){

  XwEzdrawWidget current = (XwEzdrawWidget) curr;
  XwEzdrawWidget newon   = (XwEzdrawWidget) new;
 
  Boolean rescale = FALSE , regrid = FALSE;
  float *interm;
  XGCValues values;
  XtGCMask valuemask =  GCFont ;
  
  
  	if(newon->ezdraw.pixfactor != current->ezdraw.pixfactor){
	        	if(newon->ezdraw.pixfactor < 1.0)	/* ensure legal value for factor */
			newon->ezdraw.pixfactor = 1.0 ;
		XFreePixmap(XtDisplay(newon),newon->ezdraw.pix);  
		regrid  = TRUE;
		get_proportion(newon);
 		create_pixmap (newon ,  0);		/* create all pixmaps no copy old */
 		regrid = TRUE;
 	}	
  	if(newon->ezdraw.yndecimals != current->ezdraw.yndecimals
  	  || newon->ezdraw.anflag != current->ezdraw.anflag){
		 get_proportion(newon);		/* recalculate visible sizes and starting */
		regrid = TRUE;
	}
	if(newon->ezdraw.history != current->ezdraw.history && newon->ezdraw.history)
		create_history (newon , 1);

	if(newon->ezdraw.xndecimals != current->ezdraw.xndecimals){
   		current->ezdraw.xndecimals =newon->ezdraw.xndecimals;
   		regrid = TRUE;
   	}
 	   
/* set all colors if changed or not into GC */

	XSetForeground(XtDisplay(newon) , newon->ezdraw.gc,newon->primitive.foreground);
	XSetForeground(XtDisplay(newon) , newon->ezdraw.anngc,newon->ezdraw.anncolor);
	XSetForeground(XtDisplay(newon) , newon->ezdraw.gridgc,newon->ezdraw.gridcolor);
	XSetBackground(XtDisplay(newon) , newon->ezdraw.gc,newon->ezdraw.background);
	XSetBackground(XtDisplay(newon) , newon->ezdraw.anngc,newon->core.background_pixel);
	XSetBackground(XtDisplay(newon) , newon->ezdraw.gridgc,newon->ezdraw.background);
		
	/* copy scaling and grid definition over to internal storage, as application might free the array */
	if(newon->ezdraw.vis != current->ezdraw.vis ){
		if(current->ezdraw.vis)
			XtFree((char *)current->ezdraw.vis);
		interm = 	newon->ezdraw.vis;
		newon->ezdraw.vis = (float *)XtMalloc(sizeof(float)*4);	
		memcpy(newon->ezdraw.vis , interm , 4*sizeof(float));
		rescale = TRUE ;
	}
	if(newon->ezdraw.gr != current->ezdraw.gr ){
		if(current->ezdraw.gr)
			XtFree((char *)current->ezdraw.gr);
		interm = newon->ezdraw.gr;	
		newon->ezdraw.gr = (float *)XtMalloc(sizeof(float)*4);	
		memcpy(newon->ezdraw.gr, interm , 4*sizeof(float));
		rescale = TRUE ;
	}
/* check if number of curves to be allocated has increased */
	if(newon->ezdraw.ncurves > current->ezdraw.ncurves){
		newon->ezdraw.crv = (EzCurve *)XtRealloc(
			(char *)newon->ezdraw.crv , newon->ezdraw.ncurves * sizeof(EzCurve));
	}

  /* Prfen ob sich die Fontliste gendert hat */
  	if(newon->ezdraw.font_list != current->ezdraw.font_list){
    		if((current->ezdraw.font_list == NULL) && 
    		     (current->ezdraw.font_struct != NULL))
      			XFreeFont(XtDisplay(current), current->ezdraw.font_struct);
   		
    		if( current->ezdraw.font_list)
      			XmFontListFree(current->ezdraw.font_list);

    		if( newon->ezdraw.font_list == NULL)
     			newon->ezdraw.font_list = 
           			      _XmGetDefaultFontList((Widget) newon, XmLABEL_FONTLIST);
  	 	
   	 	if( newon->ezdraw.font_list != NULL){
     		       newon->ezdraw.font_list = XmFontListCopy(newon->ezdraw.font_list);
     		      _XmFontListGetDefaultFont(newon->ezdraw.font_list,
       			&newon->ezdraw.font_struct);
    		}
    		else
      		     newon->ezdraw.font_struct = XLoadQueryFont(XtDisplay(newon),"fixed");
/* now push font to GC's */      		     
  		values.font = newon->ezdraw.font_struct->fid;
		 XChangeGC(XtDisplay(newon), newon->ezdraw.gc, valuemask, &values);
		 XChangeGC(XtDisplay(newon), newon->ezdraw.anngc, valuemask, &values);
		 XChangeGC(XtDisplay(newon), newon->ezdraw.gridgc, valuemask, &values);
		 get_proportion(newon);		/* recalculate visible sizes and starting */
		regrid = TRUE;
   	}
   	if(newon->ezdraw.	anflag != current->ezdraw.	anflag)
   		regrid = TRUE;
	if(rescale){
/* rescale all and clear pixmap, create grid and copy it into visible */
		scale (newon);		/* new scaling */
 		clear_ezdraw(newon , 1);
		regrid = TRUE;
	}
	if(regrid){
		clear_ezdraw(newon , 2);
		drawgrid(newon);
		copy_pixmaps	( newon , 1);

	}
	if(rescale)
		redrawhistory(newon);	/*  redraw all points if history enabled */

	 Set_clipping(newon);
	 return TRUE;
}





/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	get_proportion
 *
 *
 *  Prototype:	static void get_proportion(XwEzdrawWidget cw);
 *  
 *  Input:		XwEzdrawWidget cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	calculates all sizedependent parameters inside the
 *			widget. Visible part size and position, pixmap sizes 
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void get_proportion(XwEzdrawWidget cw){

  int  len;
  char  annot[40];
  int offset =0;

	offset += (cw->ezdraw.border) ? 2 : 0;
   	cw->ezdraw.Swidth = XtWidth(cw) - offset ;
	cw->ezdraw.Sheight = XtHeight(cw) - offset;
	cw->ezdraw.Sx = cw->ezdraw.Sy = offset/2;
		/* correct illegal annotation-flag combinations */
	
	if(cw->ezdraw.anflag  & (XwEzdrawUpAnno+XwEzdrawDoAnno))
		 cw->ezdraw.Sheight -= (cw->ezdraw.font_struct->ascent 
		   	- cw->ezdraw.font_struct->descent) +2;
	if(cw->ezdraw.anflag  & (XwEzdrawLeAnno | XwEzdrawRiAnno)){
		   sprintf(annot,"% .*f", cw->ezdraw.yndecimals,(cw->ezdraw.vis[2]
		          +cw->ezdraw.vis[3])*10.);
		   len = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot)) +2;
		   cw->ezdraw.Swidth -= len;
		
	}
	if (cw->ezdraw.anflag & XwEzdrawLeAnno)		
	        cw->ezdraw.Sx = len + offset/2;
	if(cw->ezdraw.anflag & XwEzdrawUpAnno)
	        cw->ezdraw.Sy = (cw->ezdraw.font_struct->ascent 
		            - cw->ezdraw.font_struct->descent)+2 + offset/2;
	if(cw->ezdraw.anflag & XwEzdrawDoAnno   
	      ||  cw->ezdraw.anflag & XwEzdrawUpAnno ){
		         cw->ezdraw.Sheight -=    (cw->ezdraw.font_struct->ascent 
		   	- cw->ezdraw.font_struct->descent) / 2;
	}  	    



}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Redisplay
 *
 *
 *  Prototype:	static void Redisplay(Widget w, XEvent *event, Region region);
 *  
 *  Input:		Widget w, XEvent *event, Region region
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	This is the Expose method for X
 *		The region and event parameter are ignored.
 *		actually the active pixmap parts are replotted and the
 *		annotation redrawed
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void Redisplay(Widget w, XEvent *event, Region region){

  XwEzdrawWidget cw = (XwEzdrawWidget) w;
  XwEzdrawCallbackStruct call_value;
 
  /* Prfen ob die Widgetinstanz schon realisiert ist */
 	 if ( !XtIsRealized((Widget)cw) )
		return;
	copy_pixmaps	( cw , 1);
 	 if(cw->ezdraw.expose_callback){
   		 call_value.reason = XmCR_EXPOSE;
    		call_value.event = event;
   		 call_value.fd = -1;
   		 call_value.x_value = (cw->ezdraw.offset_Px -cw->ezdraw.sc.ax) / cw->ezdraw.sc.bx;
   		 call_value.y_max = ( cw->ezdraw.sc.ay - cw->ezdraw.offset_Py   ) / cw->ezdraw.sc.by;
   		 call_value.x_max = (cw->ezdraw.offset_Px + cw->ezdraw.Swidth -cw->ezdraw.sc.ax) / cw->ezdraw.sc.bx;
   		 call_value.y_value= (cw->ezdraw.sc.ay - (cw->ezdraw.offset_Py + cw->ezdraw.Sheight )) / cw->ezdraw.sc.by;
    /* Aufrufen der Callbackliste fr den Exposeevent */
   		 XtCallCallbackList((Widget)cw,cw->ezdraw.expose_callback,&call_value);
 	 }


}



/* ======================================================================= */
/* 
   Funktionsname: QueryGeometry 
   Input:	  Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer
   Beschreibung:  
*/
/* ARGSUSED */

static XtGeometryResult QueryGeometry( Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer){

 
  XtWarning("XwEzdraw: query Geometry.");
  answer->request_mode = (CWWidth | CWHeight);
      answer->width = proposed->width;
/* printf("Query:  %d  --- %d  \n",proposed->width,proposed->height); */

  return XtGeometryNo;
}




/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Resize
 *
 *
 *  Prototype:	static void Resize ( Widget w );
 *  
 *  Input:		Widget w
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	This is a method, called by X whenever the size
 *			of widget was changed. it recreates the pixmaps for
 *			the new size. 
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *          added callback      Sat Jun  7 07:58:49 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void Resize ( Widget w ){

  XwEzdrawWidget cw = (XwEzdrawWidget) w;
  
  XwEzdrawCallbackStruct call_value;

	get_proportion(cw);
	if((cw->ezdraw.Swidth > cw->ezdraw.Pwidth 
	      || cw->ezdraw.Sheight > cw->ezdraw.Pheight)
	      && !cw->ezdraw.history)
	      	return;			/* no action possible */
	if(cw->ezdraw.Swidth > cw->ezdraw.Pwidth 
	      || cw->ezdraw.Sheight > cw->ezdraw.Pheight){
 		create_pixmap (cw ,  0);		/* create all pixmaps copy old */
 		scale (cw);		/* new scaling */
 		clear_ezdraw(cw , 1);
 		drawgrid(cw);
 		redrawhistory(cw);		/*  redraw all points if history enabled */
      	}
      	else{
      		if((cw->ezdraw.offset_Px + cw->ezdraw.Swidth) >= cw->ezdraw.Pwidth
      		   || (cw->ezdraw.offset_Py + cw->ezdraw.Sheight) >= cw->ezdraw.Pheight){
      		   	cw->ezdraw.offset_Px = (cw->ezdraw.Pwidth - cw->ezdraw.Swidth)/2;
     		   	cw->ezdraw.offset_Py = (cw->ezdraw.Pheight - cw->ezdraw.Sheight)/2;
     		}
     	}   
     	 Set_clipping(cw);
 	 if(cw->ezdraw.resize_callback){
   		 call_value.reason = XmCR_RESIZE;
    		 call_value.event = NULL;
   		 call_value.fd = -1;
   		 call_value.x_value = (cw->ezdraw.offset_Px -cw->ezdraw.sc.ax) / cw->ezdraw.sc.bx;
   		 call_value.y_max = ( cw->ezdraw.sc.ay - cw->ezdraw.offset_Py   ) / cw->ezdraw.sc.by;
   		 call_value.x_max = (cw->ezdraw.offset_Px + cw->ezdraw.Swidth -cw->ezdraw.sc.ax) / cw->ezdraw.sc.bx;
   		 call_value.y_value= (cw->ezdraw.sc.ay - (cw->ezdraw.offset_Py + cw->ezdraw.Sheight )) / cw->ezdraw.sc.by;
    /* Aufrufen der Callbackliste fr den Resizeevent */
   		 XtCallCallbackList((Widget)cw,cw->ezdraw.resize_callback,&call_value);
 	 }

}




/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		Destroy
 *  
 *  Input:			Widget w 
 *
 *  Return:			
 *
 *  Documentation:		Method, called when the widget is destroyed
 *			(not called during termination and quitting
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Destroy(Widget w ){
  XwEzdrawWidget cw = (XwEzdrawWidget) w;
  int i;
	if(cw->ezdraw.addtext)
  		free( cw->ezdraw.addtext);
  	cw->ezdraw.addtext = NULL;
  	XFreeGC(XtDisplay( cw), cw->ezdraw.gc);
  	  XFreeGC(XtDisplay( cw), cw->ezdraw.anngc);
   	  XFreeGC(XtDisplay( cw), cw->ezdraw.gridgc);
  	  XFreeGC(XtDisplay( cw), cw->ezdraw.clipgc);
  	 cw->ezdraw.gc = NULL;
  	 cw->ezdraw.anngc = NULL;
  	  cw->ezdraw.gridgc = NULL;
  	 cw->ezdraw.clipgc = NULL; 
	/* XmFontListFree(cw->ezdraw.font_list); */
	XFreePixmap(XtDisplay(cw), cw->ezdraw.pix);
  	XFreePixmap(XtDisplay(cw), cw->ezdraw.pannoX);
  	XFreePixmap(XtDisplay(cw), cw->ezdraw.pannoY);
  	cw->ezdraw.pix = 0;
  	 cw->ezdraw.pannoX= 0;
  	 cw->ezdraw.pannoY= 0;
	XtFree((char *)cw->ezdraw.vis);
	XtFree((char *)cw->ezdraw.gr);
   	for (i=0 ; i< cw->ezdraw.nactc ; i++){
		 if(cw->ezdraw.crv[i].history.hist )
			 XtFree( (char *)cw->ezdraw.crv[i].history.hist);
	}
 	XtFree((char *)cw->ezdraw.crv);
 	cw->ezdraw.crv = NULL;
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	scale
 *
 *
 *  Prototype:	static void scale(XwEzdrawWidget cw);
 *  
 *  Input:		XwEzdrawWidget cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	does all scaling,construct parameters to calculate from users values 
 *			into pixmap.
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void scale(XwEzdrawWidget cw){
   double width,height;
/*    scaling and pxconversions is lateron:
   	xpix = ezdraw.sc.ax + ezdraw.sc.bx* Xval
   	ypix = (ezdraw.sc.ay - ezdraw.sc.by* Yval);

and when plotting into pixmap  xpix -=    cw->ezdraw.offset_Px
			      ypix -=    cw->ezdraw.offset_Py
respective in visible area:
			       xpix -=    cw->ezdraw.offset_x            
			       ypix -=    cw->ezdraw.offset_y            
*/
 /* assumed, that pixel coords begin with 0 */	
 	width  = cw->ezdraw.Swidth;
 	height = cw->ezdraw.Sheight ;
	
	cw->ezdraw.sc.bx =  width /  cw->ezdraw.vis[1] ;
	cw->ezdraw.sc.ax = width -  cw->ezdraw.sc.bx 
	       *  (cw->ezdraw.vis[0] + cw->ezdraw.vis[1]);
	cw->ezdraw.sc.by = height /  cw->ezdraw.vis[3] ;
	cw->ezdraw.sc.ay = height  -  cw->ezdraw.sc.by  
	      * ( cw->ezdraw.vis[2] + cw->ezdraw.vis[3]) ;
	      
	      
	cw->ezdraw.sc.ay = height +   cw->ezdraw.offset_Py -   cw->ezdraw.sc.ay ;
	cw->ezdraw.sc.ax +=   cw->ezdraw.offset_Px ;
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		select_action_button1
 *  
 *  Input:			Widget w, XEvent *event
 *
 *  Return:			
 *
 *  Documentation:		action routine called at button 1 down
 *			calculation actual visible values and putting
 *			it into callback structure. calling eventally 
 *			user Input callback
 *
 *
 *  History:	initial Sat May 10 09:43:40 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void select_action_button1(Widget w, XEvent *event){
 XwEzdrawWidget  cw = (XwEzdrawWidget) w ;
 XwEzdrawCallbackStruct call_value;
 


    if(cw->ezdraw.input_callback){
    	call_value.reason = XmCR_INPUT;
    	call_value.event = event;
    	call_value.fd = -1;
  	 call_value.x_value = (cw->ezdraw.offset_Px-cw->ezdraw.Sx
  		       +event->xbutton.x -cw->ezdraw.sc.ax) / cw->ezdraw.sc.bx;
   	call_value.y_value = ( cw->ezdraw.sc.ay - cw->ezdraw.offset_Py
   		       +cw->ezdraw.Sy-event->xbutton.y   ) / cw->ezdraw.sc.by;
   	XtCallCallbackList((Widget)cw,cw->ezdraw.input_callback,&call_value);
    }
    
    
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		select_action_2_down
 *			select_action_2_drag
 *  
 *  Input:			Widget w, XEvent *event
 *
 *  Return:		void	
 *
 *  Documentation:		A pair of functions to handle middlemouse dragging.
 *			The cursor position at press is saved, and used to
 *			calculate the movement at dragging.
 *			dragging is done by recalculationg the Px/Py offsets of visible
 *			within the pixmap followed by copypix.
 *			the annotation is moved as well. (Dragging moves
 *			the picture together with the mouse, not the Window!!)
 *
 *			NO Callbacks are used!!!!!!!
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:		Sat Jun  7 07:29:02 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void select_action_2_down(Widget w, XEvent *event){
 XwEzdrawWidget  cw = (XwEzdrawWidget) w ;
	cw->ezdraw.Down_X = (long int)event->xbutton.x;
	cw->ezdraw.Down_Y = (long int)event->xbutton.y;
    
    
}

static void select_action_2_drag(Widget w, XEvent *event){
 XwEzdrawWidget  cw = (XwEzdrawWidget) w ;

	cw->ezdraw.offset_Px +=  cw->ezdraw.Down_X - (long int)event->xbutton.x;
	cw->ezdraw.offset_Py +=  cw->ezdraw.Down_Y - (long int)event->xbutton.y;

	cw->ezdraw.Down_X = event->xbutton.x;
	cw->ezdraw.Down_Y = event->xbutton.y;
	copy_pixmaps	( cw , 1);
    
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		create_pixmap
 *  
 *  Input:			XwEzdrawWidget cw
 *			int flag			if zero initial case, else existing pixmap
 *
 *  Return:			
 *
 *  Documentation:		Assuming, all proportions are calculated, create the
 *			pixmaps for drawing, and if requested, the pixmaps
 *			for annotation. If not initial case, creates new pixmaps,
 *			but copies the old ones over before destroying th old.
 *
 *
 *  History:		wizant	Sat May 17 08:10:10 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void create_pixmap	(XwEzdrawWidget cw , int flag){
  Dimension width , height , owidth , oheight;
  char annot[32];
  Pixmap opix = 0 , oannox = 0 , oannoy = 0;

	if(flag){				/* save old pixmaps and sizes */
		opix = cw->ezdraw.pix;
		oannox= cw->ezdraw.pannoX;
		oannox= cw->ezdraw.pannoY;
		owidth = cw->ezdraw.Pwidth;
		oheight = cw->ezdraw.Pheight;
	}
	cw->ezdraw.Pwidth = cw->ezdraw.Swidth * cw->ezdraw.pixfactor;
	cw->ezdraw.Pheight = cw->ezdraw.Sheight * cw->ezdraw.pixfactor;
		/* locate drawing(visible) part within pixmap */
	cw->ezdraw.offset_Px = (cw->ezdraw.Pwidth - cw->ezdraw.Swidth) / 2;
	cw->ezdraw.offset_Py = (cw->ezdraw.Pheight - cw->ezdraw.Sheight) / 2;
	

	cw->ezdraw.pix = XCreatePixmap(XtDisplay(cw),
  		RootWindow(XtDisplay(cw), DefaultScreen(XtDisplay(cw))),
  		cw->ezdraw.Pwidth+1, cw->ezdraw.Pheight+1,
  		cw->core.depth);
  	if(flag && opix){
  		XCopyArea(XtDisplay(cw),opix,  cw->ezdraw.pix,
  			 cw->ezdraw.gc, 0,  0 		
  			,  owidth, oheight, (cw->ezdraw.Pwidth - owidth)/2
  			,(cw->ezdraw.Pheight - oheight)/2 ); 
  		XFreePixmap(XtDisplay(cw), opix); 
  	}
	
  	cw->ezdraw.pannoX = cw->ezdraw.pannoY = 0;    /* preset	 to not existing */
  	
/* do this now for y-annot and x annot , each with its charactersize and width, respective height */
	width = height = 0;

		            
	if(cw->ezdraw.anflag  & (XwEzdrawLeAnno | XwEzdrawRiAnno)){
		   sprintf(annot,"% .*f", cw->ezdraw.yndecimals,(cw->ezdraw.vis[2]
		          +cw->ezdraw.vis[3])*10.);
		   width  = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot)) +2;
		   cw->ezdraw.annoWidth = width;
		   height =   cw->ezdraw.Sheight * cw->ezdraw.pixfactor; 
		   cw->ezdraw.pannoY =    XCreatePixmap(XtDisplay(cw),
  		           RootWindow(XtDisplay(cw), DefaultScreen(XtDisplay(cw))),
  		           width+1, height+1,
  		           cw->core.depth); 
  		    if(flag && oannoy){
  		           XCopyArea(XtDisplay(cw),oannoy,  cw->ezdraw.pannoY,
  			 cw->ezdraw.anngc, 0,  0 		
  			,  width, oheight, 0
  			,(cw->ezdraw.Pheight - oheight) /2); 
  		    
  		          XFreePixmap(XtDisplay(cw), oannoy); 
  		          oannoy = 0;
		   }
	}
	 if(cw->ezdraw.anflag  & (XwEzdrawUpAnno | XwEzdrawDoAnno)){  
	      	 width = cw->ezdraw.Swidth * cw->ezdraw.pixfactor;
	      	 height = (cw->ezdraw.font_struct->ascent 
		            - cw->ezdraw.font_struct->descent)+2 ;
		 cw->ezdraw.annoHeight = height;
		   cw->ezdraw.pannoX =    XCreatePixmap(XtDisplay(cw),
  		           RootWindow(XtDisplay(cw), DefaultScreen(XtDisplay(cw))),
  		           width+1, height+1,
  		           cw->core.depth);
  		    if(flag && oannox){
  		           XCopyArea(XtDisplay(cw),oannox,  cw->ezdraw.pannoX,
  			 cw->ezdraw.anngc, 0,  0 		
  			,  owidth, height, (cw->ezdraw.Pwidth - owidth) /2
  			,0); 
  		    
  		          XFreePixmap(XtDisplay(cw), oannox);
  		          oannox = 0; 
		   }
           
	}
		/* free old pixmaps if no new */
	if(flag && oannox)
		 XFreePixmap(XtDisplay(cw), oannox);
	if(flag && oannoy)	
		 XFreePixmap(XtDisplay(cw), oannoy);	            
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		create_history
 *  
 *  Input:			XwEzdrawWidget  cw
 *				int flag		if 0 only new curves
 *  Return:			
 *
 *  Documentation:		Creates ( or recreates) basic history structures
 *			for all allocated curve structures, history buffers
 *			are only created for activated curve structures
 *			if(size of buffer is not the same as given by resource , or if
 *			different from visible diagram pixels size, the buffere is reallocated
 *			old contents is lost;
 *
 *  History:		Sun Apr  6 09:21:54 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  create_history 	(XwEzdrawWidget  cw , int flag){
   int i;
   	
   	for (i=0 ; i< cw->ezdraw.nactc ; i++){
   	     if(!flag || !cw->ezdraw.crv[i].history.hist){
		if(cw->ezdraw.crv[i].history.hist){	/* might be changed */
		    /* clear old contents to a new allocated array  */
		     free(cw->ezdraw.crv[i].history.hist);
		 }

		 cw->ezdraw.crv[i].history.hist 
			 	= (Histpoint *)XtMalloc(sizeof(Histpoint)* cw->ezdraw.historysize);
		cw->ezdraw.crv[i].history.size =  cw->ezdraw.historysize;
		cw->ezdraw.crv[i].history.firstindex = -1;
		cw->ezdraw.crv[i].history.lastindex = 0;
		 memset (cw->ezdraw.crv[i].history.hist,0,sizeof(Histpoint) * cw->ezdraw.historysize);
	      }
	}	 
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Getezdraw_gc
 *
 *
 *  Prototype:	static void Getezdraw_gc(XwEzdrawWidget  cw);
 *  
 *  Input:		XwEzdrawWidget  cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	Creates all needed GC's setting the font to all of them
 *			setting background/foreground colours from resources
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Getezdraw_gc(XwEzdrawWidget  cw){

  XGCValues values;
  XtGCMask mask = GCForeground | GCBackground | GCFont ;
  
  /* Erzeugendes diagram GCs  */
  	values.foreground = cw->primitive.foreground;
  	values.background = cw->ezdraw.background;
  	values.font = cw->ezdraw.font_struct->fid;
  	cw->ezdraw.gc = XCreateGC(XtDisplay(cw),cw->ezdraw.pix, mask, &values);
 /* Erzeugen des annotation GCs  */
  	values.foreground = cw->ezdraw.anncolor;
    	values.background = cw->core.background_pixel;
  	cw->ezdraw.anngc = XCreateGC(XtDisplay(cw),cw->ezdraw.pix, mask, &values);
    /* Erzeugen des grid GCs  */
  	values.foreground = cw->ezdraw.gridcolor;
    	values.background = cw->ezdraw.background;
  	cw->ezdraw.gridgc = XCreateGC(XtDisplay(cw),cw->ezdraw.pix, mask, &values);
	
	clear_ezdraw(cw  , 1);
 
/*   Create the GC for dancevals etc */
   	values.foreground = cw->primitive.foreground;
  	values.background = cw->ezdraw.background;
  	values.font = cw->ezdraw.font_struct->fid;
 	cw->ezdraw.clipgc = XCreateGC(XtDisplay(cw),cw->ezdraw.pix, mask, &values);
 	 Set_clipping(cw);
 
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		Set_clipping
 *  
 *  Input:			XwEzdrawWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		Sets the clipping mask for dancevals and fixtext
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:	Sun Jun  8 08:09:33 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Set_clipping (XwEzdrawWidget  cw){
  XRectangle   clip;
  
  
  	clip.x = clip.y = 0;
 	clip.width = cw->ezdraw.Swidth;
 	clip.height = cw->ezdraw.Sheight;
	XSetClipRectangles(XtDisplay(cw),cw->ezdraw.clipgc,cw->ezdraw.Sx,cw->ezdraw.Sy
	   ,&clip , 1, Unsorted);
}	
/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		drawgrid
 *  
 *  Input:			XwEzdrawWidget cw
 *
 *  Return:			
 *
 *  Documentation:		Draws the grid into the underlying pixmap
 *			Draws the annotation into the pixmaps
 *
 *
 *  History:		wizant  Sun May 18 08:32:10 CEST 1997
 *     always draw both directions  Sat Jun  7 08:59:01 CEST 1997
 *
 ***************************************************************************
 ***************************************************************************/
static void drawgrid(XwEzdrawWidget cw){
   int ypix , xpix , len , cnt = 0 
        , cheight =  (cw->ezdraw.font_struct->ascent - cw->ezdraw.font_struct->descent);
   float base = cw->ezdraw.gr[2] ;
   char annot[40];


       	do {   	/* ordinate grid */
 		ypix = yPix(cw,base);
      		if( ypix <= cw->ezdraw.Pheight && ypix >= 0){
      			 XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gridgc
      				 ,0,ypix,cw->ezdraw.Pwidth,ypix);
      			if(cw->ezdraw.pannoY && (cnt-- <=0)){
      			       sprintf(annot,"%.*f",cw->ezdraw.yndecimals,base);
       			       len = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot)) ;
       			       XDrawString (XtDisplay(cw),cw->ezdraw.pannoY,cw->ezdraw.anngc
       			         	,cw->ezdraw.annoWidth-len , ypix+cheight/2
       			                ,annot,strlen(annot)); 
       			       cnt = cw->ezdraw.ynthgridanno;
       			}
       		}
      		base += cw->ezdraw.gr[3];
      	}while(ypix >= 0);
      	     base = cw->ezdraw.gr[2] ;
      	     cnt = cw->ezdraw.ynthgridanno+1;
       	     do {   	/* ordinate grid */
 		ypix = yPix(cw,base);
      		if( ypix <= cw->ezdraw.Pheight && ypix >= 0){
      			 XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gridgc
      				 ,0,ypix,cw->ezdraw.Pwidth,ypix);
      			if(cw->ezdraw.pannoY && (cnt-- <=0)){
      			       sprintf(annot,"%.*f",cw->ezdraw.yndecimals,base);
       			       len = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot));
       			       XDrawString (XtDisplay(cw),cw->ezdraw.pannoY,cw->ezdraw.anngc
       			         	,cw->ezdraw.annoWidth-len , ypix +cheight/2
       			         	 ,annot,strlen(annot)); 
       			       cnt = cw->ezdraw.ynthgridanno;
      			}
       		}
      		base -= cw->ezdraw.gr[3];
      	     }while(ypix <= cw->ezdraw.Pheight);
	base = cw->ezdraw.gr[0];
	cnt = 0;
       	do {   				/* abscissa grid */
 		xpix = xPix(cw,base);
      		if( xpix <= cw->ezdraw.Pwidth && xpix >= 0){
      			 XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gridgc
      				 ,xpix,0,xpix,cw->ezdraw.Pheight);
      			if(cw->ezdraw.pannoX && (cnt-- <=0)){
      			       sprintf(annot,"%.*f",cw->ezdraw.xndecimals,base);
       			       len = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot));
       			       XDrawString (XtDisplay(cw),cw->ezdraw.pannoX,cw->ezdraw.anngc
       			         	, xpix - len/2,cheight   ,annot,strlen(annot)); 
       			       cnt = cw->ezdraw.xnthgridanno;
       			}
      				 
      		}
      		base += cw->ezdraw.gr[1];
      	}while(xpix <= cw->ezdraw.Pwidth);
      	     base = cw->ezdraw.gr[0] ;
      	     cnt = cw->ezdraw.xnthgridanno+1;
       	     do {   				/* abscissa grid */
 		xpix = xPix(cw,base);
      		if( xpix <= cw->ezdraw.Pwidth && xpix >= 0){
      			 XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gridgc
      				  ,xpix,0,xpix,cw->ezdraw.Pheight);
      			if(cw->ezdraw.pannoX && (cnt-- <=0) ){
      			       sprintf(annot,"%.*f",cw->ezdraw.xndecimals,base);
       			       len = XTextWidth(cw->ezdraw.font_struct,annot,strlen(annot));
       			       XDrawString (XtDisplay(cw),cw->ezdraw.pannoX,cw->ezdraw.anngc
       			         	, xpix - len/2 ,cheight  ,annot,strlen(annot)); 
       			       cnt = cw->ezdraw.xnthgridanno;
       			}
       		}
      		base -= cw->ezdraw.gr[1];
      	     }while(xpix >= 0);

}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		dancevals
 *  
 *  Input:			XwEzdrawWidget  cw
 *
 *  Return:			
 *
  *  Documentation:	checks if the flag for display values is set
 *			and draws the last value as x/y at above position
 *
 *
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:	Sat Jun  7 09:33:42 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  dancevals(XwEzdrawWidget  cw ){
  int i , ch , xpix,ypix;
  char annot[20];
  
	for (i = 0; i < cw->ezdraw.nactc ; i++){
  	    if(cw->ezdraw.addvalues || cw->ezdraw.crv[i].dance){
  	    	sprintf(annot,"%.*f",cw->ezdraw.yndecimals+1,cw->ezdraw.crv[i].xy[1]);
  	    	ch = (cw->ezdraw.font_struct->ascent - cw->ezdraw.font_struct->descent) ;
		XSetForeground(XtDisplay(cw),cw->ezdraw.clipgc,cw->ezdraw.crv[i].color);  
 		    xpix = xPix(cw,cw->ezdraw.crv[i].xy[0]) 
 		    	- cw->ezdraw.offset_Px + cw->ezdraw.Sx;
  		    ypix =yPix(cw,cw->ezdraw.crv[i].xy[1]) - 2  
  		    	- cw->ezdraw.offset_Py + cw->ezdraw.Sy ;
  	      		    
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->ezdraw.clipgc
       			 ,xpix , ypix ,annot,strlen(annot));
       		 ypix -= ch;
       		 sprintf(annot,"%.*f",cw->ezdraw.xndecimals+1,cw->ezdraw.crv[i].xy[0]);
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->ezdraw.clipgc
       			 ,xpix , ypix ,annot,strlen(annot));       		 
       	   }		 
       	}
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		addtext
 *  
 *  Input:			XwEzdrawWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		adds fixed text to left upper edge
 *			adds per curve fixed text to left upper edge
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  addtext(XwEzdrawWidget  cw ){
  int i , xpix,ypix , cheight = (cw->ezdraw.font_struct->ascent - cw->ezdraw.font_struct->descent)+2;
  	       
   	ypix = cw->ezdraw.Sy + cheight;
	xpix =  cw->ezdraw.Sx;
 	if(cw->ezdraw.addtext){
		XSetForeground(XtDisplay(cw),cw->ezdraw.clipgc,cw->primitive.foreground);
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->ezdraw.clipgc
       			 ,xpix , ypix ,cw->ezdraw.addtext,strlen(cw->ezdraw.addtext));
       		ypix = ypix + cheight;		 
	}
	for (i = 0; i < cw->ezdraw.nactc ; i++){
  	    if(cw->ezdraw.crv[i].fixtext && cw->ezdraw.crv[i].fixtext[0]){
		XSetForeground(XtDisplay(cw),cw->ezdraw.clipgc,cw->ezdraw.crv[i].color);  
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->ezdraw.clipgc
       			 ,xpix , ypix ,cw->ezdraw.crv[i].fixtext,strlen(cw->ezdraw.crv[i].fixtext));
       		ypix = ypix + cheight;		 
	   }
	}
}		      

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		copy_pixmaps
 *  
 *  Input:			XwEzdrawWidget cw
 *			int flag		set to True if annotation to be copied
 *
 *  Return:			
 *
 *  Documentation:		copies the stored pixmap('s) up to screen
 *
 *
 *  History:		wizant	Sun May 18 10:01:43 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void copy_pixmaps(XwEzdrawWidget cw , int flag){

  /* Prfen ob die Widgetinstanz schon realisiert ist */
 	 if ( !XtIsRealized((Widget)cw) )
		return;


	XCopyArea(XtDisplay(cw),  cw->ezdraw.pix,XtWindow(cw) , cw->ezdraw.gc
			, cw->ezdraw.offset_Px,  cw->ezdraw.offset_Py 		
  			,  cw->ezdraw.Swidth,  cw->ezdraw.Sheight
  			, cw->ezdraw.Sx , cw->ezdraw.Sy ); 
  		dancevals(cw);
		addtext (cw);
			
  			
  			
	if(!flag)			/* if no annot copy set, just return */
		return;
	if(cw->ezdraw.pannoY ){
		if(cw->ezdraw.anflag & XwEzdrawLeAnno)
			XCopyArea(XtDisplay(cw),  cw->ezdraw.pannoY,XtWindow(cw) 
			   	, cw->ezdraw.anngc
			   	, 0,  cw->ezdraw.offset_Py 		
  			   	,  cw->ezdraw.annoWidth,  cw->ezdraw.Sheight
  			   	, 0 , cw->ezdraw.Sy ); 
		else
			XCopyArea(XtDisplay(cw),  cw->ezdraw.pannoY,XtWindow(cw) 
			   	, cw->ezdraw.anngc
				, 0,  cw->ezdraw.offset_Py 		
  				,  cw->ezdraw.annoWidth,  cw->ezdraw.Sheight
  				, cw->ezdraw.Swidth+1 , cw->ezdraw.Sy ); 
	}
	if(cw->ezdraw.pannoX ){
		if(cw->ezdraw.anflag & XwEzdrawUpAnno)
			XCopyArea(XtDisplay(cw),  cw->ezdraw.pannoX,XtWindow(cw) 
				, cw->ezdraw.anngc
				,  cw->ezdraw.offset_Px , 0		
  				,  cw->ezdraw.Swidth,  cw->ezdraw.annoHeight
  				,  cw->ezdraw.Sx , 0 ); 
		else
			XCopyArea(XtDisplay(cw),  cw->ezdraw.pannoX,XtWindow(cw) 
				, cw->ezdraw.anngc
				,  cw->ezdraw.offset_Px , 0 		
  				,  cw->ezdraw.Swidth,  cw->ezdraw.annoHeight
  				,  cw->ezdraw.Sx , cw->ezdraw.Sheight +1  ); 
	}

}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		 clear_ezdraw
 *  
 *  Input:			XwEzdrawWidget cw
 *			int flag			if == 1  clears pixmap
 *
 *  Return:			
 *
 *  Documentation:		clears pixmap and annotation pixmaps to background
 *			clour.
 *
 *
 *  History:		wizant    Sun May 18 08:33:42 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void clear_ezdraw(XwEzdrawWidget cw , int flag){
   Dimension width = cw->ezdraw.Pwidth , height = cw->ezdraw.Pheight;

	  /* Prfen ob die Widgetinstanz schon realisiert ist */
 	 if ( XtIsRealized((Widget)cw)  && (flag & 2)){
		 XClearArea(XtDisplay(cw), XtWindow(cw), 0, 0, XtWidth(cw)
 			, XtHeight(cw), FALSE);    
 
 	}
  	XSetForeground(XtDisplay(cw),cw->ezdraw.gc,cw->ezdraw.background);
     	XSetForeground(XtDisplay(cw),cw->ezdraw.anngc,cw->core.background_pixel);
	if (flag & 1){	/* clear pixmap and annot */
 	     	XFillRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc,
		    0,0,width,height);
		if(cw->ezdraw.border){
  		     XSetForeground(XtDisplay(cw),cw->ezdraw.gc,cw->primitive.foreground);
  		        XDrawRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
  		        , 0,0,width,height);
  		}
	}	  
 	if(cw->ezdraw.pannoX)
	            XFillRectangle(XtDisplay(cw),cw->ezdraw.pannoX,cw->ezdraw.anngc,
		    0,0,width,cw->ezdraw.annoHeight);
 	if(cw->ezdraw.pannoY)
	            XFillRectangle(XtDisplay(cw),cw->ezdraw.pannoY,cw->ezdraw.anngc,
		    0,0,cw->ezdraw.annoWidth,height);
       	XSetForeground(XtDisplay(cw),cw->ezdraw.anngc,cw->ezdraw.anncolor);
  



}




/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		addhistory
 *  
 *  Input:			Ezdrawhistory *hist		history structure
 *			 float xy[]		abscissa and ordinate
 * 
 *  Return:			
 *
 *  Documentation:		maintains the history pointers and adds a pair of data
 *
 *
 *  History:		Sun Apr  6 15:42:22 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  addhistory   (Ezdrawhistory *hist, float xy[] , char symb,char flag){

	if(!hist->hist)
		return;	/* no history, ignore */
	if(++hist->lastindex >= hist->size){
		hist->lastindex = 0;
		hist->firstindex = 1 ;
	}
	if(hist->firstindex >= 0 && ++hist->firstindex >= hist->size)
			 hist->firstindex= 0;
	memcpy(hist->hist[hist->lastindex].xy , xy , 2*sizeof(float));	
	hist->hist[hist->lastindex].connflag = flag & ~1;	
	hist->hist[hist->lastindex].symb = symb; 
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		ez_plot
 *  
 *  Input:			XwEzdrawWidget cw
 *			int ix , int iy		Pixmap coordinates
 *			 int flag			0(2) lineplot  etc...
 *			char symb		if flag == 4  used to define the
 *						symbol (values 1 to 33
 *						or capital A to Z
 *  Return:			
 *
 *  Documentation:		does the actual plotting into pixmap
 *			started with line plot
 *			point, symbol etc will be added later
 *			point (symbol plotting added 6x6 pixel size
 *  	    As this function is seldom used, the arrays will be created when used
 *
 *  History:		wizant   Sun May 18 14:37:38 CEST 1997
 *		symbols added Sat Jun 21 07:51:43 CEST 1997
 *
 ***************************************************************************
 ***************************************************************************/
static void ez_plot(XwEzdrawWidget cw, int ID , int ix , int iy , int flag,char symb){
  char charsymb[4];
  
 	 XSetForeground(XtDisplay(cw),cw->ezdraw.gc,cw->ezdraw.crv[ID].color);
   	 if(cw->ezdraw.crv[ID].init++){	/*  line plot */
   	     if(!flag || (flag & XwEzdrawLinePlot))  	       
      		XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,xPix(cw,cw->ezdraw.crv[ID].xy[0])
      			,yPix(cw,cw->ezdraw.crv[ID].xy[1])
      			,ix,iy);
 	}	
      	
      	if( (flag & XwEzdrawSymbPlot) && symb){	/* requested symbol plot */
      	     	switch (symb){
     	     	    case  2 :   case 'J'   :
      	     	    XFillRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6);
      	     	    case 1:  case 'A':
      	     	    XDrawRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6);
      	     	    break;
      	     	    case  4 :   case  'K'  :
      	     	    XFillArc(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6 , 0,33040); 
      	     	    case  3 :   case   'B' :
      	     	    XDrawArc(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6 , 0,33040); 
      	     	    break;
     	     	    case 6  :   case  'L'  :
    	    	    {
    	    	       XPoint triup[5] = {{0,0},{3,3},{-6,0},{3,-6},{3,6}};
     	     	    	    triup[0].x = ix;
     	     	    	    triup[0].y = iy;
      	     	    	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    	,triup,5,Convex,CoordModePrevious);
      	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,triup,5,CoordModePrevious);
		    }
		    break;
     	     	    case  5 :   case  'C'  :
    	    	    {
    	    	       XPoint triup[5] = {{0,0},{3,3},{-6,0},{3,-6},{3,6}};
       	     	    	triup[0].x = ix;
     	     	    	triup[0].y = iy;
      	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,triup,5,CoordModePrevious);
		    }	    	     	    
     	     	    break;
      	     	    case  8 :   case  'M'  :
		    {
    	    	       XPoint trido[5] = {{0,0},{-3,-3},{6,0},{-3,6},{-3,-6}};
         	     	    trido[0].x = ix;
     	         	    trido[0].y = iy;
      	         	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	        	    	,trido,5,Nonconvex,CoordModePrevious);      	     	    
       	     	    	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    	,trido,5,CoordModePrevious);
      	     	    }
		    break;
       	     	    case  7 :   case  'D'  :
		    {
    	    	       XPoint trido[5] = {{0,0},{-3,-3},{6,0},{-3,6},{-3,-6}};
      	     	    	trido[0].x = ix;
     	     	    	trido[0].y = iy;
       	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    		,trido,5,CoordModePrevious);
		    }
      	     	    break;	    	     	       	     	    
       	     	    case  10 :   case   'N' :
		    {
    	    	    	XPoint trile[5] = {{0,0},{-3,0},{6,-3},{0,6},{-6,-3}};
     	     	    	    trile[0].x = ix;
     	     	    	    trile[0].y = iy;
      	     	    	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,trile,5,Convex,CoordModePrevious);      	     	    
      	     	    }
      	     	    break;
      	     	    case 9  :   case  'E'  :
		    {
    	    	    	XPoint trile[5] = {{0,0},{-3,0},{6,-3},{0,6},{-6,-3}};
           	    	trile[0].x = ix;
     	     	    	trile[0].y = iy;
       	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,trile,5,CoordModePrevious);
		    }	    	     	       	     	    
	     	    break;
       	     	    case  12 :   case  'O'  :
		    {
    	    	    	XPoint triri[5] = {{0,0},{3,0},{-6,-3},{0,6},{6,-3}};
     	     	    	    triri[0].x = ix;
     	     	    	    triri[0].y = iy;
      	     	    	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	       ,triri,5,Nonconvex,CoordModePrevious);      	     	    
         	     	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,triri,5,CoordModePrevious);	    	     	       	     	    
     	     	    }
		    break;
     	     	    case  11 :   case  'F'  :
		    {
    	    	    	XPoint triri[5] = {{0,0},{3,0},{-6,-3},{0,6},{6,-3}};
      	     	    	triri[0].x = ix;
     	     	    	triri[0].y = iy;
        	     	   XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,triri,5,CoordModePrevious);	    	     	       	     	    
    	     	    }
      	     	    break;
      	     	    case  14 :   case   'P' :
		    {
    	    	    	XPoint diamo[6] = {{0,0},{-3,0},{3,3},{3,-3},{-3,-3},{-3,3}};
     	     	    	    diamo[0].x = ix;
     	     	    	    diamo[0].y = iy;
      	     	    	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    	,diamo,6,Convex,CoordModePrevious);
		    }
      	     	    case  13  :   case   'G' :
		    {
    	    	    	XPoint diamo[6] = {{0,0},{-3,0},{3,3},{3,-3},{-3,-3},{-3,3}};
     	     	    	diamo[0].x = ix;
     	     	    	diamo[0].y = iy;
      	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,diamo,6,CoordModePrevious);
		    }
      	     	    break;
      	     	    case  16 :   case 'Q'   :
		    {
    	    	    	XPoint ddiamov[7] = {{0,0},{-3,3},{6,0},{-3,-3},{3,-3},{-6,0},{3,3}};
     	     	       ddiamov[0].x = ix;
     	     	       ddiamov[0].y = iy;
      	     	      	XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	      	,ddiamov,7,Convex,CoordModePrevious);
        	     	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	,ddiamov,7,CoordModePrevious);
      	     	    }
		    break;
      	     	    case  15 :   case  'H'  :
		    {
    	    	    	XPoint ddiamov[7] = {{0,0},{-3,3},{6,0},{-3,-3},{3,-3},{-6,0},{3,3}};
     	     	    ddiamov[0].x = ix;
     	     	    ddiamov[0].y = iy;
        	     	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	,ddiamov,7,CoordModePrevious);
   	     	    }
      	     	    break;
      	     	    case  18 :   case  'R'  :
		    {
    	    	    	XPoint ddiamoh[7] = {{0,0},{-3,3},{0,-6},{3,3},{3,-3},{0,6},{-3-3}};
     	     	    	    ddiamoh[0].x = ix;
     	     	    	    ddiamoh[0].y = iy;
      	     	    	    XFillPolygon(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    	,ddiamoh,7,Convex,CoordModePrevious);
        	     	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,ddiamoh,7,CoordModePrevious);
		    }
		    break;	
      	     	    case  17 :   case  'I'  :
		    {
    	    	    	XPoint ddiamoh[7] = {{0,0},{-3,3},{0,-6},{3,3},{3,-3},{0,6},{-3-3}};
       	     	    	    ddiamoh[0].x = ix;
     	     	    	    ddiamoh[0].y = iy;
        	     	    XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    	,ddiamoh,7,CoordModePrevious);
    	     	    }
      	     	    break;
       	     	    case 23  :   case  'U'  :  case  24 :
		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix,iy-3,ix,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy,ix+3,iy);
   			
       	     	    case 19  :   case  'S'  :  case  20 :
		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy-3,ix+3,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix+3,iy-3,ix-3,iy+3);
		    
     	     	    break;
        	     	    case 21  :   case  'T'  :  case 22  :
		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix,iy-3,ix,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy,ix+3,iy);
   			
      	     	    break;
       	     	    case  25 :   case  'V'  :  case 26  :
  		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy-3,ix+3,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix+3,iy-3,ix-3,iy+3);
     	     	    XDrawRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6);
     	     	    
      	     	    break;
       	     	    case  27 :   case  'W'  :  case 28  :
       	     	    XDrawRectangle(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6);
  		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix,iy-3,ix,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy,ix+3,iy);
   	     	    
      	     	    break;
       	     	    case 29  :   case  'X'  :  case  30 :
 		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy-3,ix+3,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix+3,iy-3,ix-3,iy+3);
        	     	    XDrawArc(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6 , 0,33040); 
    	     	    
      	     	    break;
       	     	    case  31 :   case  'Y'  :  case 32  :
 		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix,iy-3,ix,iy+3);
   		    XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			,ix-3,iy,ix+3,iy);
      	     	    XDrawArc(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	       ,ix-3,iy-3,6,6 , 0,33040); 
      	     	    
      	     	    break;
       	     	    case 33  :   case  'Z'  :  case  34 :
    	    	    {
    	    	       XPoint diamo[6] = {{0,0},{-3,0},{3,3},{3,-3},{-3,-3},{-3,3}};

 		    	XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			    ,ix,iy-3,ix,iy+3);
   		    	XDrawLine(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      			    ,ix-3,iy,ix+3,iy);
     	     	    	diamo[0].x = ix;
     	     	    	diamo[0].y = iy;
      	     	    	XDrawLines(XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
      	     	    	    ,diamo,6,CoordModePrevious);
     	     	    }
      	     	    break;
   	     	
      	     	}
      	     }
      	if( (flag & XwEzdrawCharPlot) && symb){	/* requested character plot */
    	    charsymb[0] = symb;
	    charsymb[1] = 0;
	    iy += (cw->ezdraw.font_struct->ascent - cw->ezdraw.font_struct->descent) / 2;
    	    ix -=  XTextWidth(cw->ezdraw.font_struct,charsymb,strlen(charsymb)) /2;
    	    XDrawString (XtDisplay(cw),cw->ezdraw.pix,cw->ezdraw.gc
       			 ,ix , iy ,charsymb,strlen(charsymb));
	}
	    
	    
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		redrawhistory
 *  
 *  Input:			XwEzdrawWidget cw
 *
 *  Return:			
 *
 *  Documentation:		redraws the plot from stored history
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:	Thu Jun 19 17:33:23 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void redrawhistory(XwEzdrawWidget cw){
  int ID , idx;
  long int ix,iy;
  
         if(!cw->ezdraw.history)		/* existing ezdraw history, so redraw all */
         	return;
            for(ID = 0 ; ID < cw->ezdraw.nactc ; ID++){
  	idx = cw->ezdraw.crv[ID].history.firstindex;
 	if(idx<0)
 	  	 idx = 1;
 	if(idx == cw->ezdraw.crv[ID].history.lastindex 
 	  	 || (cw->ezdraw.crv[ID].history.firstindex < 0
 	  	 	 && !cw->ezdraw.crv[ID].history.lastindex ))
 			continue;
	memcpy(cw->ezdraw.crv[ID].xy , cw->ezdraw.crv[ID].history.hist[idx].xy,
	    	     sizeof(float)*2);
 	while(++idx != cw->ezdraw.crv[ID].history.lastindex){
 	      	if(idx >=  cw->ezdraw.crv[ID].history.size)
 		         idx = 0; 
 	     	ix = xPix(cw,cw->ezdraw.crv[ID].history.hist[idx].xy[0]);
       	     	iy = yPix(cw,cw->ezdraw.crv[ID].history.hist[idx].xy[1]);
       	     	
		ez_plot(cw,  ID ,ix , iy , cw->ezdraw.crv[ID].history.hist[idx].connflag
		   ,cw->ezdraw.crv[ID].history.hist[idx].symb  );
		
	    	memcpy(cw->ezdraw.crv[ID].xy , cw->ezdraw.crv[ID].history.hist[idx].xy,
	    	     sizeof(float)*2);

 	}
           }
}



/**********************************************************************************************
		Public and Conveniance Functions
**********************************************************************************************/

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwCreateEzdraw
 *  
 *  Input:			Widget parent,
 *			 char *name,
 *			ArgList arglist,
 *			Cardinal argcount
 *
 *  Return:		 Widget	
 *
 *  Documentation:		Standeard X- creating routine
 *
 *
 *  History:		Sun May 18 10:06:38 CEST 1997 on host:wizant
 *			
 *
 *
 ***************************************************************************
 ***************************************************************************/
 Widget XwCreateEzdraw( 
                        Widget parent,
                        char *name,
                        ArgList arglist,
                        Cardinal argcount) {
                      
 
   return( (Widget) XtCreateWidget(name, XwEzdrawWidgetClass, parent, arglist, argcount));

 }



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		 XwEzdrawcurve
 *  
 *  Input:			Widget    w
 *			long int ID 		curve ID
 *			float xy[]			value pair of next point
 *			 int flag			flag, describing type of plot,
 *						and forcing pixcopy if lsb on
 *
 *  Return:			
 *
 *  Documentation:		add a point to actual curve, connecting to previous
 *			if flag set to line
 *			 history
 *			doing symbol plot, automove or autorescale
 *
 *
 *  History:		wizant    Sun May 18 14:41:24 CEST 1997
 *	      added autosrolling          Sat Jun  7 07:24:18 CEST 1997
 *	      added autorescale           Sat Jun  7 08:59:38 CEST 1997
 *
 ***************************************************************************
 ***************************************************************************/
void XwEzdrawcurve (Widget    w  , long int ID ,  float xy[] , int flag , char symbol){
   XwEzdrawWidget cw = (XwEzdrawWidget) w;
   long int ix,iy , anno = 0 ;
   char message[100];
   float val;
   
	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawcurve ");
		return ;
	}
 /* first check for correct ID, error if bad */
 	if(ID >= cw->ezdraw.nactc){
 		sprintf(message,"XwEzdrawcurve:   ERROR   given ID: %ld  is not initialized",ID);
 		XtError(message);
 		fprintf(stderr,"%s\n",message);
 	}
 	ix = xPix(cw,xy[0]);
 	iy = yPix(cw,xy[1]);
 	if(ix < 0 || ix > cw->ezdraw.Pwidth || iy < 0 || iy > cw->ezdraw.Pheight){
 		if(cw->ezdraw.autoscroll & XwCEzdrawAutoScal){
/* autorecale: my decision is a symmetric solution , original size *1.25, but expanding to both sides */
 
 		val = cw->ezdraw.vis[1];
		cw->ezdraw.vis[1] *=  AutoScaleFactor;
		cw->ezdraw.vis[0] -= (cw->ezdraw.vis[1] - val) / 2.0;
		val = cw->ezdraw.vis[3];
		cw->ezdraw.vis[3] *=  AutoScaleFactor;
		cw->ezdraw.vis[2] -= (cw->ezdraw.vis[3] - val) / 2.0;
		
		anno = 1;
		scale (cw);		/* new scaling */
 		clear_ezdraw(cw , 1);
 		redrawhistory(cw);	/*  redraw all points if history enabled */
		clear_ezdraw(cw , 0);
		drawgrid(cw);
  		ix = xPix(cw,xy[0]);
 		iy = yPix(cw,xy[1]);
		
		}
 		else{
 		/* outside area, need something */
 fprintf(stderr,"outside pixmap\n");
 			return;
 		}
 	}
 		/*  now check if in visible */
  	  		/* if automove is set, secalcultate the pixmap offsets, to force actual point
  	  		   into plotting area */
  	if((ix < cw->ezdraw.offset_Px || ix > cw->ezdraw.Swidth+cw->ezdraw.offset_Px)
  	   && (cw->ezdraw.autoscroll & XwCEzdrawAutoMove)){
    		      cw->ezdraw.offset_Px += (ix - cw->ezdraw.offset_Px ) /2; 	
		     anno = 1; 
	}
	if( (iy < cw->ezdraw.offset_Py || iy > cw->ezdraw.Sheight+cw->ezdraw.offset_Py)
	   && (cw->ezdraw.autoscroll & XwCEzdrawAutoMove)){	  		   
      		      cw->ezdraw.offset_Py += (iy -  cw->ezdraw.offset_Py )/2;
		     anno = 1; 
 		
  	}
	if(flag & XwEzdrawMovePlot)
	    cw->ezdraw.crv[ID].init = 0;	 
  	ez_plot(cw , ID , ix ,  iy ,  flag & ~1 , symbol);
	memcpy(cw->ezdraw.crv[ID].xy ,xy, 2*sizeof(float));
	addhistory   (&(cw->ezdraw.crv[ID].history) , xy , symbol,flag);
	if(flag & 1 )
		copy_pixmaps(cw , anno);
}





/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwEzdrawAddcurve
 *  
 *  Input:			Widget w
 *			unsigned long int colour
 *
 *  Return:		long int			Curve ID	
 *
 *  Documentation:		adds a curve definition to target widget, initilizes it
 *			and return the ID
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:		Thu Jun 19 16:58:58 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
long int XwEzdrawAddcurve( Widget w , unsigned long int colour){
  XwEzdrawWidget cw = (XwEzdrawWidget) w;

	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawAddcurve ");
		return -1;
	}
	if( cw->ezdraw.nactc >= cw->ezdraw.ncurves) {	/* need no reallocate */
		cw->ezdraw.ncurves += DefaultNcurves ;
		cw->ezdraw.crv = (EzCurve *)XtRealloc(
			(char *)cw->ezdraw.crv ,cw->ezdraw.ncurves * sizeof(EzCurve));
	}
	cw->ezdraw.crv[cw->ezdraw.nactc].color = colour;
	cw->ezdraw.crv[cw->ezdraw.nactc].id = cw->ezdraw.nactc;
	cw->ezdraw.nactc++;
 	if(cw->ezdraw.history)
		create_history 	( cw , 0);
		
	return (cw->ezdraw.nactc -1);	/* return the ID */
		
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwEzdrawClear
 *  
 *  Input:			Widget w
 *  	    	    	    	int flag     if flag != 0   clear only pixmap
 *
 *  Return:			
 *
 *  Documentation:		clears the widget pixmaps, redraws the grid
 *			and clears out the history
 *
 *
 *  History:		wizant    Mon May 19 08:59:00 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
void  XwEzdrawClear(Widget w , int flag){
  XwEzdrawWidget cw = (XwEzdrawWidget) w;
  int i;

	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawClear ");
		return ;
	}

	clear_ezdraw(cw , 1);
	drawgrid( cw);
	   for (i=0 ; i< cw->ezdraw.nactc ; i++){
	      if(cw->ezdraw.history){
		   cw->ezdraw.crv[i].history.firstindex = -1;
		   cw->ezdraw.crv[i].history.lastindex = 0;
		   memset (cw->ezdraw.crv[i].history.hist,0,sizeof(Histpoint)
		   	 * cw->ezdraw.crv[i].history.size);
	       }	 
	      cw->ezdraw.crv[i].init = 0;	 
	    }
 	 if ( !XtIsRealized((Widget)cw) )
		return;
    	if(!flag)
	    copy_pixmaps	( cw , 1);

}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwEzdrawSettext
 *  
 *  Input:			Widget w
 *			int ID 		id of requeseted curve
 *			char *text	set text to display (empty or NULL to rest)
 *
 *  Return:			
 *
 *  Documentation:		sets the per curve text display.
 *			global value text (via resource )is added
 *
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:	Sat Jun  7 09:46:27 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
void XwEzdrawSettext(Widget w, int ID , char *text){
  XwEzdrawWidget cw = (XwEzdrawWidget) w;

	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawSettext ");
		return ;
	}
	if(ID >= cw->ezdraw.nactc || ID < 0) 
		return;
	if(cw->ezdraw.crv[ID].fixtext)
		free(cw->ezdraw.crv[ID].fixtext);
	if(!text ||!strlen(text) ){
		cw->ezdraw.crv[ID].fixtext = NULL;
		return;
	}
	cw->ezdraw.crv[ID].fixtext = strdup(text);
		
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwEzdrawchangecolor
 *  
 *  Input:			Widget w, int ID , Pixel color
 *
 *  Return:			
 *
 *  Documentation:		changes the colour for the selected curve
 *
 *
 *  History:		Sat Jun 14 08:41:11 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
void XwEzdrawchangecolor(Widget w, int ID , Pixel color){
  XwEzdrawWidget cw = (XwEzdrawWidget) w;

	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawchangecolor ");
		return ;
	}
	if(ID >= cw->ezdraw.nactc || ID < 0) 
		return;
	cw->ezdraw.crv[ID].color = color;
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwEzdrawhistory
 *  
 *  Input:			Widget    w
 *			long int ID	requested curve ID
 *			
 *  Output		 float **x		pointer to abscissa array
 *			float **y 		pointer to ordinate array
 *			short int **flg	combined flag for line and symbol
 *			 int *size		usable size of returned array
 *  Return:			
 *
 *  Documentation:		create (malloc)arrays for ordinate and abscissa and returns them
 *			together with the number of point pairs
 *			the user is responsible to free (free() ) the arrays
 *
 *
 *  History:		Sat Jun 14 08:51:56 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
 void XwEzdrawhistory (Widget    w  , long int ID ,  float **x , float **y , short int **flg , int *size){ 
    XwEzdrawWidget cw = (XwEzdrawWidget) w;
    int i=0 , idx;
    float *lx,*ly ;
    short int *lflg;


	if(!cw->ezdraw.crv || !cw->ezdraw.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in  XwEzdrawhistory ");
		return ;
	}
    
	if( !cw->ezdraw.history || !cw->ezdraw.crv[ID].history.size
	    || ID >= cw->ezdraw.nactc)
		return;
	lx = (float *)malloc(sizeof(float) * cw->ezdraw.crv[ID].history.size);
 	ly = (float *)malloc(sizeof(float) * cw->ezdraw.crv[ID].history.size);
	lflg = (short int *)malloc(sizeof(short int) * cw->ezdraw.crv[ID].history.size);
 	idx = cw->ezdraw.crv[ID].history.firstindex;
 	if(idx<0)
 		 idx = 0;
 	do{
 	       lx[i] = cw->ezdraw.crv[ID].history.hist[idx].xy[0];
 	       ly[i] = cw->ezdraw.crv[ID].history.hist[idx].xy[1];
 	       lflg[i] = (cw->ezdraw.crv[ID].history.hist[idx].connflag << 8)
 	                 |  (cw->ezdraw.crv[ID].history.hist[idx].symb);
 	      i++;
  	      if(++idx >=  cw->ezdraw.crv[ID].history.size)
 		idx = 0; 	       
 	}while(idx != cw->ezdraw.crv[ID].history.lastindex);
	*size = i;	
 	*x = lx;
 	*y = ly;
 	*flg = lflg;
 }	


#ifdef __cplusplus
 }
#endif

