/***********************************************************************
   Widgetklasse: XwEzdrawWidgetClass
$Revision: 2.1 $
$Log: WEzdraw.h,v $
Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:23  keidel
initial motif in motion widgets


Revision 1.4  1999/10/21 14:10:18  keidel
change ezdrwaclear to switch on flag, clear only pixmap or screen and pixmap

Revision 1.4  1999/10/21 07:29:12  keidel
change XwEzdrawClear to have flag clearing only pixmap or screen as well

Revision 1.3  1999/10/06 07:43:56  keidel
added character plot to symbolplot

Revision 1.2  1997/10/19 07:23:00  keidel
 change definitions

Revision 1.1  1997/06/22 07:55:38  keidel
Initial revision




    Copyright 1997,  WizAnt Software  
                Jrgen Keidel  
                Bergstrasse 15
                D 85080 Gaimersheim
                Tel: D  08406 379
                E-mail: wizant.keidel@01019freenet.de
     
     Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

                                                                
 ***********************************************************************/

#ifndef __wEzdraw_h
#define __wEzdraw_h

#include <Xm/Xm.h>
#include 			<WEzdrawP.h>
#ifdef __cplusplus
extern "C" {
#endif



/* wEzdraw Callackstruct */
typedef struct {
  int 		reason;
  XEvent 		*event;
  int 		fd;
  float 		x_value;	/* visible window */
  float 		y_value;
 float		x_max;
 float		y_max;
}XwEzdrawCallbackStruct;


externalref WidgetClass XwEzdrawWidgetClass;


/* define set/getargs names  */
#define XwEzdrawLinePlot	2
#define XwEzdrawSymbPlot  4
#define XwEzdrawCharPlot  8     /* use given char, not the symbol */
#define XwEzdrawMovePlot  16    /* no connection, just move */

#define DefaultNcurves	10
#define  XwEzdrawNoAnno	0	/* No ezdraw Annotation */
#define  XwEzdrawLeAnno	2	/* ezdraw or ordinate annotation in parent left */
#define  XwEzdrawRiAnno	4	/* ezdraw or ordinate annotation in parent right  */
#define  XwEzdrawUpAnno	8	/* ezdraw or ordinate annotation in parent up */
#define  XwEzdrawDoAnno	16	/* ezdraw or ordinate annotation in parent down  */

#define  XwCEzdrawAutoNo   0	/* no autoscroll at any */	
#define  XwCEzdrawAutoScal 1	/* rescale and redraw if outside pixmap */
#define  XwCEzdrawAutoMove 2	/* move into visible */

#define  XwCEzdrawAutoscroll	"EzdrawAutoscroll"
#define  XwNezdrawAutoscroll	"ezdrawAutoscroll"
#define  XwCEzdrawBorder		"EzdrawBorder"
#define  XwNezdrawBorder		"ezdrawBorder"
#define  XwCEzdrawCUcolor 	"EzdrawCUcolor"
#define  XwNezdrawCUcolor 	"ezdrawCUcolor"
#define  XwCEzdrawAnnotation 	"EzdrawAnnotation"
#define  XwNezdrawAnnotation 	"ezdrawAnnotation"
#define  XwCEzdrawAnnotColor 	"EzdrawAnnotColor"
#define  XwNezdrawAnnotColor 	"ezdrawAnnotColor"
#define  XwCEzdrawGridColor 	"EzdrawGridColor"
#define  XwNezdrawGridColor 	"ezdrawGridColor"
#define  XwNezdrawGridScale	"ezdrawGridScale"
#define  XwCEzdrawGridScale	"EzdrawGridScale"
#define  XwNezdrawScale		"ezdrawScale"
#define  XwCEzdrawScale		"EzdrawScale"
#define  XwNezdrawAnnotXNdec 	"ezdrawAnnotXNdec"
#define  XwCEzdrawAnnotXNdec 	"EzdrawAnnotXNdec"
#define  XwNezdrawAnnotYNdec 	"ezdrawAnnotYNdec"
#define  XwCEzdrawAnnotYNdec 	"EzdrawAnnotYNdec"
#define  XwNezdrawAnnotXNgrid	"ezdrawAnnotXNgrid"
#define  XwCEzdrawAnnotXNgrid	"EzdrawAnnotXNgrid"
#define  XwNezdrawAnnotYNgrid	"ezdrawAnnotYNgrid"
#define  XwCEzdrawAnnotYNgrid	"EzdrawAnnotYNgrid"
#define  XwNezdrawNcurves		"ezdrawNcurves"
#define  XwCEzdrawNcurves		"EzdrawNcurves"
#define XwNezdrawCurve		"EzdrawCurve"
#define XwCEzdrawCurve		"EzdrawCurve"
#define XwCEzdrawAddvalue	"ezdrawAddvalue"
#define XwNezdrawAddvalue	"EzdrawAddvalue"
#define XwCEzdrawAddtext		"ezdrawAddtext"
#define XwNezdrawAddtext		"EzdrawAddtext"
#define XwCEzdrawHistory		"ezdrawHistory"
#define XwNezdrawHistory		"EzdrawHistory"
#define XwCEzdrawHistorysize	"ezdrawHistorysize"
#define XwNezdrawHistorysize	"EzdrawHistorysize"
#define XwCEzdrawPixFactor	"ezdrawPixFactor"
#define XwNezdrawPixFactor	"EzdrawPixFactor"

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XwCreateEzdraw	() ;
extern long int XwEzdrawAddcurve	();
extern void XwEzdrawcurve 		();   
extern void  XwEzdrawClear		();
extern void XwEzdrawSettext	();
extern void XwEzdrawchangecolor	();
extern void XwEzdrawhistory 	();

#else

extern Widget XwCreateEzdraw( Widget parent,
                        			char *name,
                        			ArgList arglist,
                        			Cardinal argcount) ;
                        
extern long int XwEzdrawAddcurve(Widget    ezdraw,
	      			    unsigned long int colour);
	     
extern void XwEzdrawcurve 	(Widget    w  , long int ID ,  float xy[] , int flag , char symbol);   
extern void  XwEzdrawClear	(Widget w , int flag);
extern void XwEzdrawSettext	(Widget w, int ID , char *text);
extern void XwEzdrawchangecolor	(Widget w, int ID , Pixel color);
extern void XwEzdrawhistory 	(Widget    w  , long int ID ,  float **x , float **y 
				, short int **flg , int *size);


#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _WEzdraw_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
                    
