/***********************************************************************
   Widgetklasse: XwEzdrawWidgetClass
$Revision: 2.1 $
$Log: WEzdrawP.h,v $
Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:12  keidel
initial motif in motion widgets


Revision 1.5  1998/02/07 15:56:55  keidel
due to -fullwarn on IRIX6.4 eliminating unused etc

Revision 1.4  1998/01/22 16:30:38  keidel
 corrected destoy callback, no cbs special at destroy

Revision 1.3  1998/01/09 17:57:45  keidel
changed pixfactor to int

Revision 1.1  1997/06/22 07:55:17  keidel
Initial revision


   Copyright 1997, Jrgen Keidel                 
   
   Copyright 1997, Jrgen Keidel                 
                                                                  
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

                                                               
   
 ***********************************************************************/

#ifndef	_wEzdrawP_h
#define _wEzdrawP_h

#ifndef  DefaultNcurves
#define 	DefaultNcurves	10	/* allocated space for max number of curves 
				per allocation */
#endif

#include <Xm/PrimitiveP.h>
#include <Xm/DrawingAP.h>
#include <WEzdraw.h>

#ifdef __cplusplus
extern "C" {
#endif


/*Ezdrawing  class structure */
#define	AutoScaleFactor	1.25		/* scale changing factor for autrescale */

typedef struct _XwEzdrawClassPart
{
   XtPointer 	extension;   /* Pointer to extension record */
} XwEzdrawClassPart;

/* Full class record declaration for wEzdraw class */

typedef struct _XwEzdrawClassRec {
    CoreClassPart	  	core_class;
    XmPrimitiveClassPart  	primitive_class;
    XwEzdrawClassPart  	ezdraw_class;
} XwEzdrawClassRec, *XwEzdrawWidgeteClass;


externalref XwEzdrawClassRec xwEzdrawClassRec;

typedef struct {
	double		ax;
	double		bx;		/* scaling abscissa */
	double		ay;
	double		by;		/* scaling ordinate */
}EzScale;

typedef struct {
	float xy[2];
	char   connflag;
	char   symb;
	char   spare[2];
   }Histpoint;

typedef struct{
	int	  lastindex;
	int	  firstindex;
	int	  size;
	Histpoint  *hist;
  }Ezdrawhistory;

typedef struct {
	long int 	id;		/* Id of curve */
	Dimension 	oldx;		/* last abscissa position in pixels */
	Dimension 	oldy;		/* last ordinate position in pixels */
	float 		xy[2];		/* last plotted point in original values */
	unsigned 	long color;	/* colour as pixel */
	int		init;		/* while zero, no value stored */
	int		dance;		/* if TRUE draw the value */
	Ezdrawhistory	history;		/* history structure with history space */
	char		*fixtext;		/* if no zero && not empty draw fix text */
	
}EzCurve;



typedef struct _XwEzdrawPart
{
   /* public part */
 	Pixel   		background;	/* color */
   	Pixel   		gridcolor;	/* color of grid*/
   	Pixel   		anncolor;	/* color of annotation*/
 	long int		ncurves;		/* number of curves actually allocated*/
	float		*vis;		/* scaling info of visible part  array min/max  as
					 x y*/
	float		*gr;		/* base and delta    x/y*/
	int		border;		/* flag if curve should be bordered */
	long int  		anflag;		/* flag where annotation , 0 NO
					 (l/d) 2 left down outside 3  right / up outside */	
	int		xndecimals;	/* number of decimals for annotation */
	int		yndecimals;	/* number of decimals for annotation */
	long int		xnthgridanno;	/* annotation every nth gridline abscissa*/
	long int		ynthgridanno;	/* annotation every nth gridline ordinate*/
	unsigned long	firstcurve;	/* colour of first curve */
	int		addvalues;	/* global flag for dancing values */
	int		history;		/* flag for enabled history */
	int		historysize;	/* userdefined memory allocation */
	int		pixfactor;	/* factor for actual pixmap */
	int		autoscroll;	/* scrolling behaviour */
	XmFontList 	font_list;		/* fontlist for annotation */
	XFontStruct 	*font_struct;
  	XtCallbackList 	 expose_callback;
    	XtCallbackList 	 resize_callback;
   	XtCallbackList 	 input_callback;
	char		*addtext;		/* add a global text */

/*  private part */
	EzCurve		*crv;		/* array for storing curve-definitions */
 	Dimension 	Pwidth;
 	Dimension 	Pheight;		/* own pixmap dimensions */
 	Dimension 	Sx;
 	Dimension 	Sy;		/* own visible  start  coordinates  (Screen)*/
 	Dimension	Swidth;
 	Dimension	Sheight;
	long int 		offset_Px;		/* Pixmap offset  */
	long int 		offset_Py;		/* Pixmap offset  */
	Dimension	annoHeight;
	Dimension 	annoWidth;
	
 	long int   	nactc;		/* number of curves active */
/* caution, the following might have to be replaced by double, scaling might run out of 32 bit */	
	int		lastanncnt_x;
	int		lastanncnt_y;
	GC		gc;		/* graphic context */
	GC		anngc;		/* graphic context annotation */
	GC		gridgc;		/* graphic context grid */
	GC		clipgc;		/* graphic context for dancevals */
	Pixmap		pix;		/* pixmap for ezdrawing */
	Pixmap		pannoX;		/* pixmap for ezdrawing abscissa annotation */
	Pixmap		pannoY;		/* pixmap for ezdrawing ordinate annotation */
	EzScale		sc;		/* Scaling to pixels */
	long int    	Down_X;     	/* used for dragging */
	long int    	Down_Y;
	int 		exposed;
}XwEzdrawPart;	

/* Full instance record declaration */

typedef struct _XwEzdrawRec {
    CorePart	     	core;
    XmPrimitivePart  	primitive;
    XwEzdrawPart  		ezdraw;
 } XwEzdrawRec, *XwEzdrawWidget;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XwEzdrawP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

