
/***********************************************************************
   Widgetklasse: XwHistbarWidgetClass

$Revision: 2.1 $

$Log: WHistbar.h,v $
Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:22  keidel
initial motif in motion widgets


Revision 1.2  1998/01/30 17:04:17  keidel
going beta, all functions basically tested

Revision 1.1  1998/01/18 08:03:43  keidel
Initial revision



    Copyright 1998,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel/Fax: D  08406 379
   		E-mail: wizant.keidel@t-online.de
                                                                 
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		Mon Dec 29 13:33:17 CET 1997

 ***********************************************************************/

#ifndef __wHistbar_h
#define __wHistbar_h

#include <Xm/Xm.h>
#include 			<WHistbarP.h>
#ifdef __cplusplus
extern "C" {
#endif



/* wHistbar Callackstruct */
typedef struct {
  int 		reason;
  XEvent 	*event;
  int 		fd;
  Dimension	width;
  Dimension	height;		/* Dimensions of visible Bars Window */
/*  the following are only valid in input callback */  
  float 	time_win;	/* timeposition in window  (horizontal) */
  int	    	id; 	    	/* id of bar */
  float 	time_id;    	/* time of actual bar (vertical down ) */
}XwHistbarCallbackStruct;


externalref WidgetClass XwHistbarWidgetClass;


/* define set/getargs names  */

#define  XwHistbarDefaultHistsize       200	/* Default size of history buffer */
#define  XwHistbarDefaultAngle	    	45	/* Default angle of Time-Axis */
#define  XwHistbarVertical		1
#define  DefaultBarWidth		10	/* Pixel-Size of a bar    */
#define  DefaultBarSize		    	3
#define  DefaultNbars		    	10
#define  XwHistbarNoAnno	    	0	/* No histbar Annotation */
#define  XwHistbarAnno	    	    	1	/* histbar annotation right/left */

#define  XwCHistbarAngle	"HistbarAngle"
#define  XwNhistbarAngle	"histbarAngle"
#define  XwCHistbarBARcolor 	"HistbarBARcolor"
#define  XwNhistbarBARcolor 	"histbarBARcolor"
#define  XwCHistbarAnnotation 	"HistbarAnnotation"
#define  XwNhistbarAnnotation 	"histbarAnnotation"
#define  XwCHistbarAnnotColor 	"HistbarAnnotColor"
#define  XwNhistbarAnnotColor 	"histbarAnnotColor"
#define  XwNhistbarGridScale	"histbarGridScale"
#define  XwCHistbarGridScale	"HistbarGridScale"
#define  XwNhistbarScale	"histbarScale"
#define  XwCHistbarScale	"HistbarScale"
#define  XwNhistbarAnnotTNdec 	"histbarAnnotTNdec"
#define  XwCHistbarAnnotTNdec 	"HistbarAnnotTNdec"
#define  XwNhistbarAnnotYNdec 	"histbarAnnotYNdec"
#define  XwCHistbarAnnotYNdec 	"HistbarAnnotYNdec"
#define  XwNhistbarAnnotTNgrid	"histbarAnnotTNgrid"
#define  XwCHistbarAnnotTNgrid	"HistbarAnnotTNgrid"
#define  XwNhistbarAnnotYNgrid	"histbarAnnotYNgrid"
#define  XwCHistbarAnnotYNgrid	"HistbarAnnotYNgrid"
#define  XwNhistbarNbars	"histbarNbars"
#define  XwCHistbarNbars	"HistbarNbars"
#define  XwNhistbarBar		"histbarBar"
#define  XwCHistbarBar		"HistbarBar"
#define  XwNhistbarAddvalue	"histbarAddvalue"
#define  XwCHistbarAddvalue	"HistbarAddvalue"
#define  XwNhistbarAddtext	"histbarAddtext"
#define  XwCHistbarAddtext	"HistbarAddtext"
#define  XwNhistbarHistory	"histbarHistory"
#define  XwCHistbarHistory	"HistbarHistory"
#define  XwNhistbarHistorysize	"histbarHistorysize"
#define  XwCHistbarHistorysize	"HistbarHistorysize"
#define  XwNhistbarWidth	"histbarWidth"
#define  XwCHistbarWidth	"HistbarWidth"
#define  XwNhistbarSize		"histbarSize"
#define  XwCHistbarSize		"HistbarSize"


/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XwCreateHistbar() ;
extern long int XwHistbarAddbar();
extern void XwHistbarbar ();   
extern void XwHistbarvaluedisplay();
extern void XwHistbarSettext();
extern void XwHistbarchangecolor();
extern void XwHistbarhistory ();
extern float XwHistbarGetValue();
#else

extern Widget XwCreateHistbar(Widget parent,char *name,ArgList arglist,Cardinal argcount) ;
extern long int XwHistbarAddbar(Widget histbar,unsigned long int colour);	     
extern void XwHistbardobar 	(Widget w ,long int ID ,  float xy[] , int push);   
extern void XwHistbarSettext	(Widget cw,int ID , char *text);
extern void XwHistbarchangecolor(Widget cw,int ID , Pixel color);
extern void XwHistbarhistory 	(Widget w ,long int ID , float **x ,float **y ,int *size);
extern float XwHistbarGetValue	(Widget w ,long int ID , float x);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _WHistbar_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
                    
