/***********************************************************************
   Widgetklasse: XwHistbarWidgetClass

$Revision: 2.2 $

$Log: WHistbarP.h,v $
Revision 2.2  2001/11/19 15:22:51  keidel
corrected for duplicate define of ScScale

Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:22  keidel
initial motif in motion widgets


Revision 1.2  1998/01/30 17:04:17  keidel
going beta, all functions basically tested

Revision 1.1  1998/01/18 08:03:43  keidel
Initial revision




   Copyright 1998,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel/Fax: D  08406 379
   		E-mail: wizant.keidel@t-online.de
         
                                                                  
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		Mon Dec 29 13:32:27 CET 1997

   
 ***********************************************************************/

#ifndef	_wHistbarP_h
#define _wHistbarP_h

#ifndef  DefaultNbars
#define 	DefaultNbars	10	/* allocated space for max number of bars 
				per allocation */
#endif

#include <Xm/PrimitiveP.h>
#include <Xm/DrawingAP.h>
#include <WHistbar.h>

#ifdef __cplusplus
extern "C" {
#endif
/*Histbaring  class structure */


typedef struct _XwHistbarClassPart
{
   XtPointer 	extension;   /* Pointer to extension record */
} XwHistbarClassPart;


/* Full class record declaration for wHistbar class */

typedef struct _XwHistbarClassRec {
    CoreClassPart	  	core_class;
    XmPrimitiveClassPart  	primitive_class;
    XwHistbarClassPart  	histbar_class;
} XwHistbarClassRec, *XwHistbarWidgeteClass;


externalref XwHistbarClassRec xwHistbarClassRec;

/*  wHistbar instance record */

#ifndef _ScScale_ 
typedef struct {
	double		ax;
	double		bx;		/* scaling abscissa */
	double		ay;
	double		by;		/* scaling ordinate */
}ScScale;
#define _ScScale_ 
#endif 

typedef struct{
	int	lastindex;
	int	firstindex;
	int	size;
	float	*tim;
	float	*y;
  }Histbarhistory;

typedef struct {
	long int 	id;		/* Id of bar */
	Dimension 	oldx;		/* last abscissa position in pixels */
	Dimension 	oldy;		/* last ordinate position in pixels */
	float		foldx;
	float		foldy;
	float 		lasttim;
	float	 	lasty;		/* last plotted point in original values */
	Dimension	Xpos;		/* bar position in visible window */
	unsigned 	long color;	/* colour as pixel */
	unsigned 	long shadecolor;	/* shadecolour as pixel */
	int		init;		/* while zero, no value stored */
	Histbarhistory	history;		/* history structure with history space */
	char		*fixtext;		/* if no zero && not empty draw fix text */
	
}ScBars;


typedef struct _XwHistbarPart
{
   /* public part */
 	Pixel   	background;	/* color */
   	Pixel   	anncolor;	/* color of annotation*/
   	int		Angle;		/* Angle of history axis (90 to 0 degrees */
 	long int	nbars;		/* number of bars actually allocated*/
 	Dimension	barwidth;	/* size of bar in pixels */
 	int		barfactor;	/* factor * barwidth is bar + space */
	float		*vis;		/* scaling info of visible part  array min/max  as
					 x y*/
	float		*gr;		/* base and delta    x/y*/
	long int  	anflag;		/* flag where annotation , 0 NO , 1 y left, time right */
	int		xndecimals;	/* number of decimals for annotation */
	int		yndecimals;	/* number of decimals for annotation */
	long int	xnthgridanno;	/* annotation every nth gridline abscissa*/
	long int	ynthgridanno;	/* annotation every nth gridline ordinate*/
	unsigned long	firstbar;		/* colour of first bar */
	int		addvalues;	/* global flag for dancing values */
	int		history;		/* flag for enabled history */
	int		historysize;	/* userdefined memory allocation */
	int 	        barnames;   	/* allow setting of bar-names */
	XmFontList 	font_list;		/* fontlist for annotation */
	XFontStruct 	*font_struct;
  	XtCallbackList 	 expose_callback;
    	XtCallbackList 	 resize_callback;
    	XtCallbackList 	 input_callback;

/*  private part */
	ScBars		*bars;		/* array for storing bar-definitions */
 	Dimension 	width;
 	Dimension 	height;		/* own visible dimensions, used for resize */
 	Dimension 	xv;
 	Dimension 	yv;		/* own visible dimensions if outside bar area
 					 start */
 	Dimension	annsiz;		/* size of annotation pixmap */				 
  	Dimension 	pixwidth;
	Dimension 	pixheight;	/* dimensions of pixmap */
 	long int   	nactc;		/* number of bars active */
	double		angle;		/* angle of time-axis in radians */
	float		prevgrid;		/* actual last grid start */
	int		lastanncnt;
	GC		gc;		/* graphic context */
	GC		anngc;		/* graphic context annotation */
	Pixmap		pix;		/* pixmap for histbar */
	Pixmap		panno;		/* pixmap for histbar annotation */
	ScScale		sc;		/* Scaling to pixels */
	int 		exposed;
	double      	Xoffset;
	double      	Yoffset;
}XwHistbarPart;	

/* Full instance record declaration */

typedef struct _XwHistbarRec {
    CorePart	     	core;
    XmPrimitivePart  	primitive;
    XwHistbarPart  	histbar;
 } XwHistbarRec, *XwHistbarWidget;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XwHistbarP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
