/*
   Widgetklasse:	XwRotLabelWidgetClass
      

$Revision: 1.2 $

$Log: WRotLabel.c,v $
Revision 1.2  2002/09/27 15:34:00  keidel
some little adaptions

Revision 1.1  2002/09/24 16:33:07  keidel
added Rotating Label Widget

*/
/*
        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2, or (at your option)
        any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/******************************************************************
   Widgetklasse:	XwRotLabelWidgetClass

   written by: 	WizAnt Software
   		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel: D  08406 379
   		E-mail: wizant.keidel@freenet.de
   		2002
                                                                  
******************************************************************/

/*
	The Widget is based on stuff from the FastLabelWidget written by 
	Gregory M. Messner in the Module  : Xg Widget Set
 
*/


/* 
 *	Description:
 *		This is the source file for a rotatable Motif Label. The
 *		widgets supports the rotation of the label by 1 degree
 *		increments of decrements;
 *
 */



/*
 * These includes are needed to describe the widget
 */
#include <stdlib.h>
#include <math.h>
#include <X11/Xlib.h>
#ifdef _HPUX_SOURCE
#  include <Xm/Xm.h>
#endif 
#include	<Xm/XmP.h>
#include	"WRotLabelP.h"




#define set_point(newbufp,width,height,xt,yt) (newbufp + ((yt+height/2) * width/8))[(xt+width/2)/8] |= (1 << (7 - ((xt+width/2)%8)))
#define xrot(x,y) ((int)((x) * co + (y) * si))
#define yrot(x,y) ((int)((y) * co - (x) * si))



/*
 * Declaration of methods
 */

#ifdef _NO_PROTO
static void Initialize();
static Boolean SetValues();
static void GetValuesHook();
static XtGeometryResult QueryGeometry();
static void Destroy();
static void Resize();
static void ComputeSize();
static void RedrawPixmap();
static void ResizePixmap();
static void Redisplay();

static XFontStruct *GetFontStruct();
static int XwRotateXImage();
static int XwDrawRotatedText();
static void RotateEdges();
static void XwGetImagePosition();
static int XwRotateXImage();

#else
static void Initialize(Widget request,Widget new, ArgList args, Cardinal *num_args);
static Boolean SetValues(Widget cur, Widget req ,Widget new, ArgList args
				, Cardinal *numargs);
static void GetValuesHook(Widget w, ArgList args,Cardinal *num_args);
static XtGeometryResult QueryGeometry(Widget w
	, XtWidgetGeometry *proposed, XtWidgetGeometry *desired);
static void Destroy(Widget w);
static void Resize(Widget w);
static void ComputeSize(XwRotLabelWidget w, Position *x , Position *y 
                       , Dimension *width, Dimension *height);
static void RedrawPixmap(XwRotLabelWidget w);
static void ResizePixmap(Widget w);
static void Redisplay(Widget w, XEvent *event, Region region);

static XFontStruct *GetFontStruct(XmFontList font_list);
static int XwDrawRotatedText(
	XwRotLabelWidget w,
	int degrees,
	char *text);
static int XwRotateXImage(XImage *image, int degrees);
static void RotateEdges(int *x , int *y , int *w , int *h , int iw , int ih 
        , int degrees);
static void XwGetImagePosition(Position *x , Position *y , int alignment 
        , int  font_ascent ,int font_width , int wt , int ht , int degrees);
static int XwRotateXImage(XImage *image, int degrees);

#endif


static XtResource resources[] = {
   { 
    	XmNstring, XmCString, XmRString, sizeof(String),
	XtOffsetOf(XwRotLabelRec, rotlabel.label_string), 
	XmRImmediate, (XtPointer)NULL
    },
    { 
        XmNfontList, XmCFontList, XmRFontList,
        sizeof(((XwRotLabelRec*)NULL)->rotlabel.font_list),
	XtOffsetOf(XwRotLabelRec, rotlabel.font_list),
	XtRString, (XtPointer)XtDefaultFont
    },
    { 
    	XwNRotCenter, XwCRotCenter, XmRAlignment, sizeof(unsigned char),
	XtOffsetOf(XwRotLabelRec, rotlabel.alignment),
	XmRImmediate, (XtPointer)XmALIGNMENT_CENTER
    },
    {
    	XwNrotation, XwCRotation, XmRInt, sizeof(int),
	XtOffsetOf(XwRotLabelRec, rotlabel.rotation),
	XmRImmediate, (XtPointer)0
    },
    {
    	XwNmarginWidth, XwCmarginWidth, XmRInt, sizeof(Dimension),
	XtOffsetOf(XwRotLabelRec, rotlabel.margin),
	XmRImmediate, (XtPointer)0
    },
	
};

XwRotLabelClassRec xwRotLabelClassRec = {
    {
    /* core_class fields */
	/* superclass			*/ (WidgetClass) &xmPrimitiveClassRec,
	/* class_name			*/ "XwRotLabel",
	/* widget_size			*/ sizeof(XwRotLabelRec),
	/* class_initialize		*/ NULL,
	/* class_part_initialize    	*/ NULL,
	/* class_inited			*/ FALSE,
	/* initialize			*/ Initialize,
	/* initialize_hook		*/ NULL,
	/* realize		    	*/ XtInheritRealize,
	/* actions		    	*/ NULL,
	/* num_actions			*/ 0,
	/* resources			*/ resources,
	/* num_resources		*/ XtNumber(resources),
	/* xrm_class			*/ NULLQUARK,
	/* compress_motion		*/ TRUE,
	/* compress_exposure	    	*/ TRUE,
	/* compress_enterleave	    	*/ TRUE,
	/* visible_interest		*/ TRUE,
	/* destroy			*/ Destroy,
	/* resize			*/ NULL,
	/* expose			*/ Redisplay,
	/* set_values			*/ SetValues,
	/* set_values_hook		*/ NULL,
	/* set_values_almost	    	*/ XtInheritSetValuesAlmost,
	/* get_values_hook		*/ GetValuesHook,
	/* accept_focus			*/ NULL,
	/* version			*/ XtVersion,
	/* callback_private		*/ NULL,
	/* tm_table			*/ NULL,
	/* query_geometry		*/ QueryGeometry,
	/* display_accelerator	    	*/ NULL,
	/* extension			*/ NULL
    },

    /* Primitive Class Part */
    {
        ((XtWidgetProc) _XtInherit),           /* border highlight        */
        ((XtWidgetProc) _XtInherit),           /* border_unhighlight      */
        NULL,				       			   /* translations            */
        NULL,                                  /* arm and activate        */
        NULL,                                  /* synthetic resources     */
        0,                                     /* number of syn res       */
        NULL                                   /* extension               */
    },


    /* RotLabel fields */
    {
	0
    }
};


WidgetClass xwRotLabelWidgetClass = (WidgetClass) &xwRotLabelClassRec;


/* 
 *
 * Function:	Initialize()
 *
 * Scope:	static
 *
 * Description:
 *	This function is the Initialize() method for the XwRotLabel widget.
 *
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 * request	XwRotLabelWidget	Widget filled in from resources
 * new		XwRotLabelWidget	Copy of request widget that has
 *					  been potentialy altered by 
 *					  XwRotLabel's superclasses
 *
 *
 * Returns:	void
 *
 *
 */

static void Initialize(Widget trequest,Widget tnew, ArgList args, Cardinal *num_args){

  XGCValues	values;
  XtGCMask	mask;
  XwRotLabelWidget request = (XwRotLabelWidget)trequest;
  XwRotLabelWidget new = (XwRotLabelWidget)tnew;
	/*
	 * 
	 */
	if ( request->rotlabel.label_string != NULL )
	{
		new->rotlabel.my_string = 
			XtNewString(request->rotlabel.label_string);
	   	new->rotlabel.label_string = NULL;
    	}else
		new->rotlabel.my_string = NULL;
 	/*
	 * Get the XFontStruct from the XmFontList
	 */
  	if (new->rotlabel.font_list == NULL){
    		new->rotlabel.font_list =
    		      _XmGetDefaultFontList((Widget) new, XmLABEL_FONTLIST);
  	}
    	new->rotlabel.font = GetFontStruct(new->rotlabel.font_list);

  	if (new->rotlabel.font_list ){
   		new->rotlabel.font_list = XmFontListCopy(new->rotlabel.font_list);
    		_XmFontListGetDefaultFont( new->rotlabel.font_list
			                         , &new->rotlabel.font_struct);
 	}else
    	new->rotlabel.font_struct = XLoadQueryFont(XtDisplay(new), "fixed");
 	 new->rotlabel.font_gc = None;
	new->rotlabel.background = new->core.background_pixel;
	 
	new->rotlabel.foreground  = new->primitive.foreground;
    	if((new->rotlabel.rotation %= 360) < 0)
	    new->rotlabel.rotation += 360;		

	/*
	 * Make a GC for the text
	 */
	mask = GCForeground | GCBackground | GCFont;
	values.foreground = new->rotlabel.foreground;
	values.background = new->rotlabel.background;
	values.font = new->rotlabel.font->fid;
	new->rotlabel.text_gc = XtGetGC((Widget)new, mask, &values);

	/*
	 * Recompute the size of the widget
	 */
	new->rotlabel.text_image = None;
	/*
 	 * Save requested position as center point 
	 */
	new->rotlabel.x = new->core.x;
	new->rotlabel.y = new->core.y;	

	new->rotlabel.redraw = True;
	Resize((Widget)new);
}


/* 
 *
 * Function:	ComputeSize()
 *
 * Scope:	static
 *
 * Description:
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:
 *
 *
 */

static void ComputeSize(XwRotLabelWidget w, Position *x , Position *y 
		   , Dimension *width, Dimension *height){

  int		text_width ;
  XFontStruct     *font = w->rotlabel.font;
  int edgex,edgey,edgew,edgeh,fullsize , size;



	if ( w->rotlabel.my_string != NULL ){
		text_width = XTextWidth(font, w->rotlabel.my_string,
			strlen(w->rotlabel.my_string));
	}else
		text_width = 0;
        fullsize = text_width +  w->rotlabel.margin*2 +2 
                + font->max_bounds.ascent*2;
        edgex = font->max_bounds.ascent;
        edgey = fullsize/2 - (font->max_bounds.ascent)/2  - w->rotlabel.margin*2+2;
        edgew = text_width +  w->rotlabel.margin*3;
        edgeh = (font->max_bounds.ascent)+w->rotlabel.margin*4;
       
	size  = ((fullsize + 7) / 8) * 8;
       
        
	RotateEdges(&edgex , &edgey , &edgew , &edgeh , size ,size 
	     ,w->rotlabel.rotation)   ;     
	XwGetImagePosition( x ,  y , w->rotlabel.alignment 
	     , font->max_bounds.ascent+w->rotlabel.margin*4 
             ,text_width +  w->rotlabel.margin*2, edgew , edgeh , w->rotlabel.rotation);
    	*width = edgew;
 	*height = edgeh;
	w->rotlabel.x_pix = edgex;
   	w->rotlabel.y_pix = edgey;

}


/* 
 *
 * Function:	ResizePixmap()
 *
 * Scope:	static
 *
 * Description:
 *	This function 
 *
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:	void
 *
 */

static void ResizePixmap(Widget ww){
  XwRotLabelWidget w = (XwRotLabelWidget)ww;

	/*
	 * If the pixmap already exists and is the size needed then
	 * draw the string on it and get outa here
	 */
	if(!w->rotlabel.redraw && w->rotlabel.text_image != None)
		return;					
		/*
		 * Free the old pixmap
		 */
		if ( w->rotlabel.text_image != None ){
			/* XFreePixmap(display, w->rotlabel.pix); */
		    XDestroyImage( w->rotlabel.text_image);
			w->rotlabel.text_image = None;
		}

	


		RedrawPixmap(w);
}


/* 
 *
 * Function:	Resize()
 *
 * Scope:	static
 *
 * Description:
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:
 *
 *
 */

static void Resize(Widget ww){
  XwRotLabelWidget w = (XwRotLabelWidget)ww;

	/*
	 * Compute the desired size 
	 */
	w->core.x = w->rotlabel.x;
	w->core.y = w->rotlabel.y;
	ComputeSize(w, &w->core.x ,&w->core.y ,  &w->core.width, &w->core.height);

	/*
	 * recompute_size is True then resize the widget to contain the
	 * string (at a minimum).
	 */

	ResizePixmap(ww);

}


/* 
 *
 * Function:	QueryGeometry()
 *
 * Scope:	static
 *
 * Description:
 *	This function is called to query the preferred geometry of this
 *	instance.
 *
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:	XtGeometryResult
 *
 */

static XtGeometryResult QueryGeometry(Widget w
	, XtWidgetGeometry *proposed, XtWidgetGeometry *desired){
  Dimension	width, height;
  Position x,y;
#define IsBitSet(bit) (proposed->request_mode & bit)
	ComputeSize((XwRotLabelWidget)w,&x , &y , &width, &height);

	desired->width = width;
	desired->height = height;
	desired->request_mode = CWWidth | CWHeight;

	if ( IsBitSet(CWWidth) && proposed->width == desired->width &&
		IsBitSet(CWHeight) && proposed->height == desired->height )
			return(XtGeometryYes);

	if ( desired->width == w->core.width && 
		desired->height == w->core.height )
			return(XtGeometryNo);

	return(XtGeometryAlmost);

#undef IsBitSet
}


/* 
 *
 * Function:	GetValuesHook()
 *
 * Scope:	static
 *
 * Description:
 *	This function 
 *
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:	void
 *
 */

static void GetValuesHook(Widget ww, ArgList args,Cardinal *num_args){
  XwRotLabelWidget w = (XwRotLabelWidget)ww;
  int	i;

     /* We return a copy of the label_string.
     * If the user wants these, we get them from the label widget.
     */
	 
    for ( i = 0; i < *num_args; i++ ){
     /* We return a copy of the label_string.*/
		if ( !strcmp(args[i].name, XmNstring) && w->rotlabel.my_string )
			*((char **)args[i].value) = strdup(w->rotlabel.my_string);
		else if(strcmp(args[i].name, XwNRotcenterx) == 0 )
			*((Position *)args[i].value) = w->rotlabel.x;
		else if(strcmp(args[i].name, XwNRotcentery) == 0 )	
			*((Position *)args[i].value) = w->rotlabel.y;
		else if(strcmp(args[i].name, XwNrotation) == 0 )	
			*((int *)args[i].value) = w->rotlabel.rotation;
		else if(strcmp(args[i].name, XmNalignment) == 0 )	
			*((int *)args[i].value) = w->rotlabel.alignment;
		
		
		
    }	
}

/* 
 *
 * Function:	SetValues()
 *
 * Scope:	static	
 *
 * Description:
 *	SetValues() method for the XwRotLabel widget. 
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 * currnet	Widget
 * request	Widget
 * new		Widget
 *
 *
 * Returns:	Boolean which indicates wether the widget needs to be redrawn.
 *
 *
 */

static Boolean SetValues(Widget tcur, Widget req,Widget tnew, ArgList args
				, Cardinal *numargs){
   XwRotLabelWidget cur = (XwRotLabelWidget)tcur;
   XwRotLabelWidget new = (XwRotLabelWidget)tnew;
   int i , flag =0; 
	new->rotlabel.redraw = False;	 
    for ( i = 0; i < *numargs; i++ ){
    	if ( !strcmp(args[i].name, XmNstring))
	    flag |= 1;
    	else if ( !strcmp(args[i].name, XmNx)){
		new->rotlabel.x = new->core.x;
		new->core.x = new->core.x - (cur->rotlabel.x - cur->core.x);
	}else if ( !strcmp(args[i].name, XmNy)){            
		new->rotlabel.y = new->core.y;	
		new->core.y = new->core.y - (cur->rotlabel.y - cur->core.y);
	}else if ( !strcmp(args[i].name, XwNRotCenter))
		new->rotlabel.redraw = True;
    	else if ( !strcmp(args[i].name, XwNrotation)){
    	if((new->rotlabel.rotation %= 360) < 0)
	    	new->rotlabel.rotation += 360;		
		new->rotlabel.redraw = True;	    
    }else if ( !strcmp(args[i].name, XmNfontList))
	    flag |=2;
    else if ( !strcmp(args[i].name, XmNbackground))
	    flag |=2;
    else if ( !strcmp(args[i].name, XmNbackground))
	    flag |=2;
    }
	/* 
	 * Check for changed label string
	 */
	 
	 if (flag & 1 )
	{
  		XtFree(new->rotlabel.my_string);
		new->rotlabel.my_string = 
			XtNewString(new->rotlabel.label_string);

		new->rotlabel.redraw = True;
		new->rotlabel.label_string = NULL;
	}


		
	/*
	 * Check for changed Font List
	 */
	if ( flag & 2 ){
		
  XGCValues	values;
  XtGCMask	mask;

		/*
		 * Get the XFontStruct from the XmFontList
		 */
		new->rotlabel.font = GetFontStruct(new->rotlabel.font_list);

		mask = GCForeground | GCBackground | GCFont;
		values.foreground = new->primitive.foreground;
		values.background = new->core.background_pixel;
		values.font = new->rotlabel.font->fid;
		XtReleaseGC((Widget)new, new->rotlabel.text_gc);
		new->rotlabel.text_gc = XtGetGC((Widget)new, mask, &values);

		new->rotlabel.redraw = True;
		
	}

	if ( new->rotlabel.redraw  == True )
		Resize(tnew);

	return new->rotlabel.redraw;
}


/* 
 *
 * Function:	Destroy()
 *
 * Scope:	static
 *
 * Description:
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:	void
 *
 *
 */

static void Destroy(Widget ww){

 XwRotLabelWidget w = (XwRotLabelWidget)ww;

	if ( w->rotlabel.my_string != NULL )
		XtFree(w->rotlabel.my_string);

	if ( w->rotlabel.text_gc != None )
		XtReleaseGC((Widget) w, w->rotlabel.text_gc);
	if ( w->rotlabel.font_gc != None )
		XtReleaseGC((Widget) w, w->rotlabel.font_gc);
	if ( w->rotlabel.text_image )
		XDestroyImage( w->rotlabel.text_image);
}


/* 
 *
 * Function:	Redisplay()
 *
 * Scope:	static
 *
 * Description:
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:
 *
 *
 */

static void
Redisplay(Widget ww, XEvent *event, Region region){
  XwRotLabelWidget w = (XwRotLabelWidget)ww;

  Display		*display = XtDisplay(ww);
  Window		win = XtWindow(ww);


	/*
	 * No widget window then get outa here
	 */
	if ( win == None || w->rotlabel.text_image == None)
		return;

	/*
	 * If no label string then we're done here
	 */
	if ( w->rotlabel.my_string == NULL )
		return;


	/*
	 * Do all that's required is to copy the label pixmap 
	 * into the widget window
	 */
 
 	XPutImage(display, win, w->rotlabel.text_gc, w->rotlabel.text_image, 
		w->rotlabel.x_pix, w->rotlabel.y_pix, 0, 0
	 	, w->core.width, w->core.height);


}


/* 
 *
 * Function:	RedrawPixmap()
 *
 * Scope:	static
 *
 * Description:
 *	This function 
 *
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 *
 *
 * Returns:	void
 *
 */

static void RedrawPixmap(XwRotLabelWidget w){

	/*
	 * If no label then we're done here
	 */
	if ( w->rotlabel.my_string == NULL )
		return;

	/*
	 * Draw the text in the pixmap, we'll copy it to the window later
	 */
	
	XwDrawRotatedText(w,
			w->rotlabel.rotation,
			w->rotlabel.my_string);
    	 w->rotlabel.redraw  = False; 
	 Redisplay((Widget)w, NULL, NULL)     ;
}

/* 
    	helpful internal functions  
*/


/************************************************************************
 *
 *   Function Name: XwDrawRotatedText(XwRotLabelWidget wid, int degrees, char *text )
 *
 *   Description: The given text is written into a Pixmap. then the image data
 *   are rotated and the final position calculated.
 *   only the text image is held in the widget structure, the pixmap is freed.
 *   
 *   
 *
 ************************************************************************/

static int XwDrawRotatedText(XwRotLabelWidget wid, 
     int degrees, char *text ){
    
  Pixmap 	bitmap;
  int 		fullsize,  size;
  XGCValues	values;
  char		*image_data;
  int 	    	len = strlen(text);
  Display	*dpy = XtDisplay((Widget)wid);

  int edgex,edgey,edgew,edgeh,textx,texty,text_width;


 
	/*
	 * Get the font ID from the passed GC
	 */
	if ( !XGetGCValues(dpy, wid->rotlabel.text_gc, GCFont, &values) )
		return -1;

	/*
	 * Get the extents info for the text
	 */
         
         
        text_width = XTextWidth(wid->rotlabel.font, wid->rotlabel.my_string,
			strlen(wid->rotlabel.my_string));
        fullsize = text_width  +  wid->rotlabel.margin*2 +2 ;
        fullsize += (wid->rotlabel.font->max_bounds.ascent)*2;
        
        edgex = wid->rotlabel.font->max_bounds.ascent;
        edgey = fullsize/2 - (wid->rotlabel.font->max_bounds.ascent)/2  - wid->rotlabel.margin*2+2;
/* (wid->rotlabel.font->max_bounds.ascent)/2 - wid->rotlabel.margin; */
        edgew = text_width +  wid->rotlabel.margin*2;
        edgeh = (wid->rotlabel.font->max_bounds.ascent )+wid->rotlabel.margin*2;
        
        textx = (wid->rotlabel.font->max_bounds.ascent)+wid->rotlabel.margin;
        texty = fullsize/2 + wid->rotlabel.font->max_bounds.ascent/2;
        
                

 	/*
	 * Create a 1 plane pixmap as a square to render the normal text in 
	 */
 
 	bitmap = XCreatePixmap(dpy, DefaultRootWindow(dpy),fullsize , fullsize, 1);
 	if ( bitmap == None ) 
		return -1;

	/*
	 * Create a 1 plane GC for drawing the text(only once)
	 */
	if ( wid->rotlabel.font_gc == None ){

  		/* 
		 * Create GC against this 1 plane pixmap, we set the
		 * foreground to 1 and the background to 0 because that's
		 * what an XImage expects
		 */
		values.background = 0;
		values.foreground = 1;
 		wid->rotlabel.font_gc = XCreateGC(dpy, bitmap, 
			GCFont | GCForeground | GCBackground, &values);

		if ( wid->rotlabel.font_gc == None ){
			XFreePixmap(dpy, bitmap);
		    	return -1;
		}
	}else
	  	XSetFont(dpy, wid->rotlabel.font_gc, values.font);

  	values.foreground = 0;
	XChangeGC(dpy, wid->rotlabel.font_gc, GCForeground  , &values);
	XFillRectangle(dpy, bitmap,wid->rotlabel.font_gc, 0, 0,fullsize,fullsize);	
  	values.foreground = 1;
	values.line_width = wid->rotlabel.margin;
	XChangeGC(dpy, wid->rotlabel.font_gc, GCForeground | GCLineWidth , &values);

 	/* 
	 * Draw the text into the 1 plane pixmap we just created
	 */
 	XDrawImageString(dpy, bitmap, wid->rotlabel.font_gc, textx 
	, texty , text, len);
	if(wid->rotlabel.margin > 0)
		XDrawRectangle(dpy, bitmap,wid->rotlabel.font_gc
		, edgex+ wid->rotlabel.margin/2,
		edgey+ wid->rotlabel.margin/2
		,edgew - wid->rotlabel.margin/2,edgeh+ wid->rotlabel.margin/2);

	/*
	 * Round the width and height to 8 bit boundries, the rotation
	 * algorithim requires this
	 */
	size  = ((fullsize + 7) / 8) * 8;
	
	/*
	 * Create an XImage to hold the text for rotation, use calloc
	 * becuase we need the bitmap zeroed out (cleared)
	 */
	image_data = (char *)calloc((size * size) / 8, 1);

	wid->rotlabel.text_image = XCreateImage(dpy, DefaultVisual(dpy, 0), 1, 
		XYBitmap, 0, image_data, size, size, 8, 0);

	/*
	 * Now get the text out of the pixmap and put it in the XImage
	 */
	wid->rotlabel.text_image->bitmap_bit_order = MSBFirst;
	wid->rotlabel.text_image->byte_order = MSBFirst;
	wid->rotlabel.text_image->xoffset = 0;
	XGetSubImage(dpy, bitmap, 0, 0, 
		fullsize, fullsize, AllPlanes, XYPixmap, wid->rotlabel.text_image, 0, 0);

	/*
	 * We don't need the pixmap (bitmap) anymore, free it
	 */
	XFreePixmap(dpy, bitmap);

	/*
	 * Now rotate the XImage (that is the text, boys)
	 */

	XwRotateXImage(wid->rotlabel.text_image, degrees);

        RotateEdges(&edgex , &edgey , &edgew , &edgeh , size,size,degrees)   ;     
        
        wid->rotlabel.text_image->width = size;
        wid->rotlabel.text_image->height = size ;
        wid->rotlabel.text_image->bytes_per_line = size  / 8;
        wid->rotlabel.text_image->format = XYBitmap;


 	/* 
	 * Now image the text by using XPutImage with the
	 * image we rotated on the passed drawable
	 */
	return 0;
}







/************************************************************************
 *
 *   Function Name:  XwGetImagePosition(Position *x , Position *y , int alignment 
        , int  font_ascent , int wt , int ht , int degrees)
 *
 *   Description:
 *   using the given values, the final position (in respect to the  center point)
 *   is calulated, so rturning the position to place the image
 *   
 *   
 *
 ************************************************************************/
 
static void XwGetImagePosition(Position *x , Position *y , int alignment 
        , int  font_ascent ,int font_width, int wt , int ht , int degrees){
  double si = sin( ((double)((M_PI * degrees)/ 180.0))) , co = cos((double)((M_PI * degrees)/ 180.0));
        
    	switch (alignment){
     	    case 	XmALIGNMENT_BEGINNING :
/*  center point is left lower edge of first character */	 
    	    	switch ((degrees%360)/90){
    	    	    case 0:
    	    	    	*y-=ht;
                        *x-= font_ascent * si;
    	    	    	break;
    	    	    case 1: 
    	    	    	*y-=ht + font_ascent * co;
    	    	    	*x-=wt ;
    	    	    	break;
    	    	    case 2:
    	    	    	*x-= wt + font_ascent * si;
    	    	    	break;
    	    	    case 3:
                        *y-= font_ascent * co;
    	    	}
    	    	break;
    	    case XmALIGNMENT_CENTER:
/*  center point is center point of the string */	 
    	    	*x -= wt/2;
    	    	*y -= ht/2;	 
    	    	break;
    	    case XmALIGNMENT_END:
/*  center point is right lower edge of last character */	 
    	    	switch ((degrees%360)/90){
    	    	    case 0:
    	    	    	*y-= font_ascent *co ;
    	    	    	*x -= wt;
    	    	    	break;
    	    	    case 1: 
    	    	    	
    	    	    	*x -= font_ascent * si;
    	    	    	break;
    	    	    case 2:
    	    	    	
    	    	    	*y += font_width *si  ; 
     	    	    	break;
    	    	    case 3:
    	    	    	*y -= ht ;
    	    	   	*x -= wt + font_ascent*si ; 
			break;  
    	    	}
    	    	break;
    	}
}     
 
/************************************************************************
 *
 *   Function Name:  RotateEdges(int *x , int *y , int *w , int *h , int iw , int ih , int degrees)
 *
 *   Description:
 *   using the given values, the boundingbox of text is rotated,
 *   so returning the new position and sizes
 *   
 *
 ************************************************************************/
 
 
static void RotateEdges(int *x , int *y , int *w , int *h , int iw , int ih , int degrees){
  double si = sin( ((double)((M_PI * degrees)/ 180.0))) , co = cos((double)((M_PI * degrees)/ 180.0));
  int x1,y1,x2,y2,x3,y3,x4,y4 ;
  int mi1,ma1,mi2,ma2;
  

  x1 = xrot((*x-iw/2) , -*h/2) + iw/2;
  y1 = yrot((*x-iw/2) , -*h/2) + ih/2;
  x2 = xrot((*x-iw/2) , *h/2) + iw/2;
  y2 = yrot((*x-iw/2) , *h/2) + ih/2;
  x3 = xrot((*x+*w -iw/2) , -*h/2) + iw/2;
  y3 = yrot((*x+*w -iw/2) , -*h/2) + ih/2;
  x4 = xrot((*x+*w -iw/2) , *h/2) + iw/2;
  y4 = yrot((*x+*w -iw/2) , *h/2) + ih/2;
 
  if(x1 < x2){
  	mi1 = x1;
	ma1 = x2;
  }else{
  	mi1 = x2;
	ma1 = x1;
  }
   if(x3 < x4){
  	mi2 = x3;
	ma2 = x4;
  }else{
  	mi2 = x4;
	ma2 = x3;
  }
  if(mi2 < mi1)
  	mi1=mi2;
  if(ma2 > ma1)
    ma1=ma2;
	
  *x = mi1;
  *w = ma1 - mi1;
   if(y1 < y2){
  	mi1 = y1;
	ma1 = y2;
  }else{
  	mi1 = y2;
	ma1 = y1;
  }
   if(y3 < y4){
  	mi2 = y3;
	ma2 = y4;
  }else{
  	mi2 = y4;
	ma2 = y3;
  }
  if(mi2 < mi1)
  	mi1=mi2;
  if(ma2 > ma1)
    ma1=ma2;
	
  *y = mi1;
  *h = ma1 - mi1;
}
/************************************************************************
 *
 *   Function Name:  XwRotateXImage(XImage *image, int degrees)
 *
 *   Description:
 *   The given image data are rotated by creating a new buffer and replacing
 *   the old
 *   
 *
 ************************************************************************/
 
static int XwRotateXImage(XImage *image, int degrees){

  register unsigned char 	*bitmap;
  register double si = sin( ((double)((M_PI * degrees)/ 180.0))) , co = cos((double)((M_PI * degrees)/ 180.0));
  int 			width, height;
  register unsigned char 	*newbufp;
  int			nbytes,  saved_nbyterows;

  int y , x ;

	/*
	 * We do not have the capability of rotating bitmaps whose dimensions
	 * are not even multiples of 8 (one byte).  If either of these two
	 * parameters are not a muliple of 8 return with error.
	 */
	width = (int)image->width;
	height = (int)image->height;
	if ( width % 8 || height % 8 ){
		return -1;
	}
	y = -height/2 -1; 


	/*
	 * Set everything up
	 */
	bitmap = (unsigned char *)image->data;

	nbytes  = width * height / 8;
	saved_nbyterows = (width / 8);


	/*
	 *  Try and allocate a buffer to rotate to, if not successful then
	 *  get outa here with an error code
	 */
	if ( !(newbufp = (unsigned char *) calloc(nbytes , 1)))
		return -1;


	    /*
   	     * This outer loop runs once for each horizontal line of bits 
	     * in the original image. The input goes left->right, 
	     * top->bottom, and in the output image it fills rotated bits.
	     */
	while ( height-- > 0 ){
  int			nbyterows = saved_nbyterows;
		y++;
		x=-8-width/2;
		while (nbyterows-- > 0){
  register unsigned int	c = *bitmap++;
			x+=8;
			/*
			 *  As a special case, we don't have to do anything
			 *  if the byte to be set is zero.
			 */		
  			if ( !c )                            
				continue;
	
			if (c & 0x80) set_point(newbufp,image->width,image->height,xrot(x,y)  ,yrot(x,y));
			if (c & 0x40) set_point(newbufp,image->width,image->height,xrot(x+1,y),yrot(x+1,y));
			if (c & 0x20) set_point(newbufp,image->width,image->height,xrot(x+2,y),yrot(x+2,y));
			if (c & 0x10) set_point(newbufp,image->width,image->height,xrot(x+3,y),yrot(x+3,y));
			if (c & 0x08) set_point(newbufp,image->width,image->height,xrot(x+4,y),yrot(x+4,y));
			if (c & 0x04) set_point(newbufp,image->width,image->height,xrot(x+5,y),yrot(x+5,y));
			if (c & 0x02) set_point(newbufp,image->width,image->height,xrot(x+6,y),yrot(x+6,y));
			if (c & 0x01) set_point(newbufp,image->width,image->height,xrot(x+7,y),yrot(x+7,y));
		}
	}

	/*
	 * Now we have copied the entire bitmap in to the newbufp, so link
	 * the modified version back into the user's buffer, freeing the old bitmap.
	 *
	*/
	
	free(image->data);
	image->data = newbufp;
	

	return 0;
}



/* 
 * Function:	GetFontStruct()
 *
 * Scope:	static
 *
 * Description:
 *	This function takes the passed XmFontList and returns a pointer
 *	to an XFontStruct.
 *
 * Argument	Type			Description
 * ------------	-----------------------	-------------------------------------
 * font_list	XmFontList		XmFontList to get the XFontStruct from
 *
 *
 * Returns:	XFontStruct *
 *
 */

static XFontStruct *GetFontStruct(XmFontList font_list){

#if (XmVERSION == 1 && XmREVISION > 0) || XmVERSION > 1
XmFontContext		context;
XmStringCharSet		charset;
static XFontStruct	*font;

	XmFontListInitFontContext(&context, font_list);
	XmFontListGetNextFont(context, &charset, &font);

	/*
	 * Free the XmStringCharSet which was allocated 
	 * by XmFontListGetNextFont()
	 */
	if ( charset != NULL )
		XtFree(charset);

	XmFontListFreeFontContext(context);		

	return font;
#else

	return font_list->font;
#endif
}



/*  public functions   */
/*   convinience routines    */ 

Widget XwCreateRotLabel(Widget parent, char *name, ArgList al, Cardinal ac){

	return XtCreateWidget(name, xwRotLabelWidgetClass, parent, al, ac);
}

/*
    *	XtSetRotValues  is similar to XtSetValue, but checks the given arguments
    *	adding some more (ATTACH left and ATTACH to) to allow internal
    *	size and position changes if a new string, new rotation, new font
    *	,new alignment or new position is given. therefor, the given argist must be big enuf to hold two more arguments!

    PROBLEM:  if the widget was originally created p.e. with ATTACH_SELF, this function
    	      won't solve the problem. It seems, that the Manager-Wiget (parent)
	      blocks the reposition.
*/

void XwSetRotValues(Widget w, ArgList args, Cardinal num_args){
  Cardinal new_num_args = num_args;
  ArgList new_args = args;
  int add_left = False, add_top=False;
  int no_left = False , no_top = False;
    while(num_args--){
      	if(!strcmp(args->name , XmNstring) || 
	    !strcmp(args->name , XwNrotation) ||
	    !strcmp(args->name , XwNRotCenter) ||
	    !strcmp(args->name , XmNfontList))
	    	add_left = add_top = True;
      	else if (!strcmp(args->name , XmNy) )
	    add_top = True;
      	else if (!strcmp(args->name , XmNx))
	    add_left = True;
      	else if (!strcmp(args->name , XmNtopAttachment))
	    no_top = True;
        else if (!strcmp(args->name , XmNleftAttachment))
	    no_left = True;
	args++;
    } 
    if(add_top && !no_top){
          XtSetArg(new_args[new_num_args], XmNtopAttachment ,  XmATTACH_NONE );new_num_args++; 
    }	    
    if(add_left && !no_left){
          XtSetArg(new_args[new_num_args], XmNleftAttachment ,  XmATTACH_NONE );new_num_args++;   
    }
    XtSetValues(w, new_args, new_num_args);
}
  
