/*
   Widgetklasse:	XwRotLabelWidgetClass
      

$Revision: 1.1 $

$Log: WRotLabelP.h,v $
Revision 1.1  2002/09/24 16:33:07  keidel
added Rotating Label Widget

*/
/*
        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2, or (at your option)
        any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/******************************************************************
   Widgetklasse:	XwRotLabelWidgetClass

   written by: 	WizAnt Software
   		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel: D  08406 379
   		E-mail: wizant.keidel@freenet.de
   		2002
                                                                  
******************************************************************/

/*
	The Widget is based on stuff from the FastLabelWidget written by 
	Gregory M. Messner in the Module  : Xg Widget Set
 *
 */



#ifndef _XwRotLabelP_h
#define _XwRotLabelP_h

/*
 * Super Class include
 */
#if XmVersion > 1001
#include <Xm/PrimitiveP.h>
#endif

#include "WRotLabel.h"



#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



/*
 * New fields for the RotLabel widget class record
 */
typedef struct _XwRotLabelClassPart {
     int empty;
} XwRotLabelClassPart;


/*
 * Class record declaration
 */
typedef struct _XwRotLabelClassRec {
	CoreClassPart		core_class;
	XmPrimitiveClassPart    prim_class;
    	XwRotLabelClassPart	rotlabel_class;
} XwRotLabelClassRec;

extern XwRotLabelClassRec xwRotLabelClassRec;


/*
 * Rotation Label instance structure.
 */
typedef struct _XwRotLabelPart {
	/*
	 * Public resources
	 */
 	Pixel   		background;	/* color */
 	Pixel   		foreground;	/* color */
	int			rotation;	/* */
	unsigned char	        alignment;	/* */

	XmFontList		font_list;
	XFontStruct 	        *font_struct;
	String			label_string;	/* */
	Dimension		margin;



	/*
	 * Private resources
	 */
	GC			text_gc;
	XFontStruct		*font;
	GC          	        font_gc;
	String			my_string;	/* */
	XImage      	        *text_image;
	int     		redraw;
	Position    	        x;
	Position    	        y;
	Position    	        x_pix;
	Position    	        y_pix;


} XwRotLabelPart;



/*
 * Full instance record declaration
 */
typedef struct _XwRotLabelRec {
	CorePart	core;
	XmPrimitivePart	primitive;
    	XwRotLabelPart	rotlabel;
} XwRotLabelRec;



#ifdef __cplusplus
}
#endif /* __cplusplus */



#endif /* _XwRotLabelP_h */
/* DON'T ADD STUFF AFTER THIS #endif */

