/*
   Widgetklasse:	XwScrollWidgetClass
      WScroll.c

$Revision: 2.2 $

$Log: WScroll.c,v $
Revision 2.2  2001/11/17 12:30:36  keidel
corrected problem with fontlist at destroy

Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:28  keidel
initial motif in motion widgets


Revision 2.17  2001/02/23 09:03:48  keidel
safely adding default font

Revision 2.16  2000/07/15 09:31:01  keidel
some tests

Revision 2.15  1998/03/07 08:35:24  keidel
correcting for Border, enforce 2 pixels always

Revision 2.14  1998/02/09 16:23:34  keidel
final cleaning (using IRIS -fullwarn on an origin with IRIX 6.4)

Revision 2.13  1998/01/22 16:17:27  keidel
corrected destoy callback, no cbs spewcial at destroy

Revision 2.12  1997/10/12 13:24:12  keidel
added safety messages at mallocs, grid to visible as well

Revision 2.11  1997/10/11 12:39:09  keidel
cleaning up to avoid messages at "cc -pedantic", cleaning destroy method
saving all if widget was destroyed but still used. (Cannot fix access to
destroyed widget via SetValues/GetValues happens prior to my code)

Revision 2.10  1997/06/08 06:21:44  keidel
added clippinmg for dancevals

Revision 2.9  1997/05/24 08:03:08  keidel
correction of mistyped cplusplus

Revision 2.8  1997/05/20 15:25:25  keidel
deactivate highlighOnEnter

Revision 2.7  1997/04/24 15:04:52  keidel
correction for data changes with big abscissa values, rescaling
and regidding

Revision 2.5  1997/04/19 07:27:47  keidel
corrected bug for first data with x much bigger than scale, (X11R5 problem)
beautifying annotation, enforcing no highlight, correcting for border

Revision 2.4  1997/04/16 15:49:04  keidel
switching from annototion to internal annotation, with changing direction left pixmap address without pixmap, corrected

Revision 2.3  1997/04/15 16:25:36  keidel
correction for ansi (print format

Revision 2.2  1997/04/15 16:22:21  keidel
typing correction

Revision 2.1  1997/04/15 16:18:10  keidel
correction for curve-ID outside initialized curves

Revision 2.0  1997/04/13 06:23:54  keidel
added curve history, Input callback and retrieving routines

Revision 1.4  1997/04/03 16:15:46  keidel
correction for ordinate annotation (fixed position)
correction for diagramborder
but still adjustment problem by 1 pixel on vertical scroll left side

Revision 1.2  1997/03/30 05:48:13  keidel
added Revision logging

  
        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2, or (at your option)
        any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/******************************************************************
   Widgetklasse:	XwScrollWidgetClass

   written by: 	WizAnt Software
   		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel/Fax: D  08406 379
   		E-mail: wizant.keidel@01019freenet.de
   		1997
                                                                  
******************************************************************/
/*	History:
	Working version   getting resources, Scrolldirection horizontal, up and down
	Annotation NO inside, left , right , down, up
	displaying actual values and fixed text
	added history and history retrieval
	Fri Mar 21 16:41:21 CET 1997
	Sun Mar 23 09:34:01 CET 1997
	Fri Mar 28 10:08:42 CET 1997
	Sun Apr 13 18:15:25 CEST 1997
	Sun Jun  8 08:18:05 CEST 1997    added clipping for dancevals
*/		
/* include */

#include <stdio.h>
#include <stdlib.h>
#include<Xm/PrimitiveP.h>
#include<Xm/DrawP.h>


#include <WScroll.h>


#ifdef __cplusplus
extern "C"{
#endif

#define offset(field) XtOffsetOf(XwScrollRec, field)
#ifndef strdup
char *strdup(const char *s);
#endif


#define MACRO


#ifdef MACRO

#define xPix(cw,x,y) ((cw->scroll.Sdir) ? \
	(long int)(cw->scroll.sc.ay + cw->scroll.sc.by * y) :\
	((long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x)  \
	- cw->scroll.offset)\
	)
	
#define yPix(cw,x,y) ((!cw->scroll.Sdir) ?\
	(cw->scroll.pixheight - (long int)(cw->scroll.sc.ay + cw->scroll.sc.by * y) ): \
	(cw->scroll.Sdir == XwScrollVertDown) ?\
	((long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x) - cw->scroll.offset) :\
	 (cw->scroll.pixheight + cw->scroll.offset \
	 - (long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x))\
	 )
	 
#define checkrescroll(cw,x,y) (!cw->scroll.Sdir) \
	?(xPix(cw,x,y) >= cw->scroll.pixwidth) \
	?check_rescroll(cw,x,y,1)\
	:0 \
	: (cw->scroll.Sdir == XwScrollVertDown) \
	? (yPix(cw,x,y) >= cw->scroll.pixheight)\
	? check_rescroll(cw,x,y,1)\
	: 0 \
	: (yPix(cw,x,y) <= 0)\
	? check_rescroll(cw,x,y,1)\
	: 0
#endif
	
/****** private Funktions Deklaration ******/
#ifdef _NO_PROTO

/* Deklaration der Methoden */
static void Initialize();
static Boolean SetValues ();
static void Redisplay();
static XtGeometryResult QueryGeometry( );
static void Resize();
static void Destroy(  );

/* Deklaration der privaten Funktionen */
static void get_proportion();
static void Getscroll_gc();
static void clear_scroll();
static void scale();
static void drawgrid();

#ifndef MACRO
static long int xPix();
static long int yPix();
#endif
static int check_rescroll();
static void drawannot();
static void  copyannot();
static void Set_clipping ();
static void  copypix();
static void  dancevals();
static void  addtext();
static void  add_history ();
static void  create_history ();
static void  addhistory ();
static void select_action();
#else

/* Deklaration der Methoden */
static void Initialize		( Widget , Widget , ArgList , Cardinal *);
static Boolean SetValues 		( Widget curr, Widget requ, Widget new, ArgList args
				, Cardinal *numargs);
static void Redisplay		(Widget w, XEvent *event, Region region);
static XtGeometryResult QueryGeometry( Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer);
static void Resize			( Widget );
static void Destroy			( Widget );

/* Deklaration der privaten Funktionen */
static void get_proportion		( XwScrollWidget );
static void Getscroll_gc		( XwScrollWidget  );
static void clear_scroll		(XwScrollWidget , int all);
static void scale			(XwScrollWidget);
static void drawgrid		(XwScrollWidget , int really);

#ifndef MACRO
static long int xPix			(XwScrollWidget , float , float);
static long int yPix			(XwScrollWidget , float , float);
#endif

static int     check_rescroll		(XwScrollWidget , float , float,int );
static void   drawannot		(XwScrollWidget  cw);
static void   copyannot		(XwScrollWidget  cw ,Drawable target, Dimension given);
static void   copypix		(XwScrollWidget  cw ,Drawable target, Dimension given);
static void  dancevals		(XwScrollWidget  cw );
static void  addtext		(XwScrollWidget  cw );
static void  add_history		(XwScrollWidget  cw, long int id);
static void  create_history 		(XwScrollWidget  cw);
static void  addhistory		(Scrollhistory *hist, float xy[]);
static void select_action		( Widget , XEvent *);
static void Set_clipping 		(XwScrollWidget  cw);

#endif /* _NO_PROTO */


/* Definition der Resourcen-Liste */


static XtResource resources[] = {
    {
    	XmNinputCallback,
    	NULL,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(scroll.input_callback),
    	XtRCallback,
    	NULL

  },
  {
    	XmNexposeCallback,
    	XmCExposeCallback,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(scroll.expose_callback),
    	XtRCallback,
    	NULL

  },
 {
    	XmNresizeCallback,
    	XmCResizeCallback,
    	XtRCallback,
    	sizeof(XtPointer),
    	offset(scroll.resize_callback),
    	XtRCallback,
    	NULL

  },
  {
  	XwNscrolldirection,
  	XwCScrolldirection,
  	XtRInt,
  	sizeof(int),
  	offset(scroll.Sdir),
  	XtRImmediate,
  	(XtPointer) 0
  },
   {
  	XwNscrollBorder,
  	XwCScrollBorder,
  	XtRBool,
  	sizeof(int),
  	offset(scroll.border),
  	XtRImmediate,
  	(XtPointer) FALSE
  },
 {
   	XwNscrollGridScale ,
   	XwCScrollGridScale,
  	XtRFloat ,  	  	 
  	sizeof(float *),
  	offset(scroll.gr),	
  	XtRImmediate,
  	NULL
  },
  {
   	XwNscrollScale,
   	XwCScrollScale,
  	XtRFloat ,  	  	 
  	sizeof(float *),
  	offset(scroll.vis),	
  	XtRImmediate,
  	NULL
  },
 {
   	XwNscrollAnnotColor,
   	XwCScrollAnnotColor,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(scroll.anncolor ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
  {
   	XwNscrollGridColor,
   	XwCScrollGridColor,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(scroll.gridcolor ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
{
   	XwNscrollCUcolor ,
   	XwCScrollCUcolor ,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(scroll.background ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
   {
   	XwNscrollAnnotXNdec,
   	XwCScrollAnnotXNdec,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.xndecimals ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
   {
   	XwNscrollAnnotYNdec,
   	XwCScrollAnnotYNdec,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.yndecimals ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
  {
   	XwNscrollAnnotXNgrid,
   	XwCScrollAnnotXNgrid,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.xnthgridanno),	
  	XtRImmediate,
  	(XtPointer) 0
  },
   {
   	XwNscrollAnnotYNgrid,
   	XwCScrollAnnotYNgrid,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.ynthgridanno),	
  	XtRImmediate,
  	(XtPointer) 0
  },
 {
   	XwNscrollNcurves,
   	XwCScrollNcurves,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.ncurves ),	
  	XtRImmediate,
  	(XtPointer) DefaultNcurves
  },
  {
   	XwNscrollAnnotation,
   	XwCScrollAnnotation,
  	XtRInt ,  	  	 
  	sizeof(int),
  	offset(scroll.anflag ),	
  	XtRImmediate,
  	(XtPointer) (XwScrollLeAnno + XwScrollDoAnno)
  },
 {
   	XwNscrollAddvalue,
   	XwCScrollAddvalue,
  	XtRBool ,  	  	 
  	sizeof(int),
  	offset(scroll. addvalues),	
  	XtRImmediate,
  	(XtPointer) FALSE
  },
 {
   	XwNscrollCurve,
   	XwCScrollCurve,
  	XtRPixel ,  	  	 
  	sizeof(Pixel),
  	offset(scroll.firstcurve ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
  {
   	XwNscrollAddtext,
   	XwCScrollAddtext,
  	XtRString ,  	  	 
  	sizeof(char *),
  	offset(scroll.addtext ),	
  	XtRImmediate,
  	(XtPointer) NULL
  },
{
 	XmNfontList,
 	XmCFontList,
 	XmRFontList,
 	sizeof(XmFontList),
 	offset(scroll.font_list),
 	XtRImmediate,
 	NULL
  },
   {
  	XwNscrollHistory,
  	XwCScrollHistory,
  	XtRBool,
  	sizeof(int),
  	offset(scroll.history),
  	XtRImmediate,
  	(XtPointer) FALSE
  },
 {
   	XwNscrollHistorysize,
   	XwCScrollHistorysize,
  	XtRInt,  	  	 
  	sizeof(int),
  	offset(scroll.historysize ),	
  	XtRImmediate,
  	(XtPointer) 0
  },
};
/*Definition der Translation Tabelle */

static char defaultTranslations[] =
  "<Btn1Down>:	select_action()";
   
/* Definition der Aktionen fr die Translation-Tabelle */

static XtActionsRec actions[] = {

   {"select_action", (XtActionProc)select_action},
};


/* Klasseninitialisierung fr die XwScrollClass */

XwScrollClassRec xwScrollClassRec = {
  {
     /* core_Class Felder */
     /* Superklasse		*/ (WidgetClass) & xmPrimitiveClassRec,
     /* Klassenname		*/ "XwScroll",
     /* Widget groesse	*/ sizeof(XwScrollRec),
     /* Class_initialize	*/ NULL,
     /* Class_part_initialize	*/ NULL,
     /* class_inited intern	*/ FALSE,
     /* initialize		*/ Initialize,
     /* initialize_hook (dynami)*/ NULL,
     /* realize	(XCreateWindow)	*/ XtInheritRealize,
     /* actions		*/actions,
     /* Anzahl der Action	*/ XtNumber(actions), 
     /* Resourcen 		*/ resources,
     /* Resourcen anzahl	*/ XtNumber(resources),
     /* xrm_class intern	*/ NULLQUARK,
     /* compressmotion 	*/ TRUE,
     /* compress_exposure	*/ XtExposeCompressMultiple,
     /* compress_enterleave	*/ TRUE,
     /* VisibilityNotify	*/ FALSE,
     /* destroy		*/ Destroy,
     /* resize		*/ Resize,	
     /* expose		*/ Redisplay,
     /* set_values		*/ SetValues,
     /* set_values_hook	*/ NULL,
     /* set_values_almost	*/ XtInheritSetValuesAlmost,
     /* get_values_hook	*/ NULL,
     /* accept_focus		*/ NULL,
     /* version		*/ XtVersion,
     /* callback_private	*/ NULL,
     /* tm_table		*/defaultTranslations,
     /* query_geometry	*/QueryGeometry,
     /* display_accelerator	*/ XtInheritDisplayAccelerator,
     /* extension		*/ NULL
  },
  { /* Primitive_Class felder */
    /* border_highlight	*/ NULL,
    /* border_unhighlight	*/ NULL,
    /* translations		*/ XtInheritTranslations,
    /* arm_and_activate	*/ NULL,
    /* syn resources		*/ NULL,
    /* num_syn_resources	*/ 0,
    /* extension	 	*/ NULL,
  },
  { /* wiscroll_Class felder */
    /* extensions 		*/ NULL,
  },
};

WidgetClass XwScrollWidgetClass = (WidgetClass) &xwScrollClassRec;


static   float defaultscal[4] = {0.0,100.0,0.0,100.0};
static    float  defaultgrid[4] ={0.0,10.0,0.0,10.0};

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Initialize
 *
 *
 *  Prototype:	static void Initialize (Widget treq, Widget tnew, ArgList args,
 *			 Cardinal *num_args);
 *  
 *  Input:		Widget treq, Widget tnew, ArgList args,
 *			Cardinal *num_args
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	Method, called from X, creating the Widget.
 *			The Instances are checked, dependent parameters
 *			calculated from resources, pixmaps and GC's created
 *			initial clearing of pixmaps, and setting the grid
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
 static void Initialize (Widget treq, Widget tnew, ArgList args, Cardinal *num_args)
{
   XwScrollWidget new = (XwScrollWidget) tnew; /* Convert pointer type to Instancerecord */
   float *interm;
  Dimension width,height;

	new->primitive.highlight_thickness = 0;
	if(new->scroll.addtext)
		new->scroll.addtext = strdup(new->scroll.addtext);
	/* copy scaling and grid definition over to internal storage, as application might free the array */
	interm = (float *)XtMalloc(sizeof(float)*4);
	if(!interm  ) 
		XtWarning("WScroll   create   cannot XtMalloc");
	if(new->scroll.vis)
		memcpy(interm, new->scroll.vis , 4*sizeof(float));
	else
		memcpy(interm,  defaultscal , 4*sizeof(float));
	new->scroll.vis = interm;
	interm = (float *)XtMalloc(sizeof(float)*4);
	if(!interm  ) 
		XtWarning("WScroll   create   cannot XtMalloc");
	if(new->scroll.gr	)
		memcpy(interm, new->scroll.gr , 4*sizeof(float));
	else
		memcpy(interm, defaultgrid  , 4*sizeof(float));
	new->scroll.gr = interm;	
	new->scroll.exposed = 0;		/* count to get first exposure */
	new->scroll.lastanncnt = 1;
	new->scroll.lastannot = 0;
/*  create default storage for curves  */
	new->scroll.crv = (ScCurve *)XtMalloc(new->scroll.ncurves * sizeof(ScCurve));
	  if(!new->scroll.crv ) 
		XtWarning("WScroll   create   cannot XtMalloc for curves");
	else
		memset(new->scroll.crv , 0 , new->scroll.ncurves * sizeof(ScCurve));
	
	
	new->scroll.offset = 0;
  /* Wenn keine Fontliste durch Resourcen gesetzt ist,laden die Default-Fontliste */
  	if (new->scroll.font_list == NULL ){
    		new->scroll.font_list =
    		      _XmGetDefaultFontList((Widget) new, XmLABEL_FONTLIST);
  	}
	if( new->scroll.font_list != NULL ){
	    _XmFontListGetDefaultFont(new->scroll.font_list,
       			&new->scroll.font_struct);
	}
	else
    	    new->scroll.font_struct = XLoadQueryFont(XtDisplay(new),"fixed");
 /* set all colours , is not explicitely set, inherit from parent */
	if (new->scroll.background == 0){
	        new->scroll.background = new->core.background_pixel;
	 }
	if(!new->scroll.gridcolor)
		new->scroll.gridcolor  = new->primitive.foreground;

	if(!new->scroll.anncolor)
		new->scroll.anncolor = new->scroll.gridcolor;
	
  /* Die Fonts fr die Fontliste laden */
 	 new->scroll.panno = (Pixmap)NULL;

	get_proportion(new);		/* calculate sizes and starting */
	new->scroll.lastpush =  new->scroll.vis[0] ;
	new->scroll.pix = XCreatePixmap(XtDisplay(new),
  		RootWindow(XtDisplay(new), DefaultScreen(XtDisplay(new))),
  		new->scroll.pixwidth+1, new->scroll.pixheight+1,
  		new->core.depth);
  	if(new->scroll.anflag >  XwScrollInAnno){
  	      if(new->scroll.Sdir){
		 width = new->scroll.annsiz;
		 height =      new->scroll.pixheight;
	      }		
  	      else {
   	                height = new->scroll.annsiz;
 	      	width = new->scroll.pixwidth;
 	      }
 	     if(width > 0 && height > 0) 
    	        new->scroll.panno = XCreatePixmap(XtDisplay(new),
  		  RootWindow(XtDisplay(new), DefaultScreen(XtDisplay(new))),
  		  width, height,new->core.depth);
  	       else{
  	       	new->scroll.anflag  =  XwScrollNoAnno;
  	       	XtWarning("Bad size, Annotation set to XwScrollNoAnno");
  	       }

	 }
	 if(!new->scroll.historysize)       /* use default abscissa size size for history */
	 	new->scroll.historysize = (new->scroll.Sdir) 
	 	     ? new->scroll.height*2 : new->scroll.width*2;
	new->scroll.nactc	 = 0;  	/* preset number of active curves to NO */
	if(new->scroll.firstcurve){	/* if set init ID 0 here */
		new->scroll.crv[new->scroll.nactc].color = new->scroll.firstcurve;
		new->scroll.crv[new->scroll.nactc].id = new->scroll.nactc;
		new->scroll.nactc++;
		if(new->scroll.history)
			create_history (new);
	}
	 
    	 Getscroll_gc(new);	
	 scale(new);	/* scale the widget */
	drawgrid(new , 1);

}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		SetValues
 *  
 *  Input:		Widget curr,Widget requ, Widget new, ArgList args, Cardinal *numargs	
 *
 *  Return:			
 *
 *  Documentation:	Die Funktion wird von Xt als Methode aufgerufen wenn die Applikation 
 * 		  XtSetValue() oder XtSetValues() aufruft. In dieser Funktion wird ber-
 *		  prft ob sich eine Wert der Ressourcen Variablen fr die Widgetklasse
 * 		  gendert hat. Ist dies der Fall werden die davon abhngigen privaten 
  *		  Instanzvariablen neu berechnet.  Wenn sich die Skalierung, der Grid oder
  *		Annotation, bzw. Scroll-Richtung geaendert hat, wird das Widget komplett
  *		neu gezeichnet.
 *	
 *
 *
 *  History:	wizant   Sat Mar 22 10:31:32 CET 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
/* ARGSUSED */

static Boolean SetValues ( Widget curr, Widget requ, Widget new, ArgList args, Cardinal *numargs){

  XwScrollWidget current = (XwScrollWidget) curr;
  XwScrollWidget newon   = (XwScrollWidget) new;

  int i;
  Boolean rescale = FALSE;
  XGCValues values;
  XtGCMask valuemask =  GCFont ;
  float *interm , *oldinterm;
  Dimension width,height;
  
	if(!current->scroll.crv || !current->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScroll SetValues");
		return FALSE;
	}

	if(newon->scroll.yndecimals != current->scroll.yndecimals){
		 get_proportion(newon);		/* recalculate sizes and starting */
		rescale = TRUE;
	}
/* check and recalculate display relative parameters, recreate pixmaps */
	if(newon->scroll.Sdir   != current->scroll.Sdir
	           || newon->scroll.anflag   != current->scroll.anflag ){
	      if(newon->scroll.pix)
	  	  XFreePixmap(XtDisplay(newon),newon->scroll.pix);
	      if(newon->scroll.panno)
	  	  XFreePixmap(XtDisplay(newon),newon->scroll.panno);
	      newon->scroll.panno = (Pixmap)NULL;	/* put NULL in, there is no pixmap */	
	        
	      get_proportion(newon);		/* recalculate sizes and starting */
	      
	      newon->scroll.lastpush =  newon->scroll.vis[0] ;
	      newon->scroll.pix = XCreatePixmap(XtDisplay(newon),
  	                RootWindow(XtDisplay(newon), DefaultScreen(XtDisplay(newon))),
  		newon->scroll.pixwidth+1, newon->scroll.pixheight+1,
  		newon->core.depth);
  	      if(newon->scroll.anflag >  XwScrollInAnno){
  	          if(newon->scroll.Sdir){
		  width = newon->scroll.annsiz;
		   height =      newon->scroll.pixheight;
	          }		
  	          else {
   	                height = newon->scroll.annsiz;
 	      	width = newon->scroll.pixwidth;
 	         }
 	     if(width > 0 && height > 0) 
    	        newon->scroll.panno = XCreatePixmap(XtDisplay(newon),
  		  RootWindow(XtDisplay(newon), DefaultScreen(XtDisplay(newon))),
  		  width, height,newon->core.depth);
	   }

	 rescale = TRUE;
	}	 
	if(newon->scroll.history != current->scroll.history && newon->scroll.history)
		create_history (newon);
	  	   
/* set all colors if changed or not into GC */

	XSetForeground(XtDisplay(newon) , newon->scroll.gc,newon->primitive.foreground);
	XSetForeground(XtDisplay(newon) , newon->scroll.anngc,newon->scroll.anncolor);
	XSetForeground(XtDisplay(newon) , newon->scroll.gridgc,newon->scroll.gridcolor);
	XSetBackground(XtDisplay(newon) , newon->scroll.gc,newon->scroll.background);
	XSetBackground(XtDisplay(newon) , newon->scroll.anngc,newon->core.background_pixel);
	XSetBackground(XtDisplay(newon) , newon->scroll.gridgc,newon->scroll.background);
		
	/* copy scaling and grid definition over to internal storage, as application might free the array */
	if(newon->scroll.vis != current->scroll.vis ){
	   newon->scroll.lastpush = 0.0;
	   for (i=0 ; i< newon->scroll.nactc ; i++){
	      if(newon->scroll.history){
		   newon->scroll.crv[i].history.firstindex = -1;
		   newon->scroll.crv[i].history.lastindex = 0;
		   memset (newon->scroll.crv[i].history.x,0,sizeof(float)
		   	 * newon->scroll.crv[i].history.size);
		   memset (newon->scroll.crv[i].history.y,0,sizeof(float)
		   	 * newon->scroll.crv[i].history.size);
	       }	 
	       newon->scroll.crv[i].init = 0;	 
	    }
		oldinterm = current->scroll.vis;
		interm = 	newon->scroll.vis;
		newon->scroll.vis = (float *)XtMalloc(sizeof(float)*4);	
  		if(!newon->scroll.vis ) {
 			 XtWarning("WScroll   SetValues   cannot XtMalloc");
 			 newon->scroll.vis = oldinterm;
 		}
 		else{
			memcpy(newon->scroll.vis , interm , 4*sizeof(float));
			if(current->scroll.vis)
				XtFree((char *)current->scroll.vis);
		}
		rescale = TRUE ;
	}
	if(newon->scroll.gr != current->scroll.gr ){
		interm = newon->scroll.gr;	
		oldinterm = current->scroll.gr;
		newon->scroll.gr = (float *)XtMalloc(sizeof(float)*4);	
  		if(!newon->scroll.gr ) {
 			 XtWarning("WScroll   SetValues   cannot XtMalloc");
 			 newon->scroll.gr = oldinterm;
 		}
 		else{
			memcpy(newon->scroll.gr, interm , 4*sizeof(float));
			if(current->scroll.gr)
				XtFree((char *)current->scroll.gr);
		}
		rescale = TRUE ;
	}
/* check if number of curves to be allocated has increased */
	if(newon->scroll.ncurves > current->scroll.ncurves){
		newon->scroll.crv = (ScCurve *)XtRealloc(
			(char *)newon->scroll.crv , newon->scroll.ncurves * sizeof(ScCurve));
		if(!newon->scroll.crv  ) 
 	 		XtWarning("WScroll   SetValues   cannot XtRealloc");

	}

  /* Prfen ob sich die Fontliste gendert hat */
  	if(newon->scroll.font_list != current->scroll.font_list){
    		if((current->scroll.font_list == NULL) && 
    		     (current->scroll.font_struct != NULL))
      			XFreeFont(XtDisplay(current), current->scroll.font_struct);
   		
    		if( current->scroll.font_list) 
      			XmFontListFree(current->scroll.font_list);

    		if( newon->scroll.font_list == NULL)
     			newon->scroll.font_list = 
           			      _XmGetDefaultFontList((Widget) newon, XmLABEL_FONTLIST);
  	 	
   	 	if( newon->scroll.font_list != NULL){
     		       newon->scroll.font_list = XmFontListCopy(newon->scroll.font_list);
     		      _XmFontListGetDefaultFont(newon->scroll.font_list,
       			&newon->scroll.font_struct);
    		}
    		else
      		     newon->scroll.font_struct = XLoadQueryFont(XtDisplay(newon),"fixed");
/* now push font to GC's */      		     
  		values.font = newon->scroll.font_struct->fid;
		 XChangeGC(XtDisplay(newon), newon->scroll.gc, valuemask, &values);
		 XChangeGC(XtDisplay(newon), newon->scroll.anngc, valuemask, &values);
		 XChangeGC(XtDisplay(newon), newon->scroll.gridgc, valuemask, &values);

   	}	
   	if(newon->scroll.xndecimals != current->scroll.xndecimals)
   		current->scroll.xndecimals =newon->scroll.xndecimals;
	 
	/** now redisplay etc */
	if(rescale){
/* rescale all and clear pixmap, create grid and copy it into visible */
		scale (newon);		/* new scaling */
		clear_scroll(newon , 0);
		newon->scroll.offset = 0;
		if(current->scroll.gr[0] != newon->scroll.gr[0])
		check_rescroll(newon,newon->scroll.gr[0],newon->scroll.gr[0] , 0); /* re-offset */
		for(i=0;i<newon->scroll.nactc;i++){		/* first rescale all oldpoints in curves */
 			newon->scroll.crv[i].oldx = (unsigned short)
 			xPix(newon,newon->scroll.crv[i].lastx,newon->scroll.crv[i].lasty);
 			newon->scroll.crv[i].oldy =  (unsigned short)
 			yPix(newon,newon->scroll.crv[i].lastx,newon->scroll.crv[i].lasty);
		}
		
	/* need a clear */
		drawgrid(newon, 1);
	 	if(newon->scroll.exposed){
 	     		XClearArea(XtDisplay(newon), XtWindow(newon), 0, 0, 
 	     		    XtWidth(newon), XtHeight(newon), FALSE);		
			drawannot(newon);
		}
	}
	Set_clipping(newon);
	return TRUE;
}




/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	get_proportion
 *
 *
 *  Prototype:	static void get_proportion(XwScrollWidget cw);
 *  
 *  Input:		XwScrollWidget cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	calculates all sizedependent parameters inside the
 *			widget. Visible part size and position, pixmap sizes 
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void get_proportion(XwScrollWidget cw){

  int  len;
  char  annot[40];
  int offset =0;

	offset += 2; /* (cw->scroll.border) ? 2 : 0; */
   	cw->scroll.width = XtWidth(cw) - offset ;
	cw->scroll.height = XtHeight(cw) - offset;
	cw->scroll.xv = cw->scroll.yv = offset/2;
		/* correct illegal annotation-flag combinations */
	
	if(cw->scroll.Sdir){
	    if(cw->scroll.anflag > XwScrollInAnno){
	       if(cw->scroll.anflag & XwScrollInAnno)
	       		cw->scroll.anflag &= ~(XwScrollLeAnno | XwScrollRiAnno);
	       if(cw->scroll.anflag  & (XwScrollUpAnno+XwScrollDoAnno))
		   cw->scroll.height -= (cw->scroll.font_struct->ascent 
		       - cw->scroll.font_struct->descent) +2;
		if(cw->scroll.anflag  & (XwScrollLeAnno | XwScrollRiAnno)){
		   sprintf(annot,"% .*f", cw->scroll.xndecimals,(cw->scroll.vis[0]
		        +cw->scroll.vis[1])*10.);
		   len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot)) +2 ;
		   cw->scroll.width -= len;
		}
		if (cw->scroll.anflag & XwScrollLeAnno)		
		       cw->scroll.xv = len + offset/2;
		if(cw->scroll.anflag &  XwScrollUpAnno)
		      cw->scroll.yv = (cw->scroll.font_struct->ascent 
		      - cw->scroll.font_struct->descent)+2 + offset/2;
		cw->scroll.annsiz  = len ;   	         
	  }
	  cw->scroll.pixwidth  = cw->scroll.width;
	  cw->scroll.pixheight  = cw->scroll.height * 5;/* 5 times bigger pixmap */
	}	
	else {	/* horizontal scrolling */
	    if(cw->scroll.anflag > XwScrollInAnno){
	       if(cw->scroll.anflag & XwScrollInAnno)
	       		cw->scroll.anflag &= ~(XwScrollDoAnno | XwScrollUpAnno);
	       if(cw->scroll.anflag  & (XwScrollUpAnno+XwScrollDoAnno))
		   cw->scroll.height -= (cw->scroll.font_struct->ascent 
		   	- cw->scroll.font_struct->descent) +2;
		if(cw->scroll.anflag  & (XwScrollLeAnno | XwScrollRiAnno)){
		   sprintf(annot,"% .*f", cw->scroll.yndecimals,(cw->scroll.vis[2]
		          +cw->scroll.vis[3])*10.);
		   len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot)) +2;
		   cw->scroll.width -= len;
		}
		if (cw->scroll.anflag & XwScrollLeAnno)		
		         cw->scroll.xv = len + offset/2;
		if(cw->scroll.anflag & XwScrollUpAnno)
		         cw->scroll.yv = (cw->scroll.font_struct->ascent 
		            - cw->scroll.font_struct->descent)+2 + offset/2;
		 if(cw->scroll.anflag & XwScrollLeAnno   
		   ||  cw->scroll.anflag & XwScrollRiAnno ){
		        if(cw->scroll.anflag & XwScrollDoAnno)
		             cw->scroll.yv +=  (cw->scroll.font_struct->ascent 
		   	- cw->scroll.font_struct->descent) / 2;
		         cw->scroll.height -=    (cw->scroll.font_struct->ascent 
		   	- cw->scroll.font_struct->descent) / 2;
		 }  	    
		cw->scroll.annsiz = (cw->scroll.font_struct->ascent 
		            - cw->scroll.font_struct->descent)+2;            	         
	     }
	    cw->scroll.pixwidth  = cw->scroll.width *5;   /* 5 times bigger pixmap */
	    cw->scroll.pixheight  = cw->scroll.height;
	}    
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Getscroll_gc
 *
 *
 *  Prototype:	static void Getscroll_gc(XwScrollWidget  cw);
 *  
 *  Input:		XwScrollWidget  cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	Creates all needed GC's setting the font to all of them
 *			setting background/foreground colours from resources
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Getscroll_gc(XwScrollWidget  cw){

  XGCValues values;
  XtGCMask mask = GCForeground | GCBackground | GCFont ;

  /* Erzeugendes diagram GCs  */
  	values.foreground = cw->primitive.foreground;
  	values.background = cw->scroll.background;
  	values.font = cw->scroll.font_struct->fid;
  	cw->scroll.gc = XCreateGC(XtDisplay(cw),cw->scroll.pix, mask, &values);
  /* Erzeugen des annotation GCs  */
  	values.foreground = cw->scroll.anncolor;
    	values.background = cw->core.background_pixel;
  	cw->scroll.anngc = XCreateGC(XtDisplay(cw),cw->scroll.pix, mask, &values);
    /* Erzeugen des grid GCs  */
  	values.foreground = cw->scroll.gridcolor;
    	values.background = cw->scroll.background;
  	cw->scroll.gridgc = XCreateGC(XtDisplay(cw),cw->scroll.pix, mask, &values);

/*   Create the GC for dancevals etc */
   	values.foreground = cw->primitive.foreground;
  	values.background = cw->scroll.background;
  	values.font = cw->scroll.font_struct->fid;
 	cw->scroll.clipgc = XCreateGC(XtDisplay(cw),cw->scroll.pix, mask, &values);
 	 Set_clipping(cw);
	
	clear_scroll(cw , 0);
 

 
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		Set_clipping
 *  
 *  Input:			XwScrollWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		Sets the clipping mask for dancevals and fixtext
 *
 *   On host:		wizant			by: WizAnt Software
 *  History:	Sun Jun  8 08:09:33 CEST 1997	
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Set_clipping (XwScrollWidget  cw){
  XRectangle   clip;
  
  
  	clip.x = clip.y = 0;
 	clip.width = cw->scroll.width;
 	clip.height = cw->scroll.height;
	XSetClipRectangles(XtDisplay(cw),cw->scroll.clipgc,cw->scroll.xv,cw->scroll.yv
	   ,&clip , 1, Unsorted);
}	


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Redisplay
 *
 *
 *  Prototype:	static void Redisplay(Widget w, XEvent *event, Region region);
 *  
 *  Input:		Widget w, XEvent *event, Region region
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	This is the Expose method for X
 *		The region and event parameter are ignored.
 *		actually the active pixmap parts are replotted and the
 *		annotation redrawed
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void Redisplay(Widget w, XEvent *event, Region region){

  XwScrollWidget cw = (XwScrollWidget) w;
  XwScrollCallbackStruct call_value;
  Dimension pushit;

  /* Prfen ob die Widgetinstanz schon realisiert ist */
 	 if ( !XtIsRealized((Widget)cw) )
		return;
	
  /* Fenster aktualisieren */  
 	if(!cw->scroll.Sdir )	/* in case of hor scroll */
 	     pushit =  (unsigned short)xPix(cw,cw->scroll.lastpush,cw->scroll.lastpush)
 	         - cw->scroll.width ;
     	else if (cw->scroll.Sdir == XwScrollVertDown)	/* in case of ver scroll */
     	     pushit =  (unsigned short)yPix(cw,cw->scroll.lastpush,cw->scroll.lastpush) 
     	          -  cw->scroll.height;
	else
	     pushit =  (unsigned short)yPix(cw,cw->scroll.lastpush,cw->scroll.lastpush);
 
 	cw->scroll.lastcop = -1;		/* enforce redisplay even if no change */
  	copypix(cw,XtWindow(cw)	,pushit);
 	 cw->scroll.exposed++;
 	 drawannot(cw);
 	 if(cw->scroll.expose_callback){
   		 call_value.reason = XmCR_EXPOSE;
    		call_value.event = event;
   		 call_value.fd = -1;
   		 call_value.width = cw->scroll.width;
   		 call_value.height = cw->scroll.height;
   		 call_value.value = cw->scroll.lastpush;
    /* Aufrufen der Callbackliste fr den Exposeevent */
   		 XtCallCallbackList((Widget)cw,cw->scroll.expose_callback,&call_value);
 	 }
}



/* ======================================================================= */
/* 
   Funktionsname: QueryGeometry 
   Input:	  Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer
   Beschreibung:  
*/
/* ARGSUSED */

static XtGeometryResult QueryGeometry( Widget w, XtWidgetGeometry *proposed, XtWidgetGeometry *answer){

   	XtWarning("XwScroll: query Geometry.");
  	answer->request_mode = (CWWidth | CWHeight);
      	answer->width = proposed->width;

  	return XtGeometryYes;
}




/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	Resize
 *
 *
 *  Prototype:	static void Resize ( Widget w );
 *  
 *  Input:		Widget w
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	This is a method, called by X whenever the size
 *			of widget was changed. it recreates the pixmaps for
 *			the new size. If minor changes, copies the last
 *			active part of pixmap to new pixmap, clears the renaing
 *			part, rescales and recreates the grid. So at minor
 *			changes, you will see the old date with different scale, 
 *			followed by new scaling, annotation and data, as data are
 *			coming in.
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/

static void Resize ( Widget w ){

  XwScrollWidget cw = (XwScrollWidget) w;
  Pixmap	localpix = cw->scroll.pix ,localpanno = cw->scroll.panno;
  Dimension oldwidth,oldheight , oldpush;
  Dimension width,height;
  int i , idx , ID ,  iy , ix;
  float oldbase;
  XwScrollCallbackStruct call_value;

	oldwidth = cw->scroll.width;
	oldheight = cw->scroll.height;
	if(cw->scroll.Sdir)
		oldpush =  (unsigned short)yPix(cw,cw->scroll.lastpush,cw->scroll.lastpush);
	else
		oldpush =  (unsigned short)xPix(cw,cw->scroll.lastpush,cw->scroll.lastpush);
 
  	 cw->scroll.panno = (Pixmap)NULL;	/* preclear */
   	 get_proportion( cw );		/* recalculate sizes and starting */
    	cw->scroll.pix =XCreatePixmap(XtDisplay(cw),
  		RootWindow(XtDisplay(cw), DefaultScreen(XtDisplay(cw))),
  		cw->scroll.pixwidth+1, cw->scroll.pixheight+1,
  		cw->core.depth);
/* pixmap for external annotation  */ 
  	if(cw->scroll.anflag >  XwScrollInAnno){
  	      if(cw->scroll.Sdir){
		width = XtWidth(cw) - cw->scroll.width;
		 height =      cw->scroll.pixheight;
	      }		
  	      else {
   	               height = XtHeight(cw) - cw->scroll.height;
 	      	width = cw->scroll.pixwidth;
 	      }
 	     if(width > 0 && height > 0)
    	        cw->scroll.panno = XCreatePixmap(XtDisplay(cw),
  		RootWindow(XtDisplay(cw), DefaultScreen(XtDisplay(cw))),
  		width, height,cw->core.depth);
	 }
	clear_scroll(cw , 0);
	scale(cw);
	cw->scroll.offset = 0;
	oldbase = cw->scroll.gr[0];		/* save old grid abscissa base */
	check_rescroll(cw,cw->scroll.crv[0].lastx,cw->scroll.crv[0].lasty , 0); /* re-offset */
/*	if(only the size in scrolldirection changed, copy now the part from local
 	pixmap the the new one before freeing it */
 	
	for(i=0;i<cw->scroll.nactc;i++){		/* first rescale all oldpoints in curves */
 		cw->scroll.crv[i].oldx =  (unsigned short)
 			xPix(cw,cw->scroll.crv[i].lastx,cw->scroll.crv[i].lasty);
 		cw->scroll.crv[i].oldy =  (unsigned short)
 			yPix(cw,cw->scroll.crv[i].lastx,cw->scroll.crv[i].lasty);
	}
	cw->scroll.gr[0] = oldbase ;    /* reset base to old */
	drawgrid(cw , 1);		/* redraw last grid */
	if(cw->scroll.exposed)
	     XClearArea(XtDisplay(cw), XtWindow(cw), 0, 0, XtWidth(cw), XtHeight(cw), FALSE);		

         if(cw->scroll.history){	/* existing scroll history, so redraw all */
            for(ID = 0 ; ID < cw->scroll.nactc ; ID++){
  		idx = cw->scroll.crv[ID].history.firstindex;
 		if(idx<0)
 		    idx = 1;
 		if(idx == cw->scroll.crv[ID].history.lastindex 
 	  	 || (cw->scroll.crv[ID].history.firstindex < 0
 	  	 	 && !cw->scroll.crv[ID].history.lastindex ))
 			continue;
		cw->scroll.crv[ID].lastx = cw->scroll.crv[ID].history.x[idx];
		cw->scroll.crv[ID].lasty = cw->scroll.crv[ID].history.y[idx];
 		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->scroll.crv[ID].color);
		while(++idx != cw->scroll.crv[ID].history.lastindex){
 	      		if(idx >=  cw->scroll.crv[ID].history.size)
 		    	     idx = 0; 
 	     		ix = xPix(cw,cw->scroll.crv[ID].history.x[idx]
 	     			, cw->scroll.crv[ID].history.y[idx]);
       	     		iy = yPix(cw,cw->scroll.crv[ID].history.x[idx]
       	     			, cw->scroll.crv[ID].history.y[idx]);
      	         	XDrawLine(XtDisplay(w),cw->scroll.pix,cw->scroll.gc
      			,xPix(cw,cw->scroll.crv[ID].lastx,cw->scroll.crv[ID].lasty)
      			,yPix(cw,cw->scroll.crv[ID].lastx,cw->scroll.crv[ID].lasty)
      			,ix,iy);
	    		cw->scroll.crv[ID].lastx = cw->scroll.crv[ID].history.x[idx];
	    		cw->scroll.crv[ID].lasty = cw->scroll.crv[ID].history.y[idx];

 		}
             }

          }
          else {
 		if(!cw->scroll.Sdir && !(cw->scroll.height < oldheight - 10)  
 		 && !(cw->scroll.height > (oldheight +20))&& cw->scroll.exposed){	/* in case of hor scroll */
 	     	XCopyArea(XtDisplay(cw),localpix,  cw->scroll.pix,
  		  cw->scroll.gc,  oldpush - oldwidth, 0
  		  , oldwidth, cw->scroll.height,xPix(cw,cw->scroll.lastpush,cw->scroll.lastpush) - oldwidth,0); 
	     	if(localpanno && cw->scroll.panno)
  	          XCopyArea(XtDisplay(cw),localpanno,  cw->scroll.panno,
  		     cw->scroll.anngc,  oldpush - oldwidth, 0
  		, oldwidth, height,xPix(cw,cw->scroll.lastpush,cw->scroll.lastpush) - oldwidth,0); 
     	} 
     	else if(cw->scroll.Sdir && !( cw->scroll.width < oldwidth -10)
 	 && !( cw->scroll.width > (oldwidth +20))&& cw->scroll.exposed){	/* in case of ver scroll */
	    	if( cw->scroll.Sdir == XwScrollVertDown){
 	             XCopyArea(XtDisplay(cw),localpix,  cw->scroll.pix,
  		     cw->scroll.gc, 0,  oldpush -oldheight 		
  		     ,  cw->scroll.width, oldheight,0,yPix(cw,cw->scroll.lastpush
  		     ,cw->scroll.lastpush) - oldheight);  
	             if(localpanno && cw->scroll.panno)
  	                 XCopyArea(XtDisplay(cw),localpanno,  cw->scroll.panno,
  			 cw->scroll.gc, 0,  oldpush -oldheight 		
  			,  width, oldheight,0,yPix(cw,cw->scroll.lastpush
  			 ,cw->scroll.lastpush) - oldheight);  
	   	}
	   	else {		
 	       		XCopyArea(XtDisplay(cw),localpix,  cw->scroll.pix,
 			  cw->scroll.gc, 0,  oldpush 	
  			  ,  cw->scroll.width, oldheight,0,yPix(cw,cw->scroll.lastpush
  			  ,cw->scroll.lastpush) );  
	        	if(localpanno && cw->scroll.panno)
  	            		XCopyArea(XtDisplay(cw),localpanno,  cw->scroll.panno,
  				cw->scroll.gc, 0,  oldpush -oldheight 		
  				,  width, oldheight,0,yPix(cw,cw->scroll.lastpush
  				,cw->scroll.lastpush) );  
	  	} 
  	    } 
         }
    	if(localpix)
		XFreePixmap(XtDisplay(cw), localpix);
   	if(localpanno)
    		XFreePixmap(XtDisplay(cw), localpanno);
      	 Set_clipping(cw);
	 if(cw->scroll.resize_callback){
   		 call_value.reason =XmCR_RESIZE ;
    		call_value.event =NULL;
   		 call_value.fd = -1;
   		 call_value.width = cw->scroll.width;
   		 call_value.height = cw->scroll.height;
   		 call_value.value = cw->scroll.lastpush;
    /* Aufrufen der Callbackliste fr den Exposeevent */
   		 XtCallCallbackList((Widget)cw,cw->scroll.resize_callback,&call_value);
 	 }
	
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		Destroy
 *  
 *  Input:			Widget w 
 *
 *  Return:			
 *
 *  Documentation:		Method, called when the widget is destroyed
 *			(not called during termination and quitting
 *
 *
 *  History:		Wed Apr  9 16:37:27 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void Destroy(Widget w ){
  XwScrollWidget cw = (XwScrollWidget) w;
 int ID;
  	if(cw->scroll.addtext)
  		free( (void *)cw->scroll.addtext);
  	XFreeGC(XtDisplay( cw), cw->scroll.gc);
    	XFreeGC(XtDisplay( cw), cw->scroll.anngc);
  	XFreeGC(XtDisplay( cw), cw->scroll.gridgc);
	/* XmFontListFree(cw->scroll.font_list); */
	
	XFreePixmap(XtDisplay(cw), cw->scroll.pix);
	if(cw->scroll.panno)
		XFreePixmap(XtDisplay(cw), cw->scroll.panno);
		
	XtFree((char *)cw->scroll.vis);
	XtFree((char *)cw->scroll.gr);
	cw->scroll.addtext = NULL;
	cw->scroll.pix = 0;
	cw->scroll.panno = 0;
	cw->scroll.gc = NULL;
	cw->scroll.anngc = NULL;
	 cw->scroll.gridgc = NULL;
	/*  cw->scroll.font_list = NULL; */
	 
	 
	 	/* free all history and curves created */
         	if(cw->scroll.history && cw->scroll.crv ){	/* existing scroll history, so free all */
            	      for(ID = 0 ; ID < cw->scroll.nactc ; ID++){
            	      	if(cw->scroll.crv[ID].fixtext)
            	      		free(cw->scroll.crv[ID].fixtext);
		if(cw->scroll.crv[ID].history.x)	
		 	XtFree((char *)cw->scroll.crv[ID].history.x); 
		if(cw->scroll.crv[ID].history.y)		 	
		 	XtFree((char *)cw->scroll.crv[ID].history.y); 
	 	cw->scroll.crv[ID].history.size =  0;
		 cw->scroll.crv[ID].history.firstindex = -1;
	 	cw->scroll.crv[ID].history.lastindex = 0;
	     }
	 }
	 if(cw->scroll.crv )
		XtFree((char *)cw->scroll.crv);
	 cw->scroll.crv = NULL;
	 
 
}
/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	clear_scroll
 *
 *
 *  Prototype:	static void clear_scroll(XwScrollWidget cw , int notall);
 *  
 *  Input:		XwScrollWidget cw , int notall
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	 actual clearing the total (or active part of)pixmap 
 *			to background colour, should be followed by recreating grid 
 *			(and scale)
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void clear_scroll(XwScrollWidget cw , int notall){
   Dimension width = cw->scroll.pixwidth , height = cw->scroll.pixheight;


	if(cw->scroll.Sdir)
		width = cw->scroll.annsiz;
	else
		height = cw->scroll.annsiz;
     	XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->scroll.background);
     	XSetForeground(XtDisplay(cw),cw->scroll.anngc,cw->core.background_pixel);
     	if(!notall){
	        XFillRectangle(XtDisplay(cw),cw->scroll.pix,cw->scroll.gc,
		    0,0,cw->scroll.pixwidth,cw->scroll.pixheight);
	        if(cw->scroll.border){
  		  XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->primitive.foreground);
  		     XDrawRectangle(XtDisplay(cw),cw->scroll.pix,cw->scroll.gc
  		   , 0,0,cw->scroll.pixwidth,cw->scroll.pixheight);
  		}	  
     
	        if(cw->scroll.panno)
	            XFillRectangle(XtDisplay(cw),cw->scroll.panno,cw->scroll.anngc,
		    0,0,width,height);
	}	   
	else{
	       if(!cw->scroll.Sdir){
	             XFillRectangle(XtDisplay(cw),cw->scroll.pix,cw->scroll.gc,
		    cw->scroll.width,0,cw->scroll.pixwidth - cw->scroll.width,cw->scroll.pixheight);
	             if(cw->scroll.panno)
	                   XFillRectangle(XtDisplay(cw),cw->scroll.panno,cw->scroll.anngc,
	                    cw->scroll.width,0,cw->scroll.pixwidth - cw->scroll.width,height);
	        }            
	       else if(cw->scroll.Sdir == XwScrollVertDown){
	             XFillRectangle(XtDisplay(cw),cw->scroll.pix,cw->scroll.gc,
		    0,cw->scroll.height,cw->scroll.pixwidth ,cw->scroll.pixheight - cw->scroll.height);
	             if(cw->scroll.panno)
	                   XFillRectangle(XtDisplay(cw),cw->scroll.panno,cw->scroll.anngc,
	                    0,cw->scroll.height,cw->scroll.annsiz,cw->scroll.pixheight - cw->scroll.height);
	        }            	                   
	      else if(cw->scroll.Sdir == XwScrollVertUp){	    
	             XFillRectangle(XtDisplay(cw),cw->scroll.pix,cw->scroll.gc,
		    0,0,cw->scroll.pixwidth,cw->scroll.pixheight - cw->scroll.height);	       
	             if(cw->scroll.panno)
	                   XFillRectangle(XtDisplay(cw),cw->scroll.panno,cw->scroll.anngc,
	                    0,0,cw->scroll.annsiz,cw->scroll.pixheight - cw->scroll.height);
	        }            	                   
	}       
	
      	XSetForeground(XtDisplay(cw),cw->scroll.anngc,cw->scroll.anncolor);

}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	scale
 *
 *
 *  Prototype:	static void scale(XwScrollWidget cw);
 *  
 *  Input:		XwScrollWidget cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	does all scaling,construct parameters to calculate from users values 
 *			into pixmap.Takes  care about hor/vertical scrolling,
 *			 (vertical the y pixels are abscissa!!)
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void scale(XwScrollWidget cw){
   double width,height;
/*    scaling and pxconversions is lateron:
   < Sdir == 0 >   horizontal
   	          ==========
   	xpix = scroll.sc[0] + scroll.sc[1]* Xval
   	ypix = cw->scroll.height -(scroll.sc[2] + scroll.sc[3]* Yval);
   	         
   	         vertical
   	         =======
    	xpix = scroll.sc[0] + scroll.sc[1]* Yval
   	ypix = scroll.sc[2] + scroll.sc[3]* Xval;
   but pushing pixels in vertical are Ypixels!!!!
*/
 /* assumed, that pixel coords begin with 0 */	
 	if(!cw->scroll.Sdir){
 		width  = cw->scroll.width;
 		height = cw->scroll.height ;
 	}
 	else {
  		width  = cw->scroll.height;
 		height = cw->scroll.width ;
 	}
	
	cw->scroll.sc.bx =  width /  cw->scroll.vis[1] ;
	cw->scroll.sc.ax = width -  cw->scroll.sc.bx 
	       *  (cw->scroll.vis[0] + cw->scroll.vis[1]);
	cw->scroll.sc.by = height /  cw->scroll.vis[3] ;
	cw->scroll.sc.ay = height  -  cw->scroll.sc.by  
	      * ( cw->scroll.vis[2] + cw->scroll.vis[3]) ;
	      
	 cw->scroll.sc.ax += width;     
 	      
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	drawannot
 *
 *
 *  Prototype:	static void drawannot(XwScrollWidget  cw);
 *  
 *  Input:		XwScrollWidget  cw
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:	draws the ordinate annotation(if needed) to window
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void drawannot(XwScrollWidget  cw){
   int ypix  , cnt = cw->scroll. ynthgridanno+1
   , len,cheight =  (cw->scroll.font_struct->ascent - cw->scroll.font_struct->descent);
   int  pos=0;
   float base = cw->scroll.gr[2]  ;
  char annot[40];
  
  	if(cw->scroll.border){
  		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->primitive.foreground);
  		 XDrawRectangle(XtDisplay(cw),XtWindow(cw),cw->scroll.gc
  		   , cw->scroll.xv-1,cw->scroll.yv-1,cw->scroll.width+1,cw->scroll.height+1);
  	}	  
  	if(cw->scroll.anflag < XwScrollInAnno)
   		return;
      	if(!cw->scroll.Sdir){	/* horizontal scroll */
      		if(!(cw->scroll.anflag & (XwScrollLeAnno+XwScrollRiAnno)))
      			return;
       		do {   	/* ordinate annot */
  		      ypix = yPix(cw,base,base) + cw->scroll.yv;
  		      
      		     if(ypix <= (cw->scroll.height + cw->scroll.yv) && ypix >= 0){
       		          if(!--cnt ){
       			     cnt = cw->scroll.ynthgridanno+1;
       			     sprintf(annot,"%.*f",cw->scroll.yndecimals,base);
       			     len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot)) ;
      			      if(cw->scroll.anflag & XwScrollLeAnno)
      			        pos = cw->scroll.xv - len;
      			     else
      			        pos = XtWidth(cw) - len	;
       			     XDrawString (XtDisplay(cw),XtWindow(cw),cw->scroll.anngc
       			        ,pos , ypix+cheight/2 ,annot,strlen(annot));			      
      			  }
      		     }
      		     base += cw->scroll.gr[3];
      		}while(ypix >= 0);
      	}
      	else {	/* vertical scroll */
      		do { 	/* ordinate annot */
      		     if(!(cw->scroll.anflag & (XwScrollUpAnno+XwScrollDoAnno)))
      			return;
		      ypix = xPix(cw,base,base) + cw->scroll.xv;
        	      if(ypix <=  cw->scroll.width+cw->scroll.xv && ypix >= cw->scroll.xv){
       		          if(!--cnt ){
       			     cnt = cw->scroll.ynthgridanno+1;
       			     sprintf(annot,"% .*f",cw->scroll.yndecimals,base);
       			     len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot))/2 ;
			     if(cw->scroll.anflag & XwScrollUpAnno )
			        pos = 1+cheight;
			     else
			        pos = XtHeight(cw);     		     
       			     XDrawString (XtDisplay(cw),XtWindow(cw),cw->scroll.anngc
       			        ,ypix-len , pos ,annot,strlen(annot));			      
      		          }	 
      		     }
      		     base += cw->scroll.gr[3];
      		}while(ypix <= cw->scroll.width + cw->scroll.xv);
	}
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	drawgrid
 *
 *
 *  Prototype:	static void drawgrid(XwScrollWidget cw , int doit);
 *  
 *  Input:		XwScrollWidget cw , int doit
 *
 *  Output:		
 *
 *  Return:		
 *
 *  Documentation:		if doit not set, recalculates the next grid position, else
 *			Draws the grid into pixmap and draws the abscissa
 *			annotation either in same pixmap or into 
 *			annotation pixmap
 *
 *
 *  History:		Fri Mar 21 16:50:56 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void drawgrid(XwScrollWidget cw , int doit){
   int ypix , xpix , cnt = cw->scroll.lastanncnt , len;
   float base = cw->scroll.gr[2] ;
   Dimension annpos = cw->scroll.annsiz;
   char annot[40];
  Pixmap local;

/*    grid forground colour is fixed set to cw->primitive.foreground    */
       	XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->primitive.foreground);  
       	local = (cw->scroll.anflag & XwScrollInAnno ) ? cw->scroll.pix : cw->scroll.panno ;
       	
/* do y- rastering */      	
      	if(!cw->scroll.Sdir){	/* horizontal scroll */
       		do {   	/* ordinate grid */
 			ypix = yPix(cw,base,base);
      			if(doit && ypix <= cw->scroll.height && ypix >= 0)
      				 XDrawLine(XtDisplay(cw),cw->scroll.pix,cw->scroll.gridgc
      				 ,0,ypix,cw->scroll.pixwidth,ypix);
      			base += cw->scroll.gr[3];
      		}while(ypix >= 0);
      		
      		base = cw->scroll.gr[0]   - cw->scroll.vis[1] ;
      		if(cw->scroll.anflag & XwScrollInAnno)
      		   annpos = XtHeight(cw);
       		do{	/* scrolling grid */
			xpix = xPix(cw,base,base);      
      			if(xpix < cw->scroll.pixwidth && xpix >= 0){
      			  if(doit )
      			    XDrawLine(XtDisplay(cw),cw->scroll.pix,cw->scroll.gridgc
      				 ,xpix,0,xpix,cw->scroll.pixheight);
       			    cw->scroll.lastannot = base;
       			    cw->scroll.lastanncnt = cnt;
       			    
       			     if(doit && !--cnt && local){
       			            cnt = cw->scroll.xnthgridanno+1;
       			            sprintf(annot,"%.*f",cw->scroll.xndecimals,base);
       			            len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot)) /2;
       			            XDrawString (XtDisplay(cw),local,cw->scroll.anngc
       			         	,xpix-len , annpos  ,annot,strlen(annot));
       			     }
    			}	 
       			base += cw->scroll.gr[1];
     		}while(xpix < cw->scroll.pixwidth);
      	}
      	else {		/*vertical scroll */
      		do { 	/* ordinate grid */
			ypix = xPix(cw,base,base);
       			if(doit && ypix <=  cw->scroll.width && ypix >= 0)
      			         XDrawLine(XtDisplay(cw),cw->scroll.pix,cw->scroll.gridgc
      				 ,ypix,0,ypix,cw->scroll.pixheight);
      			base += cw->scroll.gr[3];
      		}while(ypix <= cw->scroll.pixwidth);
      		
       		base = cw->scroll.gr[0]    - cw->scroll.vis[1];

       		
      		do{	/* scrolling grid */
      			
        	   	   xpix = yPix(cw,base,base);
      		   if(xpix < cw->scroll.pixheight && xpix > 0){  
      		      if(doit )  			
      		            XDrawLine(XtDisplay(cw),cw->scroll.pix,cw->scroll.gridgc
      				,0 ,xpix,cw->scroll.pixheight,xpix);
      		      cw->scroll.lastannot = base;	
       		      cw->scroll.lastanncnt = cnt;
       		      if(doit && !--cnt && local){
       		              cnt = cw->scroll.xnthgridanno+1;
        		              sprintf(annot,"%.*f",cw->scroll.xndecimals,base);
        		             len = (cw->scroll.font_struct->ascent - cw->scroll.font_struct->descent) /2;
       		            XDrawString (XtDisplay(cw),local,cw->scroll.anngc
       			     ,0 , xpix+len ,annot,strlen(annot));
       		       }
    		   }	 
        		   base += cw->scroll.gr[1];
    		}while((xpix < cw->scroll.pixheight && cw->scroll.Sdir == XwScrollVertDown)
    		|| (xpix > 0 && cw->scroll.Sdir == XwScrollVertUp));  
    		
     	}
    	cw->scroll.grbase  = cw->scroll.lastannot;	/* save last scrolling base */
}

#ifndef MACRO
/* ======================================================================= */
static long int xPix(XwScrollWidget  cw, float  x, float y){
   
	if(cw->scroll.Sdir)		/* vertical */
		return (long int)(cw->scroll.sc.ay + cw->scroll.sc.by * y) ;
	else 
		return((long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x) - cw->scroll.offset);
		
}


/* ======================================================================= */
static long int yPix(XwScrollWidget  cw, float x, float y){

	switch (cw->scroll.Sdir){
		case XwScrollVertDown:		/* vertical */
		return ((long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x) - cw->scroll.offset) ;   
		case XwScrollVertUp:
		return (cw->scroll.pixheight + cw->scroll.offset - (long int)(cw->scroll.sc.ax + cw->scroll.sc.bx * x));
		case 0: 
		return(cw->scroll.pixheight - (long int)(cw->scroll.sc.ay + cw->scroll.sc.by * y) );
	}
}

#endif


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:	 check_rescroll
 *
 *
 *  Prototype:	static int check_rescroll(XwScrollWidget  cw, float x, float y , int copy);
 *  
 *  Input:		XwScrollWidget  cw, float x, float y , int copy
 *
 *  Output:		
 *
 *  Return:		TRUE / FALSE    (needing new offset )
 *
 *  Documentation:	function checking the run out of pixmap situation,
 *			, calculating the new offset
 *			and finally (if copy is set) copying actual visible into top of pixmap
 *			recalculating the new offset
 *
 *
 *  History:		
 *
 *
 ***************************************************************************
 ***************************************************************************/
static int check_rescroll(XwScrollWidget  cw, float x, float y , int copy){

  int reoffset = FALSE;
  	
	switch(cw->scroll.Sdir){
		case XwScrollVertUp :
  		while(yPix(cw,x,y) <= 0 ){
		   cw->scroll.offset += cw->scroll.pixheight - cw->scroll.height;
		   reoffset = TRUE;
		}
		break;
		case XwScrollVertDown:
		while(yPix(cw,x,y) >= cw->scroll.pixheight){
		    cw->scroll.offset += cw->scroll.pixheight - cw->scroll.height;
		    reoffset = TRUE;
		}
		break;
		case 0:
		while(xPix(cw,x,y) >= cw->scroll.pixwidth){
		   cw->scroll.offset += cw->scroll.pixwidth - cw->scroll.width;
		   reoffset = TRUE;
		}
		break;
	}
	if(!reoffset)
		return 1;
        if(copy){	
	switch(cw->scroll.Sdir){
		case XwScrollVertDown :
  	  	XCopyArea(XtDisplay(cw),cw->scroll.pix,cw->scroll.pix,
		        cw->scroll.gc, 0 , cw->scroll.pixheight -  cw->scroll.height
  		         ,  cw->scroll.width, cw->scroll.height,0,0); 
  		if(cw->scroll.panno)
  	  	     XCopyArea(XtDisplay(cw),cw->scroll.panno,cw->scroll.panno,
		        cw->scroll.anngc, 0 ,  cw->scroll.pixheight -  cw->scroll.height
  		         ,  cw->scroll.annsiz, cw->scroll.height,0,0); 
   		break;
  		case  XwScrollVertUp :       	      
  		XCopyArea(XtDisplay(cw),cw->scroll.pix,cw->scroll.pix,
    		        cw->scroll.gc, 0 ,  0
  		        ,  cw->scroll.width, cw->scroll.height,0,cw->scroll.pixheight - cw->scroll.height);  
  		if(cw->scroll.panno)
  	  	     XCopyArea(XtDisplay(cw),cw->scroll.panno,cw->scroll.panno,
		        cw->scroll.anngc, 0 ,  0
  		         ,  cw->scroll.annsiz, cw->scroll.height,0,cw->scroll.pixheight - cw->scroll.height); 
  		break;       
 		case 0:
  		XCopyArea(XtDisplay(cw),cw->scroll.pix,cw->scroll.pix,
  		        cw->scroll.gc,   cw->scroll.pixwidth - cw->scroll.width , 0
  		         ,  cw->scroll.width, cw->scroll.height,0,0);
  		if(cw->scroll.panno)
  	  	     XCopyArea(XtDisplay(cw),cw->scroll.panno,cw->scroll.panno,
		        cw->scroll.anngc,  cw->scroll.pixwidth - cw->scroll.width,0
  		         ,  cw->scroll.width, cw->scroll.annsiz,0,0); 
  		break;
  	}         
	clear_scroll(cw , 1);
	cw->scroll.gr[0] = cw->scroll.grbase;	/* set for continuating grid */
 	 drawgrid(cw , 1);
           }
          return 0;
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		 copyannot
 *  
 *  Input:			XwScrollWidget  cw , Drawable target,Dimension given
 *
 *  Return:			
 *
 *  Documentation:		if external annotation set, copies the annotation pixmap
 *			in place for annotation, wher given might be x or y coordinate
 *			corresponding to direction
 *
 *
 *  History:		Wed Mar 12 17:45:42 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  copyannot(XwScrollWidget  cw , Drawable target , Dimension giv){
  Dimension frx,fry,tox,toy , width,height;
  
  	if(!cw->scroll.panno)
  		return;		/* no copy needed */
  	if(!cw->scroll.Sdir){
  		frx = giv;
  		fry = 0;
  		width = cw->scroll.width;
  		height = cw->scroll.annsiz;
  		toy = (cw->scroll.anflag & XwScrollDoAnno) ?
  		    cw->scroll.height +1 + cw->scroll.yv : 0;
  		tox = cw->scroll.xv;
  	}
  	else {
  	
  		fry = giv;
  		frx = 0;
   		width = cw->scroll.annsiz;
  		height = cw->scroll.height;
 		toy = cw->scroll.yv; 
  		tox = (cw->scroll.anflag & XwScrollRiAnno) ?
  			cw->scroll.width+1 + cw->scroll.xv : 0;
  	}
	XCopyArea(XtDisplay(cw),cw->scroll.panno,target,
  		        cw->scroll.anngc,   frx , fry
  		         , width, height,tox,toy);
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		 copypix
 *  
 *  Input:			XwScrollWidget  cw , Drawable target,Dimension given
 *
 *  Return:			
 *
 *  Documentation:		if external annotation set, copies the annotation pixmap
 *			in place for annotation, wher given might be x or y coordinate
 *			corresponding to direction
 *
 *
 *  History:		Sun Mar 16 08:28:27 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  copypix(XwScrollWidget  cw , Drawable target , Dimension giv){
  Dimension frx,fry;
  
	 if(cw->scroll.lastcop == giv )   
	                	return;
  	if(!cw->scroll.Sdir){
  		frx = giv;
  		fry = 0;
  	}
  	else {
  	
  		fry = giv;
  		frx = 0;
  	}
	XCopyArea(XtDisplay(cw),cw->scroll.pix,target,
  	   cw->scroll.gc,   frx , fry
  	   , cw->scroll.width+1, cw->scroll.height+1,cw->scroll.xv,cw->scroll.yv);
	copyannot(cw ,XtWindow(cw), giv);     
	dancevals(cw);
	addtext (cw);
	cw->scroll.lastcop = giv ;
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		dancevals
 *  
 *  Input:			XwScrollWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		checks if the flag for display values is set
 *			and draws the last value at inscrolling position
 *
 *
 *  History:		Wed Mar 19 16:25:01 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  dancevals(XwScrollWidget  cw ){
  int i , len , xpix,ypix;
  char annot[20];
  
	for (i = 0; i < cw->scroll.nactc ; i++){
  	    if(cw->scroll.addvalues || cw->scroll.crv[i].dance){
  	    	sprintf(annot,"%.*f",cw->scroll.yndecimals+1,cw->scroll.crv[i].lasty);
  	    	len = XTextWidth(cw->scroll.font_struct,annot,strlen(annot)) ;
		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->scroll.crv[i].color);  
	  	if(!cw->scroll.Sdir){
  		    xpix = cw->scroll.width + cw->scroll.xv - len;
  		    ypix = yPix(cw, cw->scroll.crv[i].lastx, cw->scroll.crv[i].lasty);
  		}
  		else if (cw->scroll.Sdir == XwScrollVertDown){
   		    ypix = cw->scroll.yv + cw->scroll.height;
		    xpix = xPix(cw, cw->scroll.crv[i].lastx, cw->scroll.crv[i].lasty)+ cw->scroll.xv;
   		}
  		else {
    		    ypix = cw->scroll.yv + 1 +
    		      (cw->scroll.font_struct->ascent - cw->scroll.font_struct->descent);
  		    xpix = xPix(cw, cw->scroll.crv[i].lastx, cw->scroll.crv[i].lasty)+ cw->scroll.xv;
		}
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->scroll.gc
       			 ,xpix , ypix ,annot,strlen(annot));
       	   }		 
       	}
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		addtext
 *  
 *  Input:			XwScrollWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		if a global text is set or any additional text
 *			set for a curve, it is displayed
 *
 *
 *  History:		Wed Mar 19 17:40:24 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  addtext(XwScrollWidget  cw ){
  int i  , xpix,ypix , cheight = (cw->scroll.font_struct->ascent - cw->scroll.font_struct->descent)+2;
  	       
	if(!cw->scroll.Sdir){
  		xpix = cw->scroll.xv ;
  		ypix = cw->scroll.yv + cheight;
  	}
  	else if (cw->scroll.Sdir == XwScrollVertDown){
   		ypix = cw->scroll.yv + cheight;
		xpix =  cw->scroll.xv;
   	}
  	else {
    		ypix = cw->scroll.height;
  		xpix =  cw->scroll.xv;
	}
	if(cw->scroll.addtext){
		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->primitive.foreground);
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->scroll.gc
       			 ,xpix , ypix ,cw->scroll.addtext,strlen(cw->scroll.addtext));
       	ypix = (cw->scroll.Sdir == XwScrollVertUp) ? ypix - cheight : ypix + cheight;		 
	}
	for (i = 0; i < cw->scroll.nactc ; i++){
  	    if(cw->scroll.crv[i].fixtext && cw->scroll.crv[i].fixtext[0]){
		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->scroll.crv[i].color);  
	    	 XDrawString (XtDisplay(cw),XtWindow(cw),cw->scroll.gc
       			 ,xpix , ypix ,cw->scroll.crv[i].fixtext,strlen(cw->scroll.crv[i].fixtext));
       		ypix = (cw->scroll.Sdir == XwScrollVertUp) ? ypix - cheight : ypix + cheight;		 
	   }
	}
}		      


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		add_history
 *  
 *  Input:			XwScrollWidget  cw
 *			long int id		curve id
 *
 *  Return:			
 *
 *  Documentation:		used from addcurve to initialize history
 *
 *
 *  History:		Sun Apr  6 15:22:05 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  add_history	(XwScrollWidget  cw, long int id){

	if(!cw->scroll.crv[id].history.x){	
		    
		 cw->scroll.crv[id].history.x 
		 	= (float *)XtMalloc(sizeof(float)* cw->scroll.historysize);
		 cw->scroll.crv[id].history.y 
		 	= (float *)XtMalloc(sizeof(float)* cw->scroll.historysize);
		   if(! cw->scroll.crv[id].history.y || !cw->scroll.crv[id].history.x ) {
 	 		XtWarning("WScroll  add_history    cannot XtMalloc, history OFF");
			cw->scroll.history = 0;
		}
	 	cw->scroll.crv[id].history.size =  cw->scroll.historysize;
	}
/* even if a history buffer was existing, clear it an reset the pointers */
	if(cw->scroll.history){
	     cw->scroll.crv[id].history.firstindex = -1;
	     cw->scroll.crv[id].history.lastindex = 0;
	     memset (cw->scroll.crv[id].history.x,0,sizeof(float)* cw->scroll.crv[id].history.size);
	     memset (cw->scroll.crv[id].history.y,0,sizeof(float)* cw->scroll.crv[id].history.size);
	}
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		addhistory
 *  
 *  Input:			Scrollhistory *hist		history structure
 *			 float xy[]		abscissa and ordinate
 * 
 *  Return:			
 *
 *  Documentation:		maintains the history pointers and adds a pair of data
 *
 *
 *  History:		Sun Apr  6 15:42:22 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  addhistory   (Scrollhistory *hist, float xy[]){

	if(!hist)
		return;	/* no history, ignore */
	if(++hist->lastindex >= hist->size){
		hist->lastindex = 0;
		hist->firstindex = 1 ;
	}
	if(hist->firstindex >= 0 && ++hist->firstindex >= hist->size)
			 hist->firstindex= 0;
	hist->x[hist->lastindex] = xy[0];
	hist->y[hist->lastindex] = xy[1];
			 
}
/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		create_history
 *  
 *  Input:			XwScrollWidget  cw
 *
 *  Return:			
 *
 *  Documentation:		Creates ( or recreates) basic history structures
 *			for all allocated curve structures, history buffers
 *			are only created for activated curve structures
 *			if(size of buffer is not the same as given by resource , or if
 *			different from visible diagram pixels size, the buffere is reallocated
 *			old contents is lost;
 *
 *  History:		Sun Apr  6 09:21:54 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void  create_history 		(XwScrollWidget  cw){
   int i;
   	
   	for (i=0 ; i< cw->scroll.nactc ; i++){
		if(cw->scroll.crv[i].history.x){	/* might be changed */
		    /* clear old contents to a new allocated array  */
		     free(cw->scroll.crv[i].history.x);
		     free(cw->scroll.crv[i].history.y);
		 }

		 cw->scroll.crv[i].history.x 
			 	= (float *)XtMalloc(sizeof(float)* cw->scroll.historysize);
		 cw->scroll.crv[i].history.y 
			 	= (float *)XtMalloc(sizeof(float)* cw->scroll.historysize);
		 if(! cw->scroll.crv[i].history.y || !cw->scroll.crv[i].history.x ) {
 	 		XtWarning("WScroll  create_history    cannot XtMalloc, history OFF");
			cw->scroll.history = 0;
		}
		else{
		      cw->scroll.crv[i].history.size =  cw->scroll.historysize;
		      cw->scroll.crv[i].history.firstindex = -1;
		      cw->scroll.crv[i].history.lastindex = 0;
		      memset (cw->scroll.crv[i].history.x,0,sizeof(float) * cw->scroll.historysize);
		      memset (cw->scroll.crv[i].history.y,0,sizeof(float) * cw->scroll.historysize);
		}
	}	 
}



/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		select_action
 *  
 *  Input:			Widget w, XEvent *event
 *
 *  Return:			
 *
 *  Documentation:		action routine called at button 1 down
 *			calculation actual abscissa value and putting
 *			it into callback structure. calling eventally 
 *			user Input callback
 *
 *
 *  History:		Fri Apr 11 17:42:20 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
static void select_action(Widget w, XEvent *event){
 XwScrollWidget  cw = (XwScrollWidget) w ;
 XwScrollCallbackStruct call_value;
 int i;
    if(cw->scroll.input_callback){
    	call_value.reason = XmCR_INPUT;
    	call_value.event = event;
    	call_value.fd = -1;
   	call_value.width = cw->scroll.width;
   	call_value.height = cw->scroll.height;
   	i = (!cw->scroll.Sdir ) ? event->xbutton.x - cw->scroll.xv : event->xbutton.y - cw->scroll.yv;
 		    			
   	call_value.value = 	(cw->scroll.Sdir == XwScrollVertUp)  ?
		 (  ((float)cw->scroll.pixheight - 2*cw->scroll.height - cw->scroll.lastcop
		  + (float)(cw->scroll.offset  - i+1)) + cw->scroll.sc.ax )/ cw->scroll.sc.bx
		:
		 (cw->scroll.lastcop + i + cw->scroll.offset -  cw->scroll.sc.ax)
		        / cw->scroll.sc.bx;	
 
     XtCallCallbackList((Widget)cw,cw->scroll.input_callback, &call_value);
    } 

}
/* ================================================================================ */
/*		Public directly accessible Functions */
/* ================================================================================ */


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwCreateScroll
 *  
 *  Input:			Widget parent,
 *			 char *name,
 *			ArgList arglist,
 *			Cardinal argcount
 *
 *  Return:		 Widget	
 *
 *  Documentation:		Standeard X- creating routine
 *
 *
 *  History:		Sun Mar  2 08:33:23 CET 1997 on host:wizant
 *			
 *
 *
 ***************************************************************************
 ***************************************************************************/
 Widget XwCreateScroll( 
                        Widget parent,
                        char *name,
                        ArgList arglist,
                        Cardinal argcount) {
                      
 
   return( (Widget) XtCreateWidget(name, XwScrollWidgetClass, parent, arglist, argcount));

 }


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollvaluedisplay
 *  
 *  Input:			Widget w
 *			int ID 		id of requeseted curve
 *			int onoff		set value display 
 *
 *  Return:			
 *
 *  Documentation:		sets the per curve value display.
 *			global value display ON (via resource )is overriding
 *
 *
 *  History:		Wed Mar 19 17:10:19 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
void XwScrollvaluedisplay(Widget w, int ID , int onoff){
  XwScrollWidget cw = (XwScrollWidget) w;

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollvaluedisplay");
		return;
	}

	if(ID >= cw->scroll.nactc || ID < 0) 
		return;
	cw->scroll.crv[ID].dance = onoff;
}


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollchangecolor
 *  
 *  Input:			Widget w, int ID , Pixel color
 *
 *  Return:			
 *
 *  Documentation:		changes the colour for the selected curve
 *
 *
 *  History:		Sat Mar 22 09:33:42 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
void XwScrollchangecolor(Widget w, int ID , Pixel color){
  XwScrollWidget cw = (XwScrollWidget) w;

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollchangecolor");
		return;
	}

	if(ID >= cw->scroll.nactc || ID < 0) 
		return;
	cw->scroll.crv[ID].color = color;
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollSettext
 *  
 *  Input:			Widget w
 *			int ID 		id of requeseted curve
 *			char *text	set text to display (empty or NULL to rest)
 *
 *  Return:			
 *
 *  Documentation:		sets the per curve text display.
 *			global value text (via resource )is added
 *
 *
 *  History:		Wed Mar 19 17:10:19 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
void XwScrollSettext(Widget w, int ID , char *text){
  XwScrollWidget cw = (XwScrollWidget) w;

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollSettext");
		return;
	}

	if(ID >= cw->scroll.nactc || ID < 0) 
		return;
	if(cw->scroll.crv[ID].fixtext)
		free(cw->scroll.crv[ID].fixtext);
	if(!text ||!strlen(text) ){
		cw->scroll.crv[ID].fixtext = NULL;
		return;
	}
	cw->scroll.crv[ID].fixtext = strdup(text);
		

}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollAddcurve
 *  
 *  Input:			Widget cw
 *			unsigned long int colour
 *
 *  Return:		long int 			Curve ID	
 *
 *  Documentation:		Adds a Curve storage to the widget, returns the ID
 *
 *
 *  History:		Sun Mar  2 08:35:13 CET 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
long int XwScrollAddcurve( Widget w , unsigned long int colour){
  XwScrollWidget cw = (XwScrollWidget) w;


	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollAddcurve");
		return -1;
	}

	if( cw->scroll.nactc >= cw->scroll.ncurves) {	/* need to reallocate */
		cw->scroll.ncurves += DefaultNcurves ;
		cw->scroll.crv = (ScCurve *)XtRealloc(
			(char *)cw->scroll.crv ,cw->scroll.ncurves * sizeof(ScCurve));
		  if(!cw->scroll.crv  ) 
 	 		XtWarning("WScroll   XwScrollAddcurve   cannot XtRealloc");

	}
	cw->scroll.crv[cw->scroll.nactc].color = colour;
	cw->scroll.crv[cw->scroll.nactc].id = cw->scroll.nactc;
	if(cw->scroll.history)
		add_history(cw,cw->scroll.nactc);
	cw->scroll.nactc++;
	return (cw->scroll.nactc -1);	/* return the ID */
		
}

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollcurve
 *  
 *  Input:			Widget    w 	target scrolling widget
 *			long int ID	id of curve
 *			float xy[]		value pair (x , y )
 *			int push		if 1 pushes scrolling, 
 *			
 *  Return:			
 *
 *  Documentation:		adds a point to the actual curve(connecting to last stored piunt
 *			if either push is true, or only one curve existing
 *			forces scrolling to actual x value
 *
 *
 *  History:		Sun Mar  2 09:33:18 CET 1997 on host: wizant
 *
 *
 ***************************************************************************
 ***************************************************************************/
 void XwScrollcurve (Widget    w  , long int ID ,  float xy[] , int push){
   XwScrollWidget cw = (XwScrollWidget) w;
   Dimension ix,iy ;
   char message[100];

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollcurve");
		return;
	}


 /* first check for correct ID, error if bad */
 	if(ID >= cw->scroll.nactc){
 		sprintf(message,"XwScrollcurve:   ERROR   given ID: %ld  is not initialized",ID);
 		XtWarning(message);
 		fprintf(stderr,"XwScrollcurve:   ERROR   given ID: %ld  is not initialized",ID);
 		return;
 	} 
 /*  first check if pixmap overrun will occur, than refresh pixmap */
 #ifndef MACRO
 	check_rescroll(cw, xy[0],xy[1]);
#else
	checkrescroll(cw , xy[0] , xy[1]);
#endif 	
 	ix =  (unsigned short)xPix(cw,xy[0],xy[1]);
 	iy =  (unsigned short)yPix(cw,xy[0],xy[1]);
 	
 	if(cw->scroll.crv[ID].init++){
 		XSetForeground(XtDisplay(cw),cw->scroll.gc,cw->scroll.crv[ID].color);
      		XDrawLine(XtDisplay(w),cw->scroll.pix,cw->scroll.gc
      			,xPix(cw,cw->scroll.crv[ID].lastx,cw->scroll.crv[ID].lasty)
      			,yPix(cw,cw->scroll.crv[ID].lastx,cw->scroll.crv[ID].lasty)
      			,ix,iy);
 	}	
	cw->scroll.crv[ID].lastx = xy[0];
	cw->scroll.crv[ID].lasty = xy[1];
	if(cw->scroll.history)
		addhistory(&cw->scroll.crv[ID].history , xy);
	if(push || cw->scroll.nactc == 1){
	        cw->scroll.lastpush = xy[0];
	        copypix(cw,XtWindow(cw),(!cw->scroll.Sdir) ? ix -  cw->scroll.width :
	             (cw->scroll.Sdir == XwScrollVertDown) ? iy -  cw->scroll.height : iy);
 	}	    			
 }  
 

/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollhistory
 *  
 *  Input:			Widget    w
 *			long int ID	requested curve ID
 *			
 *  Output		 float **x		pointer to abscissa array
 *			float **y 		pointer to ordinate array
 *			 int *size		usable size of returned array
 *  Return:			
 *
 *  Documentation:		create (malloc)arrays for ordinate and abscissa and returns them
 *			together with the number of point pairs
 *			the user is responsible to free (free() ) the arrays
 *
 *
 *  History:		Sun Apr  6 16:06:24 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
 void XwScrollhistory (Widget    w  , long int ID ,  float **x , float **y , int *size){ 
    XwScrollWidget cw = (XwScrollWidget) w;
    int i=0 , idx;
    float *lx,*ly , fx;

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollhistory");
		return;
	}

	if( !cw->scroll.history || !cw->scroll.crv[ID].history.size
	    || ID >= cw->scroll.nactc)
		return;
	fx = (cw->scroll.Sdir == XwScrollVertUp)  ?
		 ( cw->scroll.pixheight  -cw->scroll.lastcop + cw->scroll.offset 
		        -cw->scroll.height - cw->scroll.sc.ax)/cw->scroll.sc.bx
		:
		(cw->scroll.lastcop + cw->scroll.offset -  cw->scroll.sc.ax)
		        / cw->scroll.sc.bx;	
 	lx = (float *)malloc(sizeof(float) * cw->scroll.crv[ID].history.size);
 	ly = (float *)malloc(sizeof(float) * cw->scroll.crv[ID].history.size);
 	 if(!lx || !ly ) 
 	 	XtWarning("WScroll   XwScrollhistory  cannot malloc");

 	idx = cw->scroll.crv[ID].history.firstindex;
 	if(idx<0)
 		 idx = 0;
 	do{
	       if(cw->scroll.crv[ID].history.x[idx] >= fx){
 		lx[i] = cw->scroll.crv[ID].history.x[idx];
 		ly[i] = cw->scroll.crv[ID].history.y[idx];
 		i++;
 	       }
 	      if(++idx >=  cw->scroll.crv[ID].history.size)
 		idx = 0; 	       
 	}while(idx != cw->scroll.crv[ID].history.lastindex);
	*size = i;	
 	*x = lx;
 	*y = ly;
 }	


/***************************************************************************
 ***************************************************************************
 *
 *  Functionname:		XwScrollGetValue
 *  
 *  Input:			Widget w
 *			 long int ID		ID of checked curve
 *			float x			abscissa value searched
 *
 *  Return:		float		found ordinate value,  0.0 in case no history
 *						999999.000000 in case abscissa value outside
 *
 *  Documentation:		searches the history array and interpolates for given
 *			x the ordinate value
 *
 *
 *  History:		Sat Apr 12 09:41:58 CEST 1997
 *
 *
 ***************************************************************************
 ***************************************************************************/
float XwScrollGetValue(Widget w , long int ID , float x){
    XwScrollWidget cw = (XwScrollWidget) w;
    int idx , idx1;
    float lx;

	if(!cw->scroll.crv || !cw->scroll.gc){	/* indication for bad widget */
		XtWarning("BAD widget id in XwScrollGetValue");
		return 0.0;
	}
	if( !cw->scroll.history || !cw->scroll.crv[ID].history.size
	    || ID >= cw->scroll.nactc)
		return 0.0;
 	idx = cw->scroll.crv[ID].history.firstindex;
 	if(idx<0)
 		 idx = 0;
 	lx = cw->scroll.crv[ID].history.x[idx];	
 	idx1 = idx; 
  	if(++idx >=  cw->scroll.crv[ID].history.size)
 		idx = 0; 	       
	
 	do{
	       if(cw->scroll.crv[ID].history.x[idx] >= x  && lx <= x){
 		return  (cw->scroll.crv[ID].history.y[idx1] 
 		     +( (cw->scroll.crv[ID].history.y[idx] - cw->scroll.crv[ID].history.y[idx1])
 		     * (x - lx)) / (cw->scroll.crv[ID].history.x[idx] - lx)) ;
 	       }
 	       idx1=idx;
 	       lx = cw->scroll.crv[ID].history.x[idx];
 	      if(++idx >=  cw->scroll.crv[ID].history.size)
 		idx = 0; 	       
 	}while(idx != cw->scroll.crv[ID].history.lastindex);
	return 999999.;

}	
#ifdef __cplusplus
 }
#endif
