
/***********************************************************************
   Widgetklasse: XwScrollWidgetClass

$Revision: 2.1 $

$Log: WScroll.h,v $
Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:22  keidel
initial motif in motion widgets


Revision 2.3  2000/07/15 10:51:39  keidel
address change

Revision 2.2  1997/10/13 15:40:33  keidel
change Horizontal/Vertical to XwScrollHorizontal/XwScrollVertical

Revision 2.1  1997/10/11 12:04:52  keidel
just added Address

Revision 2.0  1997/04/13 06:24:36  keidel
 added curve history, Input callback and retrieving routines

Revision 1.1  1997/03/30 05:19:38  keidel
Initial revision



    Copyright 1997,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel/Fax: D  08406 379
   		E-mail: wizant.keidel@01019freenet.de
                                                                 
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		20.02.1997
 ***********************************************************************/

#ifndef __wScroll_h
#define __wScroll_h

#include <Xm/Xm.h>
#include 			<WScrollP.h>
#ifdef __cplusplus
extern "C" {
#endif


#define  XwScrollVertDown 	1 	/* if set , positive is down */
#define  XwScrollVertUp  	2	/* if set , positive is up */

/* wScroll Callackstruct */
typedef struct {
  int 		reason;
  XEvent 		*event;
  int 		fd;
  float 		value;
  Dimension	width;
  Dimension	height;		/* Dimensios of visible Diagram Window */
}XwScrollCallbackStruct;


externalref WidgetClass XwScrollWidgetClass;


/* define set/getargs names  */

#define XwScrollHorizontal		0
#define XwScrollVertical		1
#define DefaultNcurves	10
#define  XwScrollVertDown 	1 	/* if set , positive is down */
#define  XwScrollVertUp  	2	/* if set , positive is up */
#define  XwScrollNoAnno	0	/* No scroll Annotation */
#define  XwScrollInAnno	1	/* scroll annotation inside visible */
#define  XwScrollLeAnno	2	/* scroll or ordinate annotation in parent left */
#define  XwScrollRiAnno	4	/* scroll or ordinate annotation in parent right  */
#define  XwScrollUpAnno	8	/* scroll or ordinate annotation in parent up */
#define  XwScrollDoAnno	16	/* scroll or ordinate annotation in parent down  */

#define  XwCScrollBorder		"ScrollBorder"
#define  XwNscrollBorder		"scrollBorder"
#define  XwCScrollCUcolor 		"ScrollCUcolor"
#define  XwNscrollCUcolor 		"scrollCUcolor"
#define  XwCScrollAnnotation 	"ScrollAnnotation"
#define  XwNscrollAnnotation 	"scrollAnnotation"
#define  XwCScrollAnnotColor 	"ScrollAnnotColor"
#define  XwNscrollAnnotColor 	"scrollAnnotColor"
#define  XwCScrollGridColor 	"ScrollGridColor"
#define  XwNscrollGridColor 	"scrollGridColor"
#define  XwNscrolldirection 	"scrolldirection"
#define  XwCScrolldirection 	"Scrolldirection"
#define  XwNscrollGridScale	"scrollGridScale"
#define  XwCScrollGridScale	"ScrollGridScale"
#define  XwNscrollScale		"scrollScale"
#define  XwCScrollScale		"ScrollScale"
#define  XwNscrollAnnotXNdec 	"scrollAnnotXNdec"
#define  XwCScrollAnnotXNdec 	"ScrollAnnotXNdec"
#define  XwNscrollAnnotYNdec 	"scrollAnnotYNdec"
#define  XwCScrollAnnotYNdec 	"ScrollAnnotYNdec"
#define  XwNscrollAnnotXNgrid	"scrollAnnotXNgrid"
#define  XwCScrollAnnotXNgrid	"ScrollAnnotXNgrid"
#define  XwNscrollAnnotYNgrid	"scrollAnnotYNgrid"
#define  XwCScrollAnnotYNgrid	"ScrollAnnotYNgrid"
#define  XwNscrollNcurves		"scrollNcurves"
#define  XwCScrollNcurves		"ScrollNcurves"
#define XwNscrollCurve		"ScrollCurve"
#define XwCScrollCurve		"ScrollCurve"
#define XwCScrollAddvalue		"scrollAddvalue"
#define XwNscrollAddvalue		"ScrollAddvalue"
#define XwCScrollAddtext		"scrollAddtext"
#define XwNscrollAddtext		"ScrollAddtext"
#define XwCScrollHistory		"scrollHistory"
#define XwNscrollHistory		"ScrollHistory"
#define XwCScrollHistorysize	"scrollHistorysize"
#define XwNscrollHistorysize	"ScrollHistorysize"

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XwCreateScroll() ;
extern long int XwScrollAddcurve();
extern void XwScrollcurve ();   
extern void XwScrollvaluedisplay();
extern void XwScrollSettext();
extern void XwScrollchangecolor();
extern void XwScrollhistory ();
extern float XwScrollGetValue();
#else

extern Widget XwCreateScroll( 
                        			Widget parent,
                        			char *name,
                        			ArgList arglist,
                        			Cardinal argcount) ;
                        
extern long int XwScrollAddcurve(
	      			Widget    scroll,
	      			unsigned long int colour);
	     
extern void XwScrollcurve 		(Widget    w  , long int ID ,  float xy[] , int push);   
extern void XwScrollvaluedisplay	(Widget cw, int ID , int onoff);
extern void XwScrollSettext		(Widget cw, int ID , char *text);
extern void XwScrollchangecolor	(Widget cw, int ID , Pixel color);
extern void XwScrollhistory 		(Widget    w  , long int ID ,  float **x , float **y , int *size);
extern float XwScrollGetValue	(Widget w , long int ID , float x);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _WScroll_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
                    
