/***********************************************************************
   Widgetklasse: XwScrollWidgetClass

$Revision: 2.2 $

$Log: WScrollP.h,v $
Revision 2.2  2001/11/19 15:22:51  keidel
corrected for duplicate define of ScScale

Revision 2.1  2001/02/25 14:57:15  keidel
Set all to stable version 2.0

Revision 1.1.1.1  2001/02/25 14:48:22  keidel
initial motif in motion widgets


Revision 2.4  2000/07/15 10:51:39  keidel
address change

Revision 2.3  1998/01/22 16:17:27  keidel
corrected destoy callback, no cbs spewcial at destroy

Revision 2.2  1997/10/11 12:04:52  keidel
just added Address

Revision 2.1  1997/06/08 06:21:13  keidel
added GC for clipping dancevals

Revision 2.0  1997/04/13 06:24:54  keidel
 added curve history, Input callback and retrieving routines

Revision 1.1  1997/03/30 05:19:38  keidel
Initial revision


   Copyright 1997,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel/Fax: D  08406 379
   		E-mail: wizant.keidel@01019freenet.de
         
                                                                  
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		20.02.1997
   
   
 ***********************************************************************/

#ifndef	_wScrollP_h
#define _wScrollP_h

#ifndef  DefaultNcurves
#define 	DefaultNcurves	10	/* allocated space for max number of curves 
				per allocation */
#endif

#include <Xm/PrimitiveP.h>
#include <Xm/DrawingAP.h>
#include <WScroll.h>

#ifdef __cplusplus
extern "C" {
#endif
/*Scrolling  class structure */


typedef struct _XwScrollClassPart
{
   XtPointer 	extension;   /* Pointer to extension record */
} XwScrollClassPart;


/* Full class record declaration for wScroll class */

typedef struct _XwScrollClassRec {
    CoreClassPart	  	core_class;
    XmPrimitiveClassPart  	primitive_class;
    XwScrollClassPart  	scroll_class;
} XwScrollClassRec, *XwScrollWidgeteClass;


externalref XwScrollClassRec xwScrollClassRec;

/*  wScroll instance record */
#ifndef _ScScale_ 
typedef struct {
	double		ax;
	double		bx;		/* scaling abscissa */
	double		ay;
	double		by;		/* scaling ordinate */
}ScScale;
#define _ScScale_ 
#endif 
typedef struct{
	int	lastindex;
	int	firstindex;
	int	size;
	float	*x;
	float	*y;
  }Scrollhistory;

typedef struct {
	long int 	id;		/* Id of curve */
	Dimension 	oldx;		/* last abscissa position in pixels */
	Dimension 	oldy;		/* last ordinate position in pixels */
	float 		lastx;
	float	 	lasty;		/* last plotted point in original values */
	unsigned 	long color;	/* colour as pixel */
	int		init;		/* while zero, no value stored */
	int		dance;		/* if TRUE draw the value */
	Scrollhistory	history;		/* history structure with history space */
	char		*fixtext;		/* if no zero && not empty draw fix text */
	
}ScCurve;


typedef struct _XwScrollPart
{
   /* public part */
 	Pixel   		background;	/* color */
   	Pixel   		gridcolor;	/* color of grid*/
   	Pixel   		anncolor;	/* color of annotation*/
	long int		Sdir;		/* Scrolling direction 0 horizontal, 1 Vertical */
 	long int		ncurves;		/* number of curves actually allocated*/
	float		*vis;		/* scaling info of visible part  array min/max  as
					 x y*/
	float		*gr;		/* base and delta    x/y*/
	int		border;		/* flag if curve should be bordered */
	long int  		anflag;		/* flag where annotation , 0 NO , 1 intern
					 (l/d) 2 left down outside 3  right / up outside */	
	int		xndecimals;	/* number of decimals for annotation */
	int		yndecimals;	/* number of decimals for annotation */
	long int		xnthgridanno;	/* annotation every nth gridline abscissa*/
	long int		ynthgridanno;	/* annotation every nth gridline ordinate*/
	unsigned long	firstcurve;	/* colour of first curve */
	int		addvalues;	/* global flag for dancing values */
	int		history;		/* flag for enabled history */
	int		historysize;	/* userdefined memory allocation */
	XmFontList 	font_list;		/* fontlist for annotation */
	XFontStruct 	*font_struct;
  	XtCallbackList 	 expose_callback;
    	XtCallbackList 	 resize_callback;
   	XtCallbackList 	 input_callback;
	char		*addtext;		/* add a global text */

/*  private part */
	ScCurve		*crv;		/* array for storing curve-definitions */
 	Dimension 	width;
 	Dimension 	height;		/* own visible dimensions, used for resize */
 	Dimension 	xv;
 	Dimension 	yv;		/* own visible dimensions if outside curve area
 					 start */
 	Dimension	annsiz;	/* size of annotation pixmap */				 
  	Dimension 	pixwidth;
	Dimension 	pixheight;	/* dimensions of pixmap */
 	long int   	nactc;		/* number of curves active */
/* caution, the following might have to be replaced by double, scaling might run out of 32 bit */	
	long int   	offset;		/* plotting offset to fit into pixmap */
	float   		lastpush;		/* last pushed x value position */
	Dimension 	lastcop;		/* last pushed pixel position in pixmap */
	float		grbase;		/* last gridbase for offset */
	float		lastannot;	/* last value of annotation, used for 
					new window */
	int		lastanncnt;
	GC		gc;		/* graphic context */
	GC		anngc;		/* graphic context annotation */
	GC		gridgc;		/* graphic context grid */
	GC		clipgc;		/* graphic context dancevals */
	Pixmap		pix;		/* pixmap for scrolling */
	Pixmap		panno;		/* pixmap for scrolling annotation */
	ScScale		sc;		/* Scaling to pixels */
	int 		exposed;
}XwScrollPart;	

/* Full instance record declaration */

typedef struct _XwScrollRec {
    CorePart	     	core;
    XmPrimitivePart  	primitive;
    XwScrollPart  		scroll;
 } XwScrollRec, *XwScrollWidget;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XwScrollP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
